=== modified file 'NEWS'
--- NEWS	2008-07-22 01:24:53 +0000
+++ NEWS	2008-08-06 20:34:24 +0000
@@ -4,14 +4,52 @@
 
 .. contents::
 
-
 IN DEVELOPMENT
 --------------
 
-  FEATURES:
-
-
-  IMPROVEMENTS:
+  CHANGES:
+
+  IMPROVEMENTS:
+
+  BUG FIXES:
+
+    * sftp transport: added missing ``FileExists`` case to
+      ``_translate_io_exception`` (Christophe Troestler, #123475)
+
+  API CHANGES:
+
+  INTERNALS:
+
+
+bzr 1.6rc1 2008-08-06
+---------------------
+
+This release candidate for bzr 1.6 solidifies the new branch stacking
+feature.  Bazaar now recommends that users upgrade all knit repositories,
+because later formats are much faster.  However, we plan to continue read/write and
+upgrade support for knit repostories for the forseeable future.  Several
+other bugs and performance issues were fixed.
+
+  CHANGES:
+
+    * Knit format repositories are deprecated and bzr will now emit
+      warnings whenever it encounters one.  Use ``bzr upgrade`` to upgrade
+      knit repositories to pack format.  (Andrew Bennetts)
+      
+  IMPROVEMENTS:
+
+    * ``bzr check`` can now be told which elements at a location it should
+      check.  (Daniel Watkins)
+
+    * Commit now supports ``--exclude`` (or ``-x``) to exclude some files
+      from the commit. (Robert Collins, #3117)
+
+    * Fetching data between repositories that have the same model but no 
+      optimised fetcher will not reserialise all the revisions, increasing
+      performance. (Robert Collins, John Arbash Meinel)
+
+    * Give a more specific error when target branch is not reachable.
+      (James Westby)
 
     * Implemented a custom ``walkdirs_utf8`` implementation for win32.
       This uses a pyrex extension to get direct access to the
@@ -21,9 +59,35 @@
       Anywhere from 2x-6x faster depending on the size of the tree (bigger
       trees, bigger benefit.) (John Arbash Meinel)
 
+    * New registry for log properties handles  and the method in 
+      LongLogFormatter to display the custom properties returned by the 
+      registered handlers. (Guillermo Gonzalez, #162469)
 
   BUG FIXES:
 
+    * Add more tests that stacking does not create deltas spanning
+      physical repository boundaries.
+      (Martin Pool, #252428)
+
+    * Better message about incompatible repositories.
+      (Martin Pool, #206258)
+
+    * ``bzr branch --stacked`` ensures the destination branch format can
+      support stacking, even if the origin does not.
+      (Martin Pool)
+
+    * ``bzr export`` no longer exports ``.bzrrules``.
+      (Ian Clatworthy)
+
+    * ``bzr serve --directory=/`` now correctly allows the whole
+      filesystem to be accessed on Windows, not just the root of the drive
+      that Python is running from.
+      (Adrian Wilkins, #240910)
+
+    * Deleting directories by hand before running ``bzr rm`` will not
+      cause subsequent errors in ``bzr st`` and ``bzr commit``.
+      (Robert Collins, #150438)
+
     * Fix a test case that was failing if encoding wasn't UTF-8.
       (John Arbash Meinel, #247585)
 
@@ -31,18 +95,60 @@
       smart server protocol to or from Windows.
       (Andrew Bennetts, #246180)
 
-
-  DOCUMENTATION:
-
-
-  TESTING:
-
+    * Fixed problem in branching from smart server.
+      (#249256, Michael Hudson, Martin Pool) 
+
+    * Handle a file turning in to a directory in TreeTransform.
+      (James Westby, #248448)
 
   API CHANGES:
 
+    * ``MutableTree.commit`` has an extra optional keywork parameter
+      ``exclude`` that will be unconditionally supplied by the command
+      line UI - plugins that add tree formats may need an update.
+      (Robert Collins)
+
+    * The API minimum version for plugin compatibility has been raised to
+      1.6 - there are significant changes throughout the code base.
+      (Robert Collins)
+
+    * The generic fetch code now uses three attributes on Repository objects
+      to control fetch. The streams requested are controlled via :
+      ``_fetch_order`` and ``_fetch_uses_deltas``. Setting these
+      appropriately allows different repository implementations to recieve
+      data in their optimial form. If the ``_fetch_reconcile`` is set then
+      a reconcile operation is triggered at the end of the fetch.
+      (Robert Collins)
+
+    * The ``put_on_disk`` and ``get_tar_item`` methods in
+      ``InventoryEntry`` were deprecated. (Ian Clatworthy)
+
+    * ``Repository.is_shared`` doesn't take a read lock. It didn't
+      need one in the first place (nobody cached the value, and
+      ``RemoteRepository`` wasn't taking one either). This saves a round
+      trip when probing Pack repositories, as they read the ``pack-names``
+      file when locked. And during probe, locking the repo isn't very
+      useful. (John Arbash Meinel)
 
   INTERNALS:
 
+    * ``bzrlib.branchbuilder.BranchBuilder`` is now much more capable of
+      putting together a real history without having to create a full
+      WorkingTree. It is recommended that tests that are not directly
+      testing the WorkingTree use BranchBuilder instead.  See
+      ``BranchBuilder.build_snapshot`` or
+      ``TestCaseWithMemoryTree.make_branch_builder``.  (John Arbash Meinel)
+
+    * ``bzrlib.builtins.internal_tree_files`` broken into two giving a new
+      helper ``safe_relpath_files`` - used by the new ``exclude``
+      parameter to commit. (Robert Collins)
+
+    * Make it easier to introduce new WorkingTree formats.
+      (Ian Clatworthy)
+
+    * The code for exporting trees was refactored not to use the
+      deprecated ``InventoryEntry`` methods. (Ian Clatworthy)
+
     * RuleSearchers return () instead of [] now when there are no matches.
       (Ian Clatworthy)
 
@@ -50,6 +156,12 @@
 bzr 1.6beta3 2008-07-17
 -----------------------
 
+This release adds a new 'stacked branches' feature allowing branches to
+share storage without being in the same repository or on the same machine.
+(See the user guide for more details.)  It also adds a new hook, improved
+weaves, aliases for related locations, faster bzr+ssh push, and several
+bug fixes.
+
   FEATURES:
 
     * New ``pre_change_branch_tip`` hook that is called before the
@@ -66,7 +178,9 @@
     * Sites may suggest a branch to stack new branches on.  (Aaron Bentley)
 
     * Stacked branches are now supported. See ``bzr help branch`` and 
-      ``bzr help push``. (Robert Collins)
+      ``bzr help push``.  Branches must be in the ``development1`` format
+      to stack, though the stacked-on branch can be of any format. 
+      (Robert Collins)
 
   IMPROVEMENTS:
 
@@ -90,10 +204,6 @@
       revision info directly.  This makes operations like push
       faster.  The new request method name is
       ``Branch.set_last_revision_ex``.  (Andrew Bennetts)
-      
-    * New registry for log properties handles  and the method in 
-      LongLogFormatter to display the custom properties returned by the 
-      registered handlers. (Guillermo Gonzalez, #162469)
 
   BUG FIXES:
 
@@ -110,11 +220,6 @@
       requires a branch to be present.
       (Daniel Watkins, #64783)
 
-    * ``bzr serve --directory=/`` now correctly allows the whole
-      filesystem to be accessed on Windows, not just the root of the drive
-      that Python is running from.
-      (Adrian Wilkins, #240910)
-
     * Clearer message about how to set the PYTHONPATH if bzrlib can't be
       loaded. 
       (Martin Pool, #205230)
@@ -124,9 +229,6 @@
       still in ``.bzr.log`` and can be shown with ``-Derror``.
       (Martin Pool, #240161)
 
-    * Fixed problem in branching from smart server.
-      (#249256, Michael Hudson, Martin Pool) 
-
     * Fetch from a stacked branch copies all required data.
       (Aaron Bentley, #248506)
 
@@ -156,9 +258,6 @@
     * Set locale from environment for third party libs.
       (Martin von Gagern, #128496)
 
-    * Handle a file turning in to a directory in TreeTransform.
-      (James Westby, #248448)
-
   DOCUMENTATION:
 
     * Added *Using stacked branches* to the User Guide.

=== modified file 'bzr'
--- bzr	2008-07-03 10:44:34 +0000
+++ bzr	2008-08-06 08:23:43 +0000
@@ -22,7 +22,7 @@
 import sys
 
 # update this on each release
-_script_version = (1, 6, 0)
+_script_version = (1, 7, 0)
 
 if __doc__ is None:
     print "bzr does not support python -OO."

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2008-07-17 19:11:37 +0000
+++ bzrlib/__init__.py	2008-08-06 08:23:43 +0000
@@ -41,11 +41,11 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (1, 6, 0, 'beta', 4)
-
-
-# API compatibility version: bzrlib is currently API compatible with 0.18.
-api_minimum_version = (0, 18, 0)
+version_info = (1, 7, 0, 'dev', 0)
+
+
+# API compatibility version: bzrlib is currently API compatible with 1.6.
+api_minimum_version = (1, 6, 0)
 
 def _format_version_tuple(version_info):
     """Turn a version number 3-tuple or 5-tuple into a short string.

=== modified file 'bzrlib/_dirstate_helpers_py.py'
--- bzrlib/_dirstate_helpers_py.py	2008-05-08 04:12:06 +0000
+++ bzrlib/_dirstate_helpers_py.py	2008-07-28 07:17:25 +0000
@@ -201,7 +201,7 @@
     # Remove the last blank entry
     trailing = fields.pop()
     if trailing != '':
-        raise AssertionError("dirstate line %r has trailing garbage: %r" 
+        raise AssertionError("dirstate file has trailing garbage: %r"
             % (trailing,))
     # consider turning fields into a tuple.
 

=== modified file 'bzrlib/_patiencediff_py.py'
--- bzrlib/_patiencediff_py.py	2008-05-08 04:12:06 +0000
+++ bzrlib/_patiencediff_py.py	2008-07-28 05:09:54 +0000
@@ -176,7 +176,7 @@
     length = 0
     for i_a, i_b in matches:
         if (start_a is not None
-            and (i_a == start_a + length) 
+            and (i_a == start_a + length)
             and (i_b == start_b + length)):
             length += 1
         else:

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2008-07-16 07:30:18 +0000
+++ bzrlib/branch.py	2008-07-25 15:19:45 +0000
@@ -15,6 +15,8 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
+import sys
+
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from itertools import chain
@@ -533,8 +535,6 @@
         finally:
             other.unlock()
 
-
-
     def revision_id_to_revno(self, revision_id):
         """Given a revision id, return its revno"""
         if _mod_revision.is_null(revision_id):
@@ -899,7 +899,7 @@
         elif relation == 'a_descends_from_b':
             return False
         else:
-            raise AssertionError("invalid heads: %r" % heads)
+            raise AssertionError("invalid relation: %r" % (relation,))
 
     def _revision_relations(self, revision_a, revision_b, graph):
         """Determine the relationship between two revisions.
@@ -915,7 +915,7 @@
         elif heads == set([revision_a]):
             return 'a_descends_from_b'
         else:
-            raise AssertionError("invalid heads: %r" % heads)
+            raise AssertionError("invalid heads: %r" % (heads,))
 
 
 class BranchFormat(object):
@@ -1061,6 +1061,10 @@
     def set_default_format(klass, format):
         klass._default_format = format
 
+    def supports_stacking(self):
+        """True if this format records a stacked-on branch."""
+        return False
+
     @classmethod
     def unregister_format(klass, format):
         del klass._formats[format.get_format_string()]
@@ -1368,6 +1372,9 @@
         self._matchingbzrdir.repository_format = \
             RepositoryFormatPackDevelopment1Subtree()
 
+    def supports_stacking(self):
+        return True
+
 
 class BranchReferenceFormat(BranchFormat):
     """Bzr branch reference format.
@@ -1579,11 +1586,22 @@
         check_not_reserved_id = _mod_revision.check_not_reserved_id
         for rev_id in rev_history:
             check_not_reserved_id(rev_id)
+        if Branch.hooks['post_change_branch_tip']:
+            # Don't calculate the last_revision_info() if there are no hooks
+            # that will use it.
+            old_revno, old_revid = self.last_revision_info()
+        if len(rev_history) == 0:
+            revid = _mod_revision.NULL_REVISION
+        else:
+            revid = rev_history[-1]
+        self._run_pre_change_branch_tip_hooks(len(rev_history), revid)
         self._write_revision_history(rev_history)
         self._clear_cached_state()
         self._cache_revision_history(rev_history)
         for hook in Branch.hooks['set_rh']:
             hook(self, rev_history)
+        if Branch.hooks['post_change_branch_tip']:
+            self._run_post_change_branch_tip_hooks(old_revno, old_revid)
 
     def _run_pre_change_branch_tip_hooks(self, new_revno, new_revid):
         """Run the pre_change_branch_tip hooks."""
@@ -1594,7 +1612,15 @@
         params = ChangeBranchTipParams(
             self, old_revno, new_revno, old_revid, new_revid)
         for hook in hooks:
-            hook(params)
+            try:
+                hook(params)
+            except errors.TipChangeRejected:
+                raise
+            except Exception:
+                exc_info = sys.exc_info()
+                hook_name = Branch.hooks.get_hook_name(hook)
+                raise errors.HookFailed(
+                    'pre_change_branch_tip', hook_name, exc_info)
  
     def _run_post_change_branch_tip_hooks(self, old_revno, old_revid):
         """Run the post_change_branch_tip hooks."""
@@ -1620,16 +1646,13 @@
         be permitted.
         """
         revision_id = _mod_revision.ensure_null(revision_id)
-        old_revno, old_revid = self.last_revision_info()
         # this old format stores the full history, but this api doesn't
         # provide it, so we must generate, and might as well check it's
         # correct
         history = self._lefthand_history(revision_id)
         if len(history) != revno:
             raise AssertionError('%d != %d' % (len(history), revno))
-        self._run_pre_change_branch_tip_hooks(revno, revision_id)
         self.set_revision_history(history)
-        self._run_post_change_branch_tip_hooks(old_revno, old_revid)
 
     def _gen_revision_history(self):
         history = self._transport.get_bytes('revision-history').split('\n')

=== modified file 'bzrlib/branchbuilder.py'
--- bzrlib/branchbuilder.py	2007-04-27 06:16:29 +0000
+++ bzrlib/branchbuilder.py	2008-07-29 16:16:36 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,12 +26,24 @@
     BranchBuilder on the transport you want your branch on, and then call
     appropriate build_ methods on it to get the shape of history you want.
 
+    This is meant as a helper for the test suite, not as a general class for
+    real data.
+
     For instance:
       builder = BranchBuilder(self.get_transport().clone('relpath'))
-      builder.build_commit()
-      builder.build_commit()
-      builder.build_commit()
+      builder.start_series()
+      builder.build_snapshot('rev-id', [],
+        [('add', ('filename', 'f-id', 'file', 'content\n'))])
+      builder.build_snapshot('rev2-id', ['rev-id'],
+        [('modify', ('f-id', 'new-content\n'))])
+      builder.finish_series()
       branch = builder.get_branch()
+
+    :ivar _tree: This is a private member which is not meant to be modified by
+        users of this class. While a 'series' is in progress, it should hold a
+        MemoryTree with the contents of the last commit (ready to be modified
+        by the next build_snapshot command) with a held write lock. Outside of
+        a series in progress, it should be None.
     """
 
     def __init__(self, transport, format=None):
@@ -40,15 +52,18 @@
         :param transport: The transport the branch should be created on.
             If the path of the transport does not exist but its parent does
             it will be created.
-        :param format: The name of a format in the bzrdir format registry
-            for the branch to be built.
+        :param format: Either a BzrDirFormat, or the name of a format in the
+            bzrdir format registry for the branch to be built.
         """
         if not transport.has('.'):
             transport.mkdir('.')
         if format is None:
             format = 'default'
+        if isinstance(format, str):
+            format = bzrdir.format_registry.make_bzrdir(format)
         self._branch = bzrdir.BzrDir.create_branch_convenience(transport.base,
-            format=bzrdir.format_registry.make_bzrdir(format))
+            format=format, force_new_tree=False)
+        self._tree = None
 
     def build_commit(self):
         """Build a commit on the branch."""
@@ -60,6 +75,128 @@
         finally:
             tree.unlock()
 
+    def _move_branch_pointer(self, new_revision_id):
+        """Point self._branch to a different revision id."""
+        self._branch.lock_write()
+        try:
+            # We don't seem to have a simple set_last_revision(), so we
+            # implement it here.
+            cur_revno, cur_revision_id = self._branch.last_revision_info()
+            g = self._branch.repository.get_graph()
+            new_revno = g.find_distance_to_null(new_revision_id,
+                                                [(cur_revision_id, cur_revno)])
+            self._branch.set_last_revision_info(new_revno, new_revision_id)
+        finally:
+            self._branch.unlock()
+        if self._tree is not None:
+            # We are currently processing a series, but when switching branch
+            # pointers, it is easiest to just create a new memory tree.
+            # That way we are sure to have the right files-on-disk
+            # We are cheating a little bit here, and locking the new tree
+            # before the old tree is unlocked. But that way the branch stays
+            # locked throughout.
+            new_tree = memorytree.MemoryTree.create_on_branch(self._branch)
+            new_tree.lock_write()
+            self._tree.unlock()
+            self._tree = new_tree
+
+    def start_series(self):
+        """We will be creating a series of commits.
+
+        This allows us to hold open the locks while we are processing.
+
+        Make sure to call 'finish_series' when you are done.
+        """
+        if self._tree is not None:
+            raise AssertionError('You cannot start a new series while a'
+                                 ' series is already going.')
+        self._tree = memorytree.MemoryTree.create_on_branch(self._branch)
+        self._tree.lock_write()
+
+    def finish_series(self):
+        """Call this after start_series to unlock the various objects."""
+        self._tree.unlock()
+        self._tree = None
+
+    def build_snapshot(self, revision_id, parent_ids, actions,
+                       message=None):
+        """Build a commit, shaped in a specific way.
+
+        :param revision_id: The handle for the new commit, can be None
+        :param parent_ids: A list of parent_ids to use for the commit.
+            It can be None, which indicates to use the last commit.
+        :param actions: A list of actions to perform. Supported actions are:
+            ('add', ('path', 'file-id', 'kind', 'content' or None))
+            ('modify', ('file-id', 'new-content'))
+            ('unversion', 'file-id')
+            # not supported yet: ('rename', ('orig-path', 'new-path'))
+        :param message: An optional commit message, if not supplied, a default
+            commit message will be written.
+        :return: The revision_id of the new commit
+        """
+        if parent_ids is not None:
+            base_id = parent_ids[0]
+            if base_id != self._branch.last_revision():
+                self._move_branch_pointer(base_id)
+
+        if self._tree is not None:
+            tree = self._tree
+        else:
+            tree = memorytree.MemoryTree.create_on_branch(self._branch)
+        tree.lock_write()
+        try:
+            if parent_ids is not None:
+                tree.set_parent_ids(parent_ids)
+            # Unfortunately, MemoryTree.add(directory) just creates an
+            # inventory entry. And the only public function to create a
+            # directory is MemoryTree.mkdir() which creates the directory, but
+            # also always adds it. So we have to use a multi-pass setup.
+            to_add_directories = []
+            to_add_files = []
+            to_add_file_ids = []
+            to_add_kinds = []
+            new_contents = {}
+            to_unversion_ids = []
+            # TODO: MemoryTree doesn't support rename() or
+            #       apply_inventory_delta, so we'll postpone allowing renames
+            #       for now
+            # to_rename = []
+            for action, info in actions:
+                if action == 'add':
+                    path, file_id, kind, content = info
+                    if kind == 'directory':
+                        to_add_directories.append((path, file_id))
+                    else:
+                        to_add_files.append(path)
+                        to_add_file_ids.append(file_id)
+                        to_add_kinds.append(kind)
+                        if content is not None:
+                            new_contents[file_id] = content
+                elif action == 'modify':
+                    file_id, content = info
+                    new_contents[file_id] = content
+                elif action == 'unversion':
+                    to_unversion_ids.append(info)
+                else:
+                    raise ValueError('Unknown build action: "%s"' % (action,))
+            if to_unversion_ids:
+                tree.unversion(to_unversion_ids)
+            for path, file_id in to_add_directories:
+                if path == '':
+                    # Special case, because the path already exists
+                    tree.add([path], [file_id], ['directory'])
+                else:
+                    tree.mkdir(path, file_id)
+            tree.add(to_add_files, to_add_file_ids, to_add_kinds)
+            for file_id, content in new_contents.iteritems():
+                tree.put_file_bytes_non_atomic(file_id, content)
+
+            if message is None:
+                message = u'commit %d' % (self._branch.revno() + 1,)
+            return tree.commit(message, rev_id=revision_id)
+        finally:
+            tree.unlock()
+
     def get_branch(self):
         """Return the branch created by the builder."""
         return self._branch

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2008-07-18 01:58:54 +0000
+++ bzrlib/builtins.py	2008-08-06 21:57:33 +0000
@@ -87,13 +87,27 @@
     if file_list is None or len(file_list) == 0:
         return WorkingTree.open_containing(default_branch)[0], file_list
     tree = WorkingTree.open_containing(osutils.realpath(file_list[0]))[0]
+    return tree, safe_relpath_files(tree, file_list)
+
+
+def safe_relpath_files(tree, file_list):
+    """Convert file_list into a list of relpaths in tree.
+
+    :param tree: A tree to operate on.
+    :param file_list: A list of user provided paths or None.
+    :return: A list of relative paths.
+    :raises errors.PathNotChild: When a provided path is in a different tree
+        than tree.
+    """
+    if file_list is None:
+        return None
     new_list = []
     for filename in file_list:
         try:
             new_list.append(tree.relpath(osutils.dereference_path(filename)))
         except errors.PathNotChild:
             raise errors.FileInWrongBranch(tree.branch, filename)
-    return tree, new_list
+    return new_list
 
 
 # TODO: Make sure no commands unconditionally use the working directory as a
@@ -2106,6 +2120,12 @@
     committed.  If a directory is specified then the directory and everything 
     within it is committed.
 
+    When excludes are given, they take precedence over selected files.
+    For example, too commit only changes within foo, but not changes within
+    foo/bar::
+
+      bzr commit foo -x foo/bar
+
     If author of the change is not the same person as the committer, you can
     specify the author's name using the --author option. The name should be
     in the same format as a committer-id, e.g. "John Doe <jdoe@example.com>".
@@ -2141,6 +2161,8 @@
     _see_also = ['bugs', 'uncommit']
     takes_args = ['selected*']
     takes_options = [
+            ListOption('exclude', type=str, short_name='x',
+                help="Do not consider changes made to a given path."),
             Option('message', type=unicode,
                    short_name='m',
                    help="Description of the new revision."),
@@ -2195,7 +2217,7 @@
 
     def run(self, message=None, file=None, verbose=False, selected_list=None,
             unchanged=False, strict=False, local=False, fixes=None,
-            author=None, show_diff=False):
+            author=None, show_diff=False, exclude=None):
         from bzrlib.errors import (
             PointlessCommit,
             ConflictsInTree,
@@ -2245,7 +2267,7 @@
                 raise errors.BzrCommandError(
                     "please specify either --message or --file")
             if file:
-                my_message = codecs.open(file, 'rt', 
+                my_message = codecs.open(file, 'rt',
                                          bzrlib.user_encoding).read()
             if my_message == "":
                 raise errors.BzrCommandError("empty commit message specified")
@@ -2256,7 +2278,8 @@
                         specific_files=selected_list,
                         allow_pointless=unchanged, strict=strict, local=local,
                         reporter=None, verbose=verbose, revprops=properties,
-                        author=author)
+                        author=author,
+                        exclude=safe_relpath_files(tree, exclude))
         except PointlessCommit:
             # FIXME: This should really happen before the file is read in;
             # perhaps prepare the commit; get the message; then actually commit
@@ -2277,8 +2300,7 @@
 
 
 class cmd_check(Command):
-    """Validate working tree structure, branch consistency and repository
-    history.
+    """Validate working tree structure, branch consistency and repository history.
 
     This command checks various invariants about branch and repository storage
     to detect data corruption or bzr bugs.
@@ -2299,17 +2321,43 @@
             in the checked revisions.  Texts can be repeated when their file
             entries are modified, but the file contents are not.  It does not
             indicate a problem.
+
+    If no restrictions are specified, all Bazaar data that is found at the given
+    location will be checked.
+
+    :Examples:
+
+        Check the tree and branch at 'foo'::
+
+            bzr check --tree --branch foo
+
+        Check only the repository at 'bar'::
+
+            bzr check --repo bar
+
+        Check everything at 'baz'::
+
+            bzr check baz
     """
 
     _see_also = ['reconcile']
     takes_args = ['path?']
-    takes_options = ['verbose']
+    takes_options = ['verbose',
+                     Option('branch', help="Check the branch related to the"
+                                           " current directory."),
+                     Option('repo', help="Check the repository related to the"
+                                         " current directory."),
+                     Option('tree', help="Check the working tree related to"
+                                         " the current directory.")]
 
-    def run(self, path=None, verbose=False):
+    def run(self, path=None, verbose=False, branch=False, repo=False,
+            tree=False):
         from bzrlib.check import check_dwim
         if path is None:
             path = '.'
-        check_dwim(path, verbose)
+        if not branch and not repo and not tree:
+            branch = repo = tree = True
+        check_dwim(path, verbose, do_branch=branch, do_repo=repo, do_tree=tree)
 
 
 class cmd_upgrade(Command):
@@ -4116,7 +4164,7 @@
                 raise errors.BzrCommandError('No submit branch known or'
                                              ' specified')
             if remembered_submit_branch:
-                note('Using saved location: %s', submit_branch)
+                note('Using saved location "%s" to determine what changes to submit.', submit_branch)
 
             if mail_to is None:
                 submit_config = Branch.open(submit_branch).get_config()
@@ -4267,6 +4315,9 @@
 
     It is an error to give a tag name that already exists unless you pass 
     --force, in which case the tag is moved to point to the new revision.
+
+    To rename a tag (change the name but keep it on the same revsion), run ``bzr
+    tag new-name -r tag:old-name`` and then ``bzr tag --delete oldname``.
     """
 
     _see_also = ['commit', 'tags']
@@ -4344,6 +4395,8 @@
             ):
         branch, relpath = Branch.open_containing(directory)
         tags = branch.tags.get_tag_dict().items()
+        if not tags:
+            return
         if sort == 'alpha':
             tags.sort()
         elif sort == 'time':

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2008-07-24 05:19:40 +0000
+++ bzrlib/bzrdir.py	2008-07-31 08:35:25 +0000
@@ -380,6 +380,7 @@
         repository used instead.
 
         If stack_on is supplied, will not seek a containing shared repo.
+
         :param force_new_repo: If True, require a new repository to be created.
         :param stack_on: If supplied, the location to stack on.  If not
             supplied, a default_stack_on location may be used.
@@ -978,7 +979,10 @@
             return False
 
     def _cloning_metadir(self):
-        """Produce a metadir suitable for cloning with."""
+        """Produce a metadir suitable for cloning with.
+        
+        :returns: (destination_bzrdir_format, source_repository)
+        """
         result_format = self._format.__class__()
         try:
             try:
@@ -1013,6 +1017,10 @@
         These operations may produce workingtrees (yes, even though they're
         "cloning" something that doesn't have a tree), so a viable workingtree
         format must be selected.
+
+        :returns: a BzrDirFormat with all component formats either set
+            appropriately or set to None if that component should not be 
+            created.
         """
         format, repository = self._cloning_metadir()
         if format._workingtree_format is None:
@@ -1073,15 +1081,39 @@
             force_new_repo, stacked_branch_url, require_stacking=stacked)
         result_repo = repository_policy.acquire_repository()
         if source_repository is not None:
+            # XXX: Isn't this redundant with the copy_content_into used below
+            # after creating the branch? -- mbp 20080724
             result_repo.fetch(source_repository, revision_id=revision_id)
 
         # Create/update the result branch
-        if source_branch is not None:
-            result_branch = source_branch.sprout(result,
-                revision_id=revision_id)
-        else:
+        format_forced = False
+        if ((stacked 
+             or repository_policy._require_stacking 
+             or repository_policy._stack_on)
+            and not result._format.get_branch_format().supports_stacking()):
+            # We need to make a stacked branch, but the default format for the
+            # target doesn't support stacking.  So force a branch that *can*
+            # support stacking. 
+            from bzrlib.branch import BzrBranchFormat7
+            format = BzrBranchFormat7()
+            result_branch = format.initialize(result)
+            mutter("using %r for stacking" % (format,))
+            format_forced = True
+        elif source_branch is None:
+            # this is for sprouting a bzrdir without a branch; is that
+            # actually useful?
             result_branch = result.create_branch()
+        else:
+            result_branch = source_branch.sprout(
+                result, revision_id=revision_id)
+        mutter("created new branch %r" % (result_branch,))
         repository_policy.configure_branch(result_branch)
+        if source_branch is not None and format_forced:
+            # XXX: this duplicates Branch.sprout(); it probably belongs on an
+            # InterBranch method? -- mbp 20080724
+            source_branch.copy_content_into(result_branch,
+                 revision_id=revision_id)
+            result_branch.set_parent(self.root_transport.base)
 
         # Create/update the result working tree
         if isinstance(target_transport, LocalTransport) and (
@@ -2859,7 +2891,29 @@
 
         Creates the desired repository in the bzrdir we already have.
         """
-        repository = self._bzrdir.create_repository(shared=shared)
+        if self._stack_on or self._require_stacking:
+            # we may be coming from a format that doesn't support stacking,
+            # but we require it in the destination, so force creation of a new
+            # one here.
+            #
+            # TODO: perhaps this should be treated as a distinct repository
+            # acquisition policy?
+            repository_format = self._bzrdir._format.repository_format
+            if not repository_format.supports_external_lookups:
+                # should possibly be controlled by the registry rather than
+                # hardcoded here.
+                from bzrlib.repofmt import pack_repo
+                if repository_format.rich_root_data:
+                    repository_format = \
+                        pack_repo.RepositoryFormatKnitPack5RichRoot()
+                else:
+                    repository_format = pack_repo.RepositoryFormatKnitPack5()
+                note("using %r for stacking" % (repository_format,))
+            repository = repository_format.initialize(self._bzrdir,
+                shared=shared)
+        else:
+            # let bzrdir choose
+            repository = self._bzrdir.create_repository(shared=shared)
         self._add_fallback(repository)
         if make_working_trees is not None:
             repository.set_make_working_trees(make_working_trees)

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2008-07-14 07:47:45 +0000
+++ bzrlib/check.py	2008-07-28 06:53:44 +0000
@@ -269,13 +269,20 @@
     branch_result.report_results(verbose)
 
 
-def check_dwim(path, verbose):
-    tree, branch, repo, relpath = BzrDir.open_containing_tree_branch_or_repository(path)
+def check_dwim(path, verbose, do_branch=False, do_repo=False, do_tree=False):
+    try:
+        tree, branch, repo, relpath = \
+                        BzrDir.open_containing_tree_branch_or_repository(path)
+    except errors.NotBranchError:
+        tree = branch = repo = None
 
-    if tree is not None:
-        note("Checking working tree at '%s'." 
-             % (tree.bzrdir.root_transport.base,))
-        tree._check()
+    if do_tree:
+        if tree is not None:
+            note("Checking working tree at '%s'." 
+                 % (tree.bzrdir.root_transport.base,))
+            tree._check()
+        else:
+            log_error("No working tree found at specified location.")
 
     if branch is not None:
         # We have a branch
@@ -289,13 +296,23 @@
     if repo is not None:
         repo.lock_read()
         try:
-            note("Checking repository at '%s'."
-                 % (repo.bzrdir.root_transport.base,))
-            result = repo.check()
-            result.report_results(verbose)
-            for branch in branches:
-                note("Checking branch at '%s'."
-                     % (branch.bzrdir.root_transport.base,))
-                check_branch(branch, verbose)
+            if do_repo:
+                note("Checking repository at '%s'."
+                     % (repo.bzrdir.root_transport.base,))
+                result = repo.check()
+                result.report_results(verbose)
+            if do_branch:
+                if branches == []:
+                    log_error("No branch found at specified location.")
+                else:
+                    for branch in branches:
+                        note("Checking branch at '%s'."
+                             % (branch.bzrdir.root_transport.base,))
+                        check_branch(branch, verbose)
         finally:
             repo.unlock()
+    else:
+        if do_branch:
+            log_error("No branch found at specified location.")
+        if do_repo:
+            log_error("No repository found at specified location.")

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2008-04-24 07:22:53 +0000
+++ bzrlib/commit.py	2008-08-05 04:10:43 +0000
@@ -204,7 +204,8 @@
                reporter=None,
                config=None,
                message_callback=None,
-               recursive='down'):
+               recursive='down',
+               exclude=None):
         """Commit working copy as a new revision.
 
         :param message: the commit message (it or message_callback is required)
@@ -232,6 +233,9 @@
         :param verbose: if True and the reporter is not None, report everything
         :param recursive: If set to 'down', commit in any subtrees that have
             pending changes of any sort during this commit.
+        :param exclude: None or a list of relative paths to exclude from the
+            commit. Pending changes to excluded files will be ignored by the
+            commit. 
         """
         mutter('preparing to commit')
 
@@ -255,6 +259,11 @@
         self.bound_branch = None
         self.any_entries_changed = False
         self.any_entries_deleted = False
+        if exclude is not None:
+            self.exclude = sorted(
+                minimum_path_selection(exclude))
+        else:
+            self.exclude = []
         self.local = local
         self.master_branch = None
         self.master_locked = False
@@ -329,12 +338,15 @@
             self.pb.show_count = True
             self.pb.show_bar = True
 
+            self.basis_inv = self.basis_tree.inventory
+            self._gather_parents()
             # After a merge, a selected file commit is not supported.
             # See 'bzr help merge' for an explanation as to why.
-            self.basis_inv = self.basis_tree.inventory
-            self._gather_parents()
             if len(self.parents) > 1 and self.specific_files:
                 raise errors.CannotCommitSelectedFileMerge(self.specific_files)
+            # Excludes are a form of selected file commit.
+            if len(self.parents) > 1 and self.exclude:
+                raise errors.CannotCommitSelectedFileMerge(self.exclude)
 
             # Collect the changes
             self._set_progress_stage("Collecting changes",
@@ -648,28 +660,30 @@
         # in bugs like #46635.  Any reason not to use/enhance Tree.changes_from?
         # ADHB 11-07-2006
 
-        specific_files = self.specific_files
+        exclude = self.exclude
+        specific_files = self.specific_files or []
         mutter("Selecting files for commit with filter %s", specific_files)
 
         # Build the new inventory
-        self._populate_from_inventory(specific_files)
+        self._populate_from_inventory()
 
         # If specific files are selected, then all un-selected files must be
         # recorded in their previous state. For more details, see
         # https://lists.ubuntu.com/archives/bazaar/2007q3/028476.html.
-        if specific_files:
+        if specific_files or exclude:
             for path, old_ie in self.basis_inv.iter_entries():
                 if old_ie.file_id in self.builder.new_inventory:
                     # already added - skip.
                     continue
-                if is_inside_any(specific_files, path):
-                    # was inside the selected path, if not present it has been
-                    # deleted so skip.
+                if (is_inside_any(specific_files, path)
+                    and not is_inside_any(exclude, path)):
+                    # was inside the selected path, and not excluded - if not
+                    # present it has been deleted so skip.
                     continue
+                # From here down it was either not selected, or was excluded:
                 if old_ie.kind == 'directory':
                     self._next_progress_entry()
-                # not in final inv yet, was not in the selected files, so is an
-                # entry to be preserved unaltered.
+                # We preserve the entry unaltered.
                 ie = old_ie.copy()
                 # Note: specific file commits after a merge are currently
                 # prohibited. This test is for sanity/safety in case it's
@@ -697,13 +711,15 @@
                 self._basis_delta.append((path, None, file_id, None))
                 self.reporter.deleted(path)
 
-    def _populate_from_inventory(self, specific_files):
+    def _populate_from_inventory(self):
         """Populate the CommitBuilder by walking the working tree inventory."""
         if self.strict:
             # raise an exception as soon as we find a single unknown.
             for unknown in self.work_tree.unknowns():
                 raise StrictCommitFailed()
-               
+        
+        specific_files = self.specific_files
+        exclude = self.exclude
         report_changes = self.reporter.is_verbose()
         deleted_ids = []
         # A tree of paths that have been deleted. E.g. if foo/bar has been
@@ -712,6 +728,8 @@
         # XXX: Note that entries may have the wrong kind because the entry does
         # not reflect the status on disk.
         work_inv = self.work_tree.inventory
+        # NB: entries will include entries within the excluded ids/paths
+        # because iter_entries_by_dir has no 'exclude' facility today.
         entries = work_inv.iter_entries_by_dir(
             specific_file_ids=self.specific_file_ids, yield_parents=True)
         for path, existing_ie in entries:
@@ -739,6 +757,10 @@
                 if deleted_dict is not None:
                     # the path has a deleted parent, do not add it.
                     continue
+            if exclude and is_inside_any(exclude, path):
+                # Skip excluded paths. Excluded paths are processed by
+                # _update_builder_with_changes.
+                continue
             content_summary = self.work_tree.path_content_summary(path)
             # Note that when a filter of specific files is given, we must only
             # skip/record deleted files matching that filter.

=== modified file 'bzrlib/dirstate.py'
--- bzrlib/dirstate.py	2008-06-05 21:47:39 +0000
+++ bzrlib/dirstate.py	2008-07-30 08:55:10 +0000
@@ -1199,6 +1199,7 @@
                     fingerprint = ''
                 insertions[file_id] = (key, minikind, inv_entry.executable,
                                        fingerprint, new_path)
+            # Transform moves into delete+add pairs
             if None not in (old_path, new_path):
                 for child in self._iter_child_entries(0, old_path):
                     if child[0][2] in insertions or child[0][2] in removals:
@@ -1228,6 +1229,21 @@
                 self._get_block_entry_index(dirname, basename, 0)
             entry = self._dirblocks[block_i][1][entry_i]
             self._make_absent(entry)
+            # See if we have a malformed delta: deleting a directory must not
+            # leave crud behind. This increases the number of bisects needed
+            # substantially, but deletion or renames of large numbers of paths
+            # is rare enough it shouldn't be an issue (famous last words?) RBC
+            # 20080730.
+            block_i, entry_i, d_present, f_present = \
+                self._get_block_entry_index(path, '', 0)
+            if d_present:
+                # The dir block is still present in the dirstate; this could
+                # be due to it being in a parent tree, or a corrupt delta.
+                for child_entry in self._dirblocks[block_i][1]:
+                    if child_entry[1][0][0] not in ('r', 'a'):
+                        raise errors.InconsistentDelta(path, entry[0][2],
+                            "The file id was deleted but its children were "
+                            "not deleted.")
 
     def _apply_insertions(self, adds):
         for key, minikind, executable, fingerprint, path_utf8 in sorted(adds):

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2008-07-23 08:10:03 +0000
+++ bzrlib/errors.py	2008-08-03 00:36:46 +0000
@@ -93,11 +93,11 @@
             for key, value in kwds.items():
                 setattr(self, key, value)
 
-    def __str__(self):
+    def _format(self):
         s = getattr(self, '_preformatted_string', None)
         if s is not None:
-            # contains a preformatted message; must be cast to plain str
-            return str(s)
+            # contains a preformatted message
+            return s
         try:
             fmt = self._get_format_string()
             if fmt:
@@ -108,8 +108,6 @@
                 s = fmt % d
                 # __str__() should always return a 'str' object
                 # never a 'unicode' object.
-                if isinstance(s, unicode):
-                    return s.encode('utf8')
                 return s
         except (AttributeError, TypeError, NameError, ValueError, KeyError), e:
             return 'Unprintable exception %s: dict=%r, fmt=%r, error=%r' \
@@ -118,6 +116,26 @@
                    getattr(self, '_fmt', None),
                    e)
 
+    def __unicode__(self):
+        u = self._format()
+        if isinstance(u, str):
+            # Try decoding the str using the default encoding.
+            u = unicode(u)
+        elif not isinstance(u, unicode):
+            # Try to make a unicode object from it, because __unicode__ must
+            # return a unicode object.
+            u = unicode(u)
+        return u
+    
+    def __str__(self):
+        s = self._format()
+        if isinstance(s, unicode):
+            s = s.encode('utf8')
+        else:
+            # __str__ must return a str.
+            s = str(s)
+        return s
+
     def _get_format_string(self):
         """Return format string for this exception or None"""
         fmt = getattr(self, '_fmt', None)
@@ -371,16 +389,6 @@
     # are not intended to be caught anyway.  UI code need not subclass
     # BzrCommandError, and non-UI code should not throw a subclass of
     # BzrCommandError.  ADHB 20051211
-    def __init__(self, msg):
-        # Object.__str__() must return a real string
-        # returning a Unicode string is a python error.
-        if isinstance(msg, unicode):
-            self.msg = msg.encode('utf8')
-        else:
-            self.msg = msg
-
-    def __str__(self):
-        return self.msg
 
 
 class NotWriteLocked(BzrError):
@@ -766,11 +774,15 @@
 
 class IncompatibleRepositories(BzrError):
 
-    _fmt = "Repository %(target)s is not compatible with repository"\
-        " %(source)s"
+    _fmt = "%(target)s\n" \
+            "is not compatible with\n" \
+            "%(source)s\n" \
+            "%(details)s"
 
-    def __init__(self, source, target):
-        BzrError.__init__(self, target=target, source=source)
+    def __init__(self, source, target, details=None):
+        if details is None:
+            details = "(no details)"
+        BzrError.__init__(self, target=target, source=source, details=details)
 
 
 class IncompatibleRevision(BzrError):
@@ -2373,6 +2385,19 @@
         self.patch_type = patch_type
 
 
+class TargetNotBranch(BzrError):
+    """A merge directive's target branch is required, but isn't a branch"""
+
+    _fmt = ("Your branch does not have all of the revisions required in "
+            "order to merge this merge directive and the target "
+            "location specified in the merge directive is not a branch: "
+            "%(location)s.")
+
+    def __init__(self, location):
+        BzrError.__init__(self)
+        self.location = location
+
+
 class UnsupportedInventoryKind(BzrError):
     
     _fmt = """Unsupported entry kind %(kind)s"""
@@ -2421,7 +2446,7 @@
 class TagsNotSupported(BzrError):
 
     _fmt = ("Tags not supported by %(branch)s;"
-            " you may be able to use bzr upgrade --dirstate-tags.")
+            " you may be able to use bzr upgrade.")
 
     def __init__(self, branch):
         self.branch = branch
@@ -2794,3 +2819,34 @@
 
     def __init__(self, unknowns):
         BzrError.__init__(self, unknowns_str=", ".join(unknowns))
+
+
+class HookFailed(BzrError):
+    """Raised when a pre_change_branch_tip hook function fails anything other
+    than TipChangeRejected.
+    """
+
+    _fmt = ("Hook '%(hook_name)s' during %(hook_stage)s failed:\n"
+            "%(traceback_text)s%(exc_value)s")
+
+    def __init__(self, hook_stage, hook_name, exc_info):
+        import traceback
+        self.hook_stage = hook_stage
+        self.hook_name = hook_name
+        self.exc_info = exc_info
+        self.exc_type = exc_info[0]
+        self.exc_value = exc_info[1]
+        self.exc_tb = exc_info[2]
+        self.traceback_text = ''.join(traceback.format_tb(self.exc_tb))
+
+
+class TipChangeRejected(BzrError):
+    """A pre_change_branch_tip hook function may raise this to cleanly and
+    explicitly abort a change to a branch tip.
+    """
+    
+    _fmt = u"Tip change rejected: %(msg)s"
+
+    def __init__(self, msg):
+        self.msg = msg
+

=== modified file 'bzrlib/export/dir_exporter.py'
--- bzrlib/export/dir_exporter.py	2006-07-29 16:04:16 +0000
+++ bzrlib/export/dir_exporter.py	2008-07-30 00:26:38 +0000
@@ -17,9 +17,13 @@
 """Export a Tree to a non-versioned directory.
 """
 
+
 import os
+
+from bzrlib import errors, osutils
 from bzrlib.trace import mutter
 
+
 def dir_exporter(tree, dest, root):
     """Export this tree to a new directory.
 
@@ -32,17 +36,32 @@
     :note: If the export fails, the destination directory will be
            left in a half-assed state.
     """
-    import os
     os.mkdir(dest)
     mutter('export version %r', tree)
     inv = tree.inventory
     entries = inv.iter_entries()
     entries.next() # skip root
     for dp, ie in entries:
-        # .bzrignore has no meaning outside of a working tree
-        # so do not export it
-        if dp == ".bzrignore":
+        # The .bzr* namespace is reserved for "magic" files like
+        # .bzrignore and .bzrrules - do not export these
+        if dp.startswith(".bzr"):
             continue
         
-        ie.put_on_disk(dest, dp, tree)
-
+        fullpath = osutils.pathjoin(dest, dp)
+        if ie.kind == "file":
+            fileobj = tree.get_file(ie.file_id)
+            osutils.pumpfile(fileobj, file(fullpath, 'wb'))
+            if tree.is_executable(ie.file_id):
+                os.chmod(fullpath, 0755)
+        elif ie.kind == "directory":
+            os.mkdir(fullpath)
+        elif ie.kind == "symlink":
+            try:
+                os.symlink(ie.symlink_target, fullpath)
+            except OSError,e:
+                raise errors.BzrError(
+                    "Failed to create symlink %r -> %r, error: %s"
+                    % (fullpath, self.symlink_target, e))
+        else:
+            raise errors.BzrError("don't know how to export {%s} of kind %r" %
+               (ie.file_id, ie.kind))

=== modified file 'bzrlib/export/tar_exporter.py'
--- bzrlib/export/tar_exporter.py	2008-05-29 06:53:31 +0000
+++ bzrlib/export/tar_exporter.py	2008-07-30 00:26:38 +0000
@@ -18,11 +18,11 @@
 """
 
 import os
+import sys
 import tarfile
 import time
-import sys
 
-from bzrlib import errors, export
+from bzrlib import errors, export, osutils
 from bzrlib.trace import mutter
 
 
@@ -47,11 +47,37 @@
     entries = inv.iter_entries()
     entries.next() # skip root
     for dp, ie in entries:
-        # .bzrignore has no meaning outside of a working tree
-        # so do not export it
-        if dp == ".bzrignore":
+        # The .bzr* namespace is reserved for "magic" files like
+        # .bzrignore and .bzrrules - do not export these
+        if dp.startswith(".bzr"):
             continue
-        item, fileobj = ie.get_tar_item(root, dp, now, tree)
+
+        filename = osutils.pathjoin(root, dp).encode('utf8')
+        item = tarfile.TarInfo(filename)
+        item.mtime = now
+        if ie.kind == "file":
+            item.type = tarfile.REGTYPE
+            if tree.is_executable(ie.file_id):
+                item.mode = 0755
+            else:
+                item.mode = 0644
+            item.size = ie.text_size
+            fileobj = tree.get_file(ie.file_id)
+        elif ie.kind == "directory":
+            item.type = tarfile.DIRTYPE
+            item.name += '/'
+            item.size = 0
+            item.mode = 0755
+            fileobj = None
+        elif ie.kind == "symlink":
+            item.type = tarfile.SYMTYPE
+            item.size = 0
+            item.mode = 0755
+            item.linkname = ie.symlink_target
+            fileobj = None
+        else:
+            raise BzrError("don't know how to export {%s} of kind %r" %
+                           (ie.file_id, ie.kind))
         ball.addfile(item, fileobj)
     ball.close()
 
@@ -62,4 +88,3 @@
 
 def tbz_exporter(tree, dest, root):
     tar_exporter(tree, dest, root, compression='bz2')
-

=== modified file 'bzrlib/export/zip_exporter.py'
--- bzrlib/export/zip_exporter.py	2006-10-04 01:56:39 +0000
+++ bzrlib/export/zip_exporter.py	2008-07-25 01:12:16 +0000
@@ -55,9 +55,9 @@
         entries = inv.iter_entries()
         entries.next() # skip root
         for dp, ie in entries:
-            # .bzrignore has no meaning outside of a working tree
-            # so do not export it
-            if dp == ".bzrignore":
+            # The .bzr* namespace is reserved for "magic" files like
+            # .bzrignore and .bzrrules - do not export these
+            if dp.startswith(".bzr"):
                 continue
 
             file_id = ie.file_id

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2008-06-25 10:06:48 +0000
+++ bzrlib/fetch.py	2008-07-28 09:12:28 +0000
@@ -179,7 +179,8 @@
                     to_texts = self.to_repository.texts
                     from_texts = self.from_repository.texts
                     to_texts.insert_record_stream(from_texts.get_record_stream(
-                        text_keys, 'topological', False))
+                        text_keys, self.to_repository._fetch_order,
+                        self.to_repository._fetch_uses_deltas))
                     # Cause an error if a text occurs after we have done the
                     # copy.
                     text_keys = None
@@ -198,6 +199,8 @@
                     self._fetch_revision_texts(revs, pb)
                 else:
                     raise AssertionError("Unknown knit kind %r" % knit_kind)
+            if self.to_repository._fetch_reconcile:
+                self.to_repository.reconcile()
         finally:
             if pb is not None:
                 pb.finished()
@@ -239,61 +242,11 @@
             # corrupt.
             to_weave.insert_record_stream(from_weave.get_record_stream(
                 [(rev_id,) for rev_id in revs],
-                'topological', False))
+                self.to_repository._fetch_order,
+                self.to_repository._fetch_uses_deltas))
         finally:
             child_pb.finished()
 
-    def _generate_root_texts(self, revs):
-        """This will be called by __fetch between fetching weave texts and
-        fetching the inventory weave.
-
-        Subclasses should override this if they need to generate root texts
-        after fetching weave texts.
-        """
-        pass
-
-
-class GenericRepoFetcher(RepoFetcher):
-    """This is a generic repo to repo fetcher.
-
-    This makes minimal assumptions about repo layout and contents.
-    It triggers a reconciliation after fetching to ensure integrity.
-    """
-
-    def _fetch_revision_texts(self, revs, pb):
-        """Fetch revision object texts"""
-        count = 0
-        total = len(revs)
-        for rev in revs:
-            pb.update('copying revisions', count, total)
-            try:
-                sig_text = self.from_repository.get_signature_text(rev)
-                self.to_repository.add_signature_text(rev, sig_text)
-            except errors.NoSuchRevision:
-                # not signed.
-                pass
-            self._copy_revision(rev)
-            count += 1
-        # fixup inventory if needed: 
-        # this is expensive because we have no inverse index to current ghosts.
-        # but on local disk its a few seconds and sftp push is already insane.
-        # so we just-do-it.
-        # FIXME: repository should inform if this is needed.
-        self.to_repository.reconcile()
-
-    def _copy_revision(self, rev_id):
-        rev = self.from_repository.get_revision(rev_id)
-        self.to_repository.add_revision(rev_id, rev)
-
-
-class KnitRepoFetcher(RepoFetcher):
-    """This is a knit format repository specific fetcher.
-
-    This differs from the GenericRepoFetcher by not doing a 
-    reconciliation after copying, and using knit joining to
-    copy revision texts.
-    """
-
     def _fetch_revision_texts(self, revs, pb):
         # may need to be a InterRevisionStore call here.
         to_sf = self.to_repository.signatures
@@ -301,7 +254,8 @@
         # A missing signature is just skipped.
         to_sf.insert_record_stream(filter_absent(from_sf.get_record_stream(
             [(rev_id,) for rev_id in revs],
-            'unordered', False)))
+            self.to_repository._fetch_order,
+            self.to_repository._fetch_uses_deltas)))
         self._fetch_just_revision_texts(revs)
 
     def _fetch_just_revision_texts(self, version_ids):
@@ -309,7 +263,17 @@
         from_rf = self.from_repository.revisions
         to_rf.insert_record_stream(from_rf.get_record_stream(
             [(rev_id,) for rev_id in version_ids],
-            'topological', False))
+            self.to_repository._fetch_order,
+            self.to_repository._fetch_uses_deltas))
+
+    def _generate_root_texts(self, revs):
+        """This will be called by __fetch between fetching weave texts and
+        fetching the inventory weave.
+
+        Subclasses should override this if they need to generate root texts
+        after fetching weave texts.
+        """
+        pass
 
 
 class Inter1and2Helper(object):
@@ -420,13 +384,13 @@
             self.target.add_revision(revision.revision_id, revision)
 
 
-class Model1toKnit2Fetcher(GenericRepoFetcher):
+class Model1toKnit2Fetcher(RepoFetcher):
     """Fetch from a Model1 repository into a Knit2 repository
     """
     def __init__(self, to_repository, from_repository, last_revision=None,
                  pb=None, find_ghosts=True):
         self.helper = Inter1and2Helper(from_repository, to_repository)
-        GenericRepoFetcher.__init__(self, to_repository, from_repository,
+        RepoFetcher.__init__(self, to_repository, from_repository,
             last_revision, pb, find_ghosts)
 
     def _generate_root_texts(self, revs):
@@ -435,17 +399,32 @@
     def _fetch_inventory_weave(self, revs, pb):
         self.helper.regenerate_inventory(revs)
 
+    def _fetch_revision_texts(self, revs, pb):
+        """Fetch revision object texts"""
+        count = 0
+        total = len(revs)
+        for rev in revs:
+            pb.update('copying revisions', count, total)
+            try:
+                sig_text = self.from_repository.get_signature_text(rev)
+                self.to_repository.add_signature_text(rev, sig_text)
+            except errors.NoSuchRevision:
+                # not signed.
+                pass
+            self._copy_revision(rev)
+            count += 1
+
     def _copy_revision(self, rev):
         self.helper.fetch_revisions([rev])
 
 
-class Knit1to2Fetcher(KnitRepoFetcher):
+class Knit1to2Fetcher(RepoFetcher):
     """Fetch from a Knit1 repository into a Knit2 repository"""
 
-    def __init__(self, to_repository, from_repository, last_revision=None, 
+    def __init__(self, to_repository, from_repository, last_revision=None,
                  pb=None, find_ghosts=True):
         self.helper = Inter1and2Helper(from_repository, to_repository)
-        KnitRepoFetcher.__init__(self, to_repository, from_repository,
+        RepoFetcher.__init__(self, to_repository, from_repository,
             last_revision, pb, find_ghosts)
 
     def _generate_root_texts(self, revs):

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2008-06-19 13:14:24 +0000
+++ bzrlib/inventory.py	2008-07-30 21:30:59 +0000
@@ -50,7 +50,7 @@
     BzrCheckError,
     BzrError,
     )
-from bzrlib.symbol_versioning import deprecated_method
+from bzrlib.symbol_versioning import deprecated_in, deprecated_method
 from bzrlib.trace import mutter
 
 
@@ -176,6 +176,7 @@
                     candidates[ie.revision] = ie
         return candidates
 
+    @deprecated_method(deprecated_in((1, 6, 0)))
     def get_tar_item(self, root, dp, now, tree):
         """Get a tarfile item and a file stream for its content."""
         item = tarfile.TarInfo(osutils.pathjoin(root, dp).encode('utf8'))
@@ -238,6 +239,7 @@
         raise BzrError("don't know how to export {%s} of kind %r" %
                        (self.file_id, self.kind))
 
+    @deprecated_method(deprecated_in((1, 6, 0)))
     def put_on_disk(self, dest, dp, tree):
         """Create a representation of self on disk in the prefix dest.
         
@@ -813,7 +815,9 @@
                 # adds come later
                 continue
             # Preserve unaltered children of file_id for later reinsertion.
-            children[file_id] = getattr(self[file_id], 'children', {})
+            file_id_children = getattr(self[file_id], 'children', {})
+            if len(file_id_children):
+                children[file_id] = file_id_children
             # Remove file_id and the unaltered children. If file_id is not
             # being deleted it will be reinserted back later.
             self.remove_recursive_id(file_id)
@@ -825,8 +829,16 @@
         for new_path, new_entry in sorted((np, e) for op, np, f, e in
                                           delta if np is not None):
             if new_entry.kind == 'directory':
-                new_entry.children = children.get(new_entry.file_id, {})
+                # Pop the child which to allow detection of children whose
+                # parents were deleted and which were not reattached to a new
+                # parent.
+                new_entry.children = children.pop(new_entry.file_id, {})
             self.add(new_entry)
+        if len(children):
+            # Get the parent id that was deleted
+            parent_id, children = children.popitem()
+            raise errors.InconsistentDelta("<deleted>", parent_id,
+                "The file id was deleted but its children were not deleted.")
 
     def _set_root(self, ie):
         self.root = ie

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2008-07-18 03:07:07 +0000
+++ bzrlib/knit.py	2008-08-01 04:06:18 +0000
@@ -698,6 +698,11 @@
     """Storage for many versioned files using knit compression.
 
     Backend storage is managed by indices and data objects.
+
+    :ivar _index: A _KnitGraphIndex or similar that can describe the 
+        parents, graph, compression and data location of entries in this 
+        KnitVersionedFiles.  Note that this is only the index for 
+        *this* vfs; if there are fallbacks they must be queried separately.
     """
 
     def __init__(self, index, data_access, max_delta_chain=200,
@@ -892,6 +897,10 @@
         for count in xrange(self._max_delta_chain):
             # XXX: Collapse these two queries:
             try:
+                # Note that this only looks in the index of this particular
+                # KnitVersionedFiles, not in the fallbacks.  This ensures that
+                # we won't store a delta spanning physical repository
+                # boundaries.
                 method = self._index.get_method(parent)
             except RevisionNotPresent:
                 # Some basis is not locally present: always delta

=== modified file 'bzrlib/merge_directive.py'
--- bzrlib/merge_directive.py	2008-05-23 10:39:44 +0000
+++ bzrlib/merge_directive.py	2008-07-12 00:52:42 +0000
@@ -210,7 +210,11 @@
                 except errors.RevisionNotPresent:
                     # At least one dependency isn't present.  Try installing
                     # missing revisions from the submit branch
-                    submit_branch = _mod_branch.Branch.open(self.target_branch)
+                    try:
+                        submit_branch = \
+                            _mod_branch.Branch.open(self.target_branch)
+                    except errors.NotBranchError:
+                        raise errors.TargetNotBranch(self.target_branch)
                     missing_revisions = []
                     bundle_revisions = set(r.revision_id for r in
                                            info.real_revisions)

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2008-07-17 20:16:43 +0000
+++ bzrlib/osutils.py	2008-07-30 09:50:22 +0000
@@ -1168,11 +1168,20 @@
 
         dirblock = []
         append = dirblock.append
-        for name in sorted(_listdir(top)):
-            abspath = top_slash + name
-            statvalue = _lstat(abspath)
-            kind = _kind_from_mode(statvalue.st_mode & 0170000, 'unknown')
-            append((relprefix + name, name, kind, statvalue, abspath))
+        try:
+            names = sorted(_listdir(top))
+        except OSError, e:
+            if getattr(e, 'errno', None) == errno.ENOTDIR:
+                # We have been asked to examine a file, this is fine.
+                pass
+            else:
+                raise
+        else:
+            for name in names:
+                abspath = top_slash + name
+                statvalue = _lstat(abspath)
+                kind = _kind_from_mode(statvalue.st_mode & 0170000, 'unknown')
+                append((relprefix + name, name, kind, statvalue, abspath))
         yield (relroot, top), dirblock
 
         # push the user specified dirs from dirblock

=== modified file 'bzrlib/remote.py'
--- bzrlib/remote.py	2008-07-23 22:53:38 +0000
+++ bzrlib/remote.py	2008-07-28 09:12:28 +0000
@@ -816,6 +816,36 @@
         self._ensure_real()
         return self._real_repository.iter_files_bytes(desired_files)
 
+    @property
+    def _fetch_order(self):
+        """Decorate the real repository for now.
+
+        In the long term getting this back from the remote repository as part
+        of open would be more efficient.
+        """
+        self._ensure_real()
+        return self._real_repository._fetch_order
+
+    @property
+    def _fetch_uses_deltas(self):
+        """Decorate the real repository for now.
+
+        In the long term getting this back from the remote repository as part
+        of open would be more efficient.
+        """
+        self._ensure_real()
+        return self._real_repository._fetch_uses_deltas
+
+    @property
+    def _fetch_reconcile(self):
+        """Decorate the real repository for now.
+
+        In the long term getting this back from the remote repository as part
+        of open would be more efficient.
+        """
+        self._ensure_real()
+        return self._real_repository._fetch_reconcile
+
     def get_parent_map(self, keys):
         """See bzrlib.Graph.get_parent_map()."""
         # Hack to build up the caching logic.
@@ -1696,5 +1726,7 @@
         raise errors.TokenMismatch(find('token'), '(remote token)')
     elif err.error_verb == 'Diverged':
         raise errors.DivergedBranches(find('branch'), find('other_branch'))
+    elif err.error_verb == 'TipChangeRejected':
+        raise errors.TipChangeRejected(err.error_args[0].decode('utf8'))
     raise
 

=== modified file 'bzrlib/repofmt/knitrepo.py'
--- bzrlib/repofmt/knitrepo.py	2008-06-11 07:22:00 +0000
+++ bzrlib/repofmt/knitrepo.py	2008-07-28 06:08:42 +0000
@@ -130,10 +130,8 @@
         self._commit_builder_class = _commit_builder_class
         self._serializer = _serializer
         self._reconcile_fixes_text_parents = True
-
-    def _warn_if_deprecated(self):
-        # This class isn't deprecated
-        pass
+        self._fetch_uses_deltas = True
+        self._fetch_order = 'topological'
 
     @needs_read_lock
     def _all_revision_ids(self):

=== modified file 'bzrlib/repofmt/pack_repo.py'
--- bzrlib/repofmt/pack_repo.py	2008-07-22 09:05:52 +0000
+++ bzrlib/repofmt/pack_repo.py	2008-08-05 14:35:14 +0000
@@ -17,16 +17,16 @@
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from itertools import izip
-import math
 import md5
 import time
 
 from bzrlib import (
-        debug,
-        graph,
-        pack,
-        ui,
-        )
+    debug,
+    graph,
+    pack,
+    transactions,
+    ui,
+    )
 from bzrlib.index import (
     GraphIndex,
     GraphIndexBuilder,
@@ -41,8 +41,6 @@
     _DirectPackAccess,
     )
 from bzrlib.osutils import rand_chars, split_lines
-from bzrlib.pack import ContainerWriter
-from bzrlib.store import revision
 from bzrlib import tsort
 """)
 from bzrlib import (
@@ -50,30 +48,23 @@
     errors,
     lockable_files,
     lockdir,
-    osutils,
     symbol_versioning,
-    transactions,
     xml5,
     xml6,
     xml7,
     )
 
-from bzrlib.decorators import needs_read_lock, needs_write_lock
+from bzrlib.decorators import needs_write_lock
 from bzrlib.repofmt.knitrepo import KnitRepository
 from bzrlib.repository import (
     CommitBuilder,
-    InterRepository,
-    MetaDirRepository,
     MetaDirRepositoryFormat,
     RepositoryFormat,
     RootCommitBuilder,
     )
 import bzrlib.revision as _mod_revision
-from bzrlib.store.versioned import VersionedFileStore
 from bzrlib.trace import (
     mutter,
-    mutter_callsite,
-    note,
     warning,
     )
 
@@ -1728,6 +1719,11 @@
         self._reconcile_does_inventory_gc = True
         self._reconcile_fixes_text_parents = True
         self._reconcile_backsup_inventory = False
+        self._fetch_order = 'unsorted'
+
+    def _warn_if_deprecated(self):
+        # This class isn't deprecated
+        pass
 
     def _abort_write_group(self):
         self._pack_collection._abort_write_group()
@@ -1814,7 +1810,6 @@
             raise errors.ReadOnlyError(self)
         self._write_lock_count += 1
         if self._write_lock_count == 1:
-            from bzrlib import transactions
             self._transaction = transactions.WriteTransaction()
             for repo in self._fallback_repositories:
                 # Writes don't affect fallback repos
@@ -1975,103 +1970,6 @@
         pass
 
 
-class RepositoryFormatPack(MetaDirRepositoryFormat):
-    """Format logic for pack structured repositories.
-
-    This repository format has:
-     - a list of packs in pack-names
-     - packs in packs/NAME.pack
-     - indices in indices/NAME.{iix,six,tix,rix}
-     - knit deltas in the packs, knit indices mapped to the indices.
-     - thunk objects to support the knits programming API.
-     - a format marker of its own
-     - an optional 'shared-storage' flag
-     - an optional 'no-working-trees' flag
-     - a LockDir lock
-    """
-
-    # Set this attribute in derived classes to control the repository class
-    # created by open and initialize.
-    repository_class = None
-    # Set this attribute in derived classes to control the
-    # _commit_builder_class that the repository objects will have passed to
-    # their constructor.
-    _commit_builder_class = None
-    # Set this attribute in derived clases to control the _serializer that the
-    # repository objects will have passed to their constructor.
-    _serializer = None
-    # External references are not supported in pack repositories yet.
-    supports_external_lookups = False
-
-    def initialize(self, a_bzrdir, shared=False):
-        """Create a pack based repository.
-
-        :param a_bzrdir: bzrdir to contain the new repository; must already
-            be initialized.
-        :param shared: If true the repository will be initialized as a shared
-                       repository.
-        """
-        mutter('creating repository in %s.', a_bzrdir.transport.base)
-        dirs = ['indices', 'obsolete_packs', 'packs', 'upload']
-        builder = GraphIndexBuilder()
-        files = [('pack-names', builder.finish())]
-        utf8_files = [('format', self.get_format_string())]
-        
-        self._upload_blank_content(a_bzrdir, dirs, files, utf8_files, shared)
-        return self.open(a_bzrdir=a_bzrdir, _found=True)
-
-    def open(self, a_bzrdir, _found=False, _override_transport=None):
-        """See RepositoryFormat.open().
-        
-        :param _override_transport: INTERNAL USE ONLY. Allows opening the
-                                    repository at a slightly different url
-                                    than normal. I.e. during 'upgrade'.
-        """
-        if not _found:
-            format = RepositoryFormat.find_format(a_bzrdir)
-        if _override_transport is not None:
-            repo_transport = _override_transport
-        else:
-            repo_transport = a_bzrdir.get_repository_transport(None)
-        control_files = lockable_files.LockableFiles(repo_transport,
-                                'lock', lockdir.LockDir)
-        return self.repository_class(_format=self,
-                              a_bzrdir=a_bzrdir,
-                              control_files=control_files,
-                              _commit_builder_class=self._commit_builder_class,
-                              _serializer=self._serializer)
-
-
-class RepositoryFormatKnitPack1(RepositoryFormatPack):
-    """A no-subtrees parameterized Pack repository.
-
-    This format was introduced in 0.92.
-    """
-
-    repository_class = KnitPackRepository
-    _commit_builder_class = PackCommitBuilder
-    _serializer = xml5.serializer_v5
-
-    def _get_matching_bzrdir(self):
-        return bzrdir.format_registry.make_bzrdir('pack-0.92')
-
-    def _ignore_setting_bzrdir(self, format):
-        pass
-
-    _matchingbzrdir = property(_get_matching_bzrdir, _ignore_setting_bzrdir)
-
-    def get_format_string(self):
-        """See RepositoryFormat.get_format_string()."""
-        return "Bazaar pack repository format 1 (needs bzr 0.92)\n"
-
-    def get_format_description(self):
-        """See RepositoryFormat.get_format_description()."""
-        return "Packs containing knits without subtree support"
-
-    def check_conversion_target(self, target_format):
-        pass
-
-
 class RepositoryFormatKnitPack3(RepositoryFormatPack):
     """A subtrees parameterized Pack repository.
 

=== modified file 'bzrlib/repofmt/weaverepo.py'
--- bzrlib/repofmt/weaverepo.py	2008-06-18 07:56:09 +0000
+++ bzrlib/repofmt/weaverepo.py	2008-07-29 15:51:45 +0000
@@ -85,6 +85,8 @@
             self.inventory_store = get_store('inventory-store')
             self._text_store = get_store('text-store')
         super(AllInOneRepository, self).__init__(_format, a_bzrdir, a_bzrdir._control_files)
+        self._fetch_order = 'topological'
+        self._fetch_reconcile = True
 
     @needs_read_lock
     def _all_possible_ids(self):
@@ -146,7 +148,6 @@
         return self.inventories.add_lines((revision_id,), final_parents, lines,
             check_content=check_content)[0]
 
-    @needs_read_lock
     def is_shared(self):
         """AllInOne repositories cannot be shared."""
         return False
@@ -178,6 +179,11 @@
 
     _serializer = xml5.serializer_v5
 
+    def __init__(self, _format, a_bzrdir, control_files):
+        super(WeaveMetaDirRepository, self).__init__(_format, a_bzrdir, control_files)
+        self._fetch_order = 'topological'
+        self._fetch_reconcile = True
+
     @needs_read_lock
     def _all_possible_ids(self):
         """Return all the possible revisions that we could find."""
@@ -317,6 +323,8 @@
 
     def __init__(self):
         super(RepositoryFormat4, self).__init__()
+        self._fetch_order = 'topological'
+        self._fetch_reconcile = True
 
     def get_format_description(self):
         """See RepositoryFormat.get_format_description()."""
@@ -368,6 +376,8 @@
 
     def __init__(self):
         super(RepositoryFormat5, self).__init__()
+        self._fetch_order = 'topological'
+        self._fetch_reconcile = True
 
     def get_format_description(self):
         """See RepositoryFormat.get_format_description()."""
@@ -410,6 +420,8 @@
 
     def __init__(self):
         super(RepositoryFormat6, self).__init__()
+        self._fetch_order = 'topological'
+        self._fetch_reconcile = True
 
     def get_format_description(self):
         """See RepositoryFormat.get_format_description()."""

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2008-07-22 09:54:03 +0000
+++ bzrlib/repository.py	2008-07-31 06:26:44 +0000
@@ -530,21 +530,21 @@
         """
         if not self._format.supports_external_lookups:
             raise errors.UnstackableRepositoryFormat(self._format, self.base)
-        if not self._add_fallback_repository_check(repository):
-            raise errors.IncompatibleRepositories(self, repository)
+        self._check_fallback_repository(repository)
         self._fallback_repositories.append(repository)
         self.texts.add_fallback_versioned_files(repository.texts)
         self.inventories.add_fallback_versioned_files(repository.inventories)
         self.revisions.add_fallback_versioned_files(repository.revisions)
         self.signatures.add_fallback_versioned_files(repository.signatures)
 
-    def _add_fallback_repository_check(self, repository):
+    def _check_fallback_repository(self, repository):
         """Check that this repository can fallback to repository safely.
+
+        Raise an error if not.
         
         :param repository: A repository to fallback to.
-        :return: True if the repositories can stack ok.
         """
-        return InterRepository._same_model(self, repository)
+        return InterRepository._assert_same_model(self, repository)
 
     def add_inventory(self, revision_id, inv, parents):
         """Add the inventory inv to the repository as revision_id.
@@ -690,6 +690,18 @@
         self._write_group = None
         # Additional places to query for data.
         self._fallback_repositories = []
+        # What order should fetch operations request streams in?
+        # The default is unsorted as that is the cheapest for an origin to
+        # provide.
+        self._fetch_order = 'unsorted'
+        # Does this repository use deltas that can be fetched as-deltas ?
+        # (E.g. knits, where the knit deltas can be transplanted intact.
+        # We default to False, which will ensure that enough data to get
+        # a full text out of any fetch stream will be grabbed.
+        self._fetch_uses_deltas = False
+        # Should fetch trigger a reconcile after the fetch? Only needed for
+        # some repository formats that can suffer internal inconsistencies.
+        self._fetch_reconcile = False
 
     def __repr__(self):
         return '%s(%r)' % (self.__class__.__name__,
@@ -955,11 +967,12 @@
                 not _mod_revision.is_null(revision_id)):
                 self.get_revision(revision_id)
             return 0, []
+        # if there is no specific appropriate InterRepository, this will get
+        # the InterRepository base class, which raises an
+        # IncompatibleRepositories when asked to fetch.
         inter = InterRepository.get(source, self)
-        try:
-            return inter.fetch(revision_id=revision_id, pb=pb, find_ghosts=find_ghosts)
-        except NotImplementedError:
-            raise errors.IncompatibleRepositories(source, self)
+        return inter.fetch(revision_id=revision_id, pb=pb,
+            find_ghosts=find_ghosts)
 
     def create_bundle(self, target, base, fileobj, format=None):
         return serializer.write_bundle(self, target, base, fileobj, format)
@@ -1613,7 +1626,6 @@
         else:
             return self.get_inventory(revision_id)
 
-    @needs_read_lock
     def is_shared(self):
         """Return True if this repository is flagged as a shared repository."""
         raise NotImplementedError(self.is_shared)
@@ -1993,7 +2005,6 @@
         super(MetaDirRepository, self).__init__(_format, a_bzrdir, control_files)
         self._transport = control_files._transport
 
-    @needs_read_lock
     def is_shared(self):
         """Return True if this repository is flagged as a shared repository."""
         return self._transport.has('shared-storage')
@@ -2350,10 +2361,16 @@
         :param pb: optional progress bar to use for progress reports. If not
                    provided a default one will be created.
 
-        Returns the copied revision count and the failed revisions in a tuple:
-        (copied, failures).
+        :returns: (copied_revision_count, failures).
         """
-        raise NotImplementedError(self.fetch)
+        # Normally we should find a specific InterRepository subclass to do
+        # the fetch; if nothing else then at least InterSameDataRepository.
+        # If none of them is suitable it looks like fetching is not possible;
+        # we try to give a good message why.  _assert_same_model will probably
+        # give a helpful message; otherwise a generic one.
+        self._assert_same_model(self.source, self.target)
+        raise errors.IncompatibleRepositories(self.source, self.target,
+            "no suitableInterRepository found")
 
     def _walk_to_common_revisions(self, revision_ids):
         """Walk out from revision_ids in source to revisions target has.
@@ -2433,12 +2450,27 @@
 
     @staticmethod
     def _same_model(source, target):
-        """True if source and target have the same data representation."""
+        """True if source and target have the same data representation.
+        
+        Note: this is always called on the base class; overriding it in a
+        subclass will have no effect.
+        """
+        try:
+            InterRepository._assert_same_model(source, target)
+            return True
+        except errors.IncompatibleRepositories, e:
+            return False
+
+    @staticmethod
+    def _assert_same_model(source, target):
+        """Raise an exception if two repositories do not use the same model.
+        """
         if source.supports_rich_root() != target.supports_rich_root():
-            return False
+            raise errors.IncompatibleRepositories(source, target,
+                "different rich-root support")
         if source._serializer != target._serializer:
-            return False
-        return True
+            raise errors.IncompatibleRepositories(source, target,
+                "different serializers")
 
 
 class InterSameDataRepository(InterRepository):
@@ -2487,11 +2519,11 @@
     @needs_write_lock
     def fetch(self, revision_id=None, pb=None, find_ghosts=False):
         """See InterRepository.fetch()."""
-        from bzrlib.fetch import GenericRepoFetcher
+        from bzrlib.fetch import RepoFetcher
         mutter("Using fetch logic to copy between %s(%s) and %s(%s)",
                self.source, self.source._format, self.target,
                self.target._format)
-        f = GenericRepoFetcher(to_repository=self.target,
+        f = RepoFetcher(to_repository=self.target,
                                from_repository=self.source,
                                last_revision=revision_id,
                                pb=pb, find_ghosts=find_ghosts)
@@ -2568,10 +2600,10 @@
     @needs_write_lock
     def fetch(self, revision_id=None, pb=None, find_ghosts=False):
         """See InterRepository.fetch()."""
-        from bzrlib.fetch import GenericRepoFetcher
+        from bzrlib.fetch import RepoFetcher
         mutter("Using fetch logic to copy between %s(%s) and %s(%s)",
                self.source, self.source._format, self.target, self.target._format)
-        f = GenericRepoFetcher(to_repository=self.target,
+        f = RepoFetcher(to_repository=self.target,
                                from_repository=self.source,
                                last_revision=revision_id,
                                pb=pb, find_ghosts=find_ghosts)
@@ -2649,10 +2681,10 @@
     @needs_write_lock
     def fetch(self, revision_id=None, pb=None, find_ghosts=False):
         """See InterRepository.fetch()."""
-        from bzrlib.fetch import KnitRepoFetcher
+        from bzrlib.fetch import RepoFetcher
         mutter("Using fetch logic to copy between %s(%s) and %s(%s)",
                self.source, self.source._format, self.target, self.target._format)
-        f = KnitRepoFetcher(to_repository=self.target,
+        f = RepoFetcher(to_repository=self.target,
                             from_repository=self.source,
                             last_revision=revision_id,
                             pb=pb, find_ghosts=find_ghosts)
@@ -2719,10 +2751,15 @@
     @needs_write_lock
     def fetch(self, revision_id=None, pb=None, find_ghosts=False):
         """See InterRepository.fetch()."""
-        if len(self.source._fallback_repositories) > 0:
-            from bzrlib.fetch import KnitRepoFetcher
-            fetcher = KnitRepoFetcher(self.target, self.source, revision_id,
-                                      pb, find_ghosts)
+        if (len(self.source._fallback_repositories) > 0 or
+            len(self.target._fallback_repositories) > 0):
+            # The pack layer is not aware of fallback repositories, so when
+            # fetching from a stacked repository or into a stacked repository
+            # we use the generic fetch logic which uses the VersionedFiles
+            # attributes on repository.
+            from bzrlib.fetch import RepoFetcher
+            fetcher = RepoFetcher(self.target, self.source, revision_id,
+                                  pb, find_ghosts)
             return fetcher.count_copied, fetcher.failed_revisions
         from bzrlib.repofmt.pack_repo import Packer
         mutter("Using fetch logic to copy between %s(%s) and %s(%s)",

=== modified file 'bzrlib/revisionspec.py'
--- bzrlib/revisionspec.py	2008-06-15 23:08:14 +0000
+++ bzrlib/revisionspec.py	2008-07-19 15:00:27 +0000
@@ -596,7 +596,7 @@
 
     One way to display all the changes since yesterday would be::
 
-        bzr log -r date:yesterday..-1
+        bzr log -r date:yesterday..
 
     Examples::
 
@@ -787,7 +787,7 @@
 
     Diffing against this shows all the changes that were made in this branch,
     and is a good predictor of what merge will do.  The submit branch is
-    used by the bundle and merge directive comands.  If no submit branch
+    used by the bundle and merge directive commands.  If no submit branch
     is specified, the parent branch is used instead.
 
     The common ancestor is the last revision that existed in both

=== modified file 'bzrlib/smart/branch.py'
--- bzrlib/smart/branch.py	2008-06-25 07:03:41 +0000
+++ bzrlib/smart/branch.py	2008-07-25 06:42:08 +0000
@@ -115,9 +115,24 @@
         return SuccessfulSmartServerResponse(('ok', str(revno), last_revision))
 
 
-class SmartServerBranchRequestSetLastRevision(SmartServerLockedBranchRequest):
+class SmartServerSetTipRequest(SmartServerLockedBranchRequest):
+    """Base class for handling common branch request logic for requests that
+    update the branch tip.
+    """
+
+    def do_with_locked_branch(self, branch, *args):
+        try:
+            return self.do_tip_change_with_locked_branch(branch, *args)
+        except errors.TipChangeRejected, e:
+            msg = e.msg
+            if isinstance(msg, unicode):
+                msg = msg.encode('utf-8')
+            return FailedSmartServerResponse(('TipChangeRejected', msg))
+
+
+class SmartServerBranchRequestSetLastRevision(SmartServerSetTipRequest):
     
-    def do_with_locked_branch(self, branch, new_last_revision_id):
+    def do_tip_change_with_locked_branch(self, branch, new_last_revision_id):
         if new_last_revision_id == 'null:':
             branch.set_revision_history([])
         else:
@@ -128,9 +143,9 @@
         return SuccessfulSmartServerResponse(('ok',))
 
 
-class SmartServerBranchRequestSetLastRevisionEx(SmartServerLockedBranchRequest):
+class SmartServerBranchRequestSetLastRevisionEx(SmartServerSetTipRequest):
     
-    def do_with_locked_branch(self, branch, new_last_revision_id,
+    def do_tip_change_with_locked_branch(self, branch, new_last_revision_id,
             allow_divergence, allow_overwrite_descendant):
         """Set the last revision of the branch.
 
@@ -176,15 +191,15 @@
             ('ok', new_revno, new_last_revision_id))
 
 
-class SmartServerBranchRequestSetLastRevisionInfo(
-    SmartServerLockedBranchRequest):
+class SmartServerBranchRequestSetLastRevisionInfo(SmartServerSetTipRequest):
     """Branch.set_last_revision_info.  Sets the revno and the revision ID of
     the specified branch.
 
     New in bzrlib 1.4.
     """
     
-    def do_with_locked_branch(self, branch, new_revno, new_last_revision_id):
+    def do_tip_change_with_locked_branch(self, branch, new_revno,
+            new_last_revision_id):
         try:
             branch.set_last_revision_info(int(new_revno), new_last_revision_id)
         except errors.NoSuchRevision:

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2008-07-21 08:58:33 +0000
+++ bzrlib/tests/__init__.py	2008-08-04 07:55:41 +0000
@@ -49,6 +49,7 @@
 
 
 from bzrlib import (
+    branchbuilder,
     bzrdir,
     debug,
     errors,
@@ -1993,6 +1994,11 @@
         b = self.make_branch(relpath, format=format)
         return memorytree.MemoryTree.create_on_branch(b)
 
+    def make_branch_builder(self, relpath, format=None):
+        url = self.get_url(relpath)
+        tran = get_transport(url)
+        return branchbuilder.BranchBuilder(get_transport(url), format=format)
+
     def overrideEnvironmentForTesting(self):
         os.environ['HOME'] = self.test_home_dir
         os.environ['BZR_HOME'] = self.test_home_dir
@@ -2132,7 +2138,7 @@
             tree = workingtree.WorkingTree.open(root_path)
         if not isinstance(path, basestring):
             for p in path:
-                self.assertInWorkingTree(p,tree=tree)
+                self.assertInWorkingTree(p, tree=tree)
         else:
             self.assertIsNot(tree.path2id(path), None,
                 path+' not in working tree.')
@@ -2757,6 +2763,7 @@
                    'bzrlib.tests.test_osutils',
                    'bzrlib.tests.test_osutils_encodings',
                    'bzrlib.tests.test_pack',
+                   'bzrlib.tests.test_pack_repository',
                    'bzrlib.tests.test_patch',
                    'bzrlib.tests.test_patches',
                    'bzrlib.tests.test_permissions',
@@ -2808,6 +2815,7 @@
                    'bzrlib.tests.test_ui',
                    'bzrlib.tests.test_uncommit',
                    'bzrlib.tests.test_upgrade',
+                   'bzrlib.tests.test_upgrade_stacked',
                    'bzrlib.tests.test_urlutils',
                    'bzrlib.tests.test_versionedfile',
                    'bzrlib.tests.test_version',

=== modified file 'bzrlib/tests/blackbox/test_branch.py'
--- bzrlib/tests/blackbox/test_branch.py	2008-07-17 08:00:25 +0000
+++ bzrlib/tests/blackbox/test_branch.py	2008-07-25 05:32:45 +0000
@@ -97,6 +97,9 @@
         target_stat = os.stat('target/file1')
         self.assertEqual(source_stat, target_stat)
 
+class TestBranchStacked(ExternalBase):
+    """Tests for branch --stacked"""
+
     def check_shallow_branch(self, branch_revid, stacked_on):
         """Assert that the branch 'newbranch' has been published correctly.
         
@@ -153,6 +156,9 @@
         self.assertEqual('', out)
         self.assertEqual('Branched 1 revision(s).\n',
             err)
+        # it should have preserved the branch format, and so it should be
+        # capable of supporting stacking, but not actually have a stacked_on
+        # branch configured
         self.assertRaises(errors.NotStacked,
             bzrdir.BzrDir.open('newbranch').open_branch().get_stacked_on_url)
 
@@ -207,6 +213,12 @@
         out, err = self.run_bzr(
             ['branch', '--stacked', self.get_url('mainline'), 'shallow'])
 
+    def test_branch_stacked_from_non_stacked_format(self):
+        """The origin format doesn't support stacking"""
+        trunk = self.make_branch('trunk', format='pack-0.92')
+        out, err = self.run_bzr(
+            ['branch', '--stacked', 'trunk', 'shallow'])
+
 
 class TestRemoteBranch(TestCaseWithSFTPServer):
 

=== modified file 'bzrlib/tests/blackbox/test_check.py'
--- bzrlib/tests/blackbox/test_check.py	2008-03-10 23:45:32 +0000
+++ bzrlib/tests/blackbox/test_check.py	2008-07-04 00:37:35 +0000
@@ -16,6 +16,7 @@
 
 """Tests for the 'check' CLI command."""
 
+from bzrlib.tests import ChrootedTestCase
 from bzrlib.tests.blackbox import ExternalBase
 
 
@@ -43,3 +44,72 @@
                                    r"     0 unreferenced text versions\n"
                                    r"Checking branch at '.*'\.\n"
                                    r"checked branch.*\n$")
+
+    def test_check_branch(self):
+        tree = self.make_branch_and_tree('.')
+        tree.commit('foo')
+        out, err = self.run_bzr('check --branch')
+        self.assertContainsRe(err, r"^Checking branch at '.*'\.\n"
+                                   r"checked branch.*\n$")
+
+    def test_check_repository(self):
+        tree = self.make_branch_and_tree('.')
+        tree.commit('foo')
+        out, err = self.run_bzr('check --repo')
+        self.assertContainsRe(err, r"^Checking repository at '.*'\.\n"
+                                   r"checked repository.*\n"
+                                   r"     1 revisions\n"
+                                   r"     0 file-ids\n"
+                                   r"     0 unique file texts\n"
+                                   r"     0 repeated file texts\n"
+                                   r"     0 unreferenced text versions$")
+
+    def test_check_tree(self):
+        tree = self.make_branch_and_tree('.')
+        tree.commit('foo')
+        out, err = self.run_bzr('check --tree')
+        self.assertContainsRe(err, r"^Checking working tree at '.*'\.\n$")
+
+    def test_partial_check(self):
+        tree = self.make_branch_and_tree('.')
+        tree.commit('foo')
+        out, err = self.run_bzr('check --tree --branch')
+        self.assertContainsRe(err, r"^Checking working tree at '.*'\.\n"
+                                   r"Checking branch at '.*'\.\n"
+                                   r"checked branch.*\n$")
+
+    def test_check_missing_tree(self):
+        branch = self.make_branch('.')
+        out, err = self.run_bzr('check --tree')
+        self.assertEqual(err, "No working tree found at specified location.\n")
+
+    def test_check_missing_partial(self):
+        branch = self.make_branch('.')
+        out, err = self.run_bzr('check --tree --branch')
+        self.assertContainsRe(err,
+            r"^No working tree found at specified location\.\n"
+            r"Checking branch at '.*'\.\n"
+            r"checked branch.*\n$")
+
+    def test_check_missing_branch_in_shared_repo(self):
+        self.make_repository('shared', shared=True)
+        out, err = self.run_bzr('check --branch shared')
+        self.assertEqual(err, "No branch found at specified location.\n")
+
+
+class ChrootedCheckTests(ChrootedTestCase):
+
+    def test_check_missing_branch(self):
+        out, err = self.run_bzr(
+            'check --branch %s' % self.get_readonly_url(''))
+        self.assertEqual(err, "No branch found at specified location.\n")
+
+    def test_check_missing_repository(self):
+        out, err = self.run_bzr('check --repo %s' % self.get_readonly_url(''))
+        self.assertEqual(err, "No repository found at specified location.\n")
+
+    def test_check_missing_everything(self):
+        out, err = self.run_bzr('check %s' % self.get_readonly_url(''))
+        self.assertEqual(err, "No working tree found at specified location.\n"
+                              "No branch found at specified location.\n"
+                              "No repository found at specified location.\n")

=== modified file 'bzrlib/tests/blackbox/test_commit.py'
--- bzrlib/tests/blackbox/test_commit.py	2007-12-10 16:39:00 +0000
+++ bzrlib/tests/blackbox/test_commit.py	2008-08-05 00:06:19 +0000
@@ -331,6 +331,35 @@
         self.build_tree_contents([('u1/hosts', 'merge resolution\n')])
         self.run_bzr('commit -m checkin-merge-of-the-offline-work-from-u1 u1')
 
+    def test_commit_exclude_excludes_modified_files(self):
+        """Commit -x foo should ignore changes to foo."""
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['a', 'b', 'c'])
+        tree.smart_add(['.'])
+        out, err = self.run_bzr(['commit', '-m', 'test', '-x', 'b'])
+        self.assertFalse('added b' in out)
+        self.assertFalse('added b' in err)
+        # If b was excluded it will still be 'added' in status.
+        out, err = self.run_bzr(['added'])
+        self.assertEqual('b\n', out)
+        self.assertEqual('', err)
+
+    def test_commit_exclude_twice_uses_both_rules(self):
+        """Commit -x foo -x bar should ignore changes to foo and bar."""
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['a', 'b', 'c'])
+        tree.smart_add(['.'])
+        out, err = self.run_bzr(['commit', '-m', 'test', '-x', 'b', '-x', 'c'])
+        self.assertFalse('added b' in out)
+        self.assertFalse('added c' in out)
+        self.assertFalse('added b' in err)
+        self.assertFalse('added c' in err)
+        # If b was excluded it will still be 'added' in status.
+        out, err = self.run_bzr(['added'])
+        self.assertTrue('b\n' in out)
+        self.assertTrue('c\n' in out)
+        self.assertEqual('', err)
+
     def test_commit_respects_spec_for_removals(self):
         """Commit with a file spec should only commit removals that match"""
         t = self.make_branch_and_tree('.')

=== modified file 'bzrlib/tests/blackbox/test_export.py'
--- bzrlib/tests/blackbox/test_export.py	2008-05-29 06:53:31 +0000
+++ bzrlib/tests/blackbox/test_export.py	2008-07-30 00:22:33 +0000
@@ -38,12 +38,19 @@
         tree = self.make_branch_and_tree('tar')
         self.build_tree(['tar/a'])
         tree.add('a')
+        self.build_tree_contents([('tar/.bzrrules', '')])
+        tree.add('.bzrrules')
+        self.build_tree(['tar/.bzr-adir/', 'tar/.bzr-adir/afile'])
+        tree.add(['.bzr-adir/', '.bzr-adir/afile'])
 
         os.chdir('tar')
         self.run_bzr('ignore something')
         tree.commit('1')
 
         self.failUnless(tree.has_filename('.bzrignore'))
+        self.failUnless(tree.has_filename('.bzrrules'))
+        self.failUnless(tree.has_filename('.bzr-adir'))
+        self.failUnless(tree.has_filename('.bzr-adir/afile'))
         self.run_bzr('export test.tar.gz')
         ball = tarfile.open('test.tar.gz')
         # Make sure the tarball contains 'a', but does not contain
@@ -75,12 +82,19 @@
         tree = self.make_branch_and_tree('zip')
         self.build_tree(['zip/a'])
         tree.add('a')
+        self.build_tree_contents([('zip/.bzrrules', '')])
+        tree.add('.bzrrules')
+        self.build_tree(['zip/.bzr-adir/', 'zip/.bzr-adir/afile'])
+        tree.add(['.bzr-adir/', '.bzr-adir/afile'])
 
         os.chdir('zip')
         self.run_bzr('ignore something')
         tree.commit('1')
 
         self.failUnless(tree.has_filename('.bzrignore'))
+        self.failUnless(tree.has_filename('.bzrrules'))
+        self.failUnless(tree.has_filename('.bzr-adir'))
+        self.failUnless(tree.has_filename('.bzr-adir/afile'))
         self.run_bzr('export test.zip')
 
         zfile = zipfile.ZipFile('test.zip')
@@ -139,12 +153,19 @@
         tree = self.make_branch_and_tree('dir')
         self.build_tree(['dir/a'])
         tree.add('a')
+        self.build_tree_contents([('dir/.bzrrules', '')])
+        tree.add('.bzrrules')
+        self.build_tree(['dir/.bzr-adir/', 'dir/.bzr-adir/afile'])
+        tree.add(['.bzr-adir/', '.bzr-adir/afile'])
 
         os.chdir('dir')
         self.run_bzr('ignore something')
         tree.commit('1')
 
         self.failUnless(tree.has_filename('.bzrignore'))
+        self.failUnless(tree.has_filename('.bzrrules'))
+        self.failUnless(tree.has_filename('.bzr-adir'))
+        self.failUnless(tree.has_filename('.bzr-adir/afile'))
         self.run_bzr('export direxport')
 
         files = sorted(os.listdir('direxport'))

=== modified file 'bzrlib/tests/blackbox/test_selftest.py'
--- bzrlib/tests/blackbox/test_selftest.py	2008-05-09 06:46:17 +0000
+++ bzrlib/tests/blackbox/test_selftest.py	2008-07-19 15:00:27 +0000
@@ -257,7 +257,7 @@
 class TestRunBzrSubprocess(TestCaseWithTransport):
 
     def test_run_bzr_subprocess(self):
-        """The run_bzr_helper_external comand behaves nicely."""
+        """The run_bzr_helper_external command behaves nicely."""
         result = self.run_bzr_subprocess('--version')
         result = self.run_bzr_subprocess(['--version'])
         result = self.run_bzr_subprocess('--version', retcode=None)

=== modified file 'bzrlib/tests/blackbox/test_status.py'
--- bzrlib/tests/blackbox/test_status.py	2008-05-01 20:10:42 +0000
+++ bzrlib/tests/blackbox/test_status.py	2008-07-30 07:52:22 +0000
@@ -438,13 +438,11 @@
         b_tree.add('b')
         b_tree.commit('b')
 
-        chdir('a')
-        self.run_bzr('merge ../b')
-        out, err = self.run_bzr('status --no-pending')
+        self.run_bzr('merge ../b', working_dir='a')
+        out, err = self.run_bzr('status --no-pending', working_dir='a')
         self.assertEquals(out, "added:\n  b\n")
 
 
-
 class TestStatusEncodings(TestCaseWithTransport):
     
     def setUp(self):

=== modified file 'bzrlib/tests/branch_implementations/test_hooks.py'
--- bzrlib/tests/branch_implementations/test_hooks.py	2008-07-17 16:26:45 +0000
+++ bzrlib/tests/branch_implementations/test_hooks.py	2008-07-25 06:42:08 +0000
@@ -16,6 +16,7 @@
 
 """Tests that branch classes implement hook callouts correctly."""
 
+from bzrlib.errors import HookFailed, TipChangeRejected
 from bzrlib.branch import Branch, ChangeBranchTipParams
 from bzrlib.revision import NULL_REVISION
 from bzrlib.tests import TestCaseWithMemoryTransport
@@ -90,7 +91,7 @@
         """
         hook_calls = []
         Branch.hooks.install_named_hook(
-            'pre_change_branch_tip', hook_calls.append, None)
+            prefix + '_change_branch_tip', hook_calls.append, None)
         return hook_calls
 
     def make_branch_with_revision_ids(self, *revision_ids):
@@ -124,10 +125,10 @@
             'pre_change_branch_tip', assertBranchAtRevision1, None)
         branch.set_last_revision_info(0, NULL_REVISION)
 
-    def test_reject_by_hook(self):
+    def test_hook_failure_prevents_change(self):
         """If a hook raises an exception, the change does not take effect.
         
-        Also, the exception will be propogated.
+        Also, a HookFailed exception will be raised.
         """
         branch = self.make_branch_with_revision_ids(
             'one-\xc2\xb5', 'two-\xc2\xb5')
@@ -137,8 +138,9 @@
             raise PearShapedError()
         Branch.hooks.install_named_hook(
             'pre_change_branch_tip', hook_that_raises, None)
-        self.assertRaises(
-            PearShapedError, branch.set_last_revision_info, 0, NULL_REVISION)
+        hook_failed_exc = self.assertRaises(
+            HookFailed, branch.set_last_revision_info, 0, NULL_REVISION)
+        self.assertIsInstance(hook_failed_exc.exc_value, PearShapedError)
         # The revision info is unchanged.
         self.assertEqual((2, 'two-\xc2\xb5'), branch.last_revision_info())
         
@@ -183,6 +185,22 @@
         self.assertEqual(len(hook_calls_1), 1)
         self.assertEqual(len(hook_calls_2), 1)
 
+    def test_explicit_reject_by_hook(self):
+        """If a hook raises TipChangeRejected, the change does not take effect.
+        
+        TipChangeRejected exceptions are propagated, not wrapped in HookFailed.
+        """
+        branch = self.make_branch_with_revision_ids(
+            'one-\xc2\xb5', 'two-\xc2\xb5')
+        def hook_that_rejects(params):
+            raise TipChangeRejected('rejection message')
+        Branch.hooks.install_named_hook(
+            'pre_change_branch_tip', hook_that_rejects, None)
+        self.assertRaises(
+            TipChangeRejected, branch.set_last_revision_info, 0, NULL_REVISION)
+        # The revision info is unchanged.
+        self.assertEqual((2, 'two-\xc2\xb5'), branch.last_revision_info())
+        
 
 class TestPostChangeBranchTip(ChangeBranchTipTestCase):
     """Tests for post_change_branch_tip hook.
@@ -243,3 +261,57 @@
         # Both hooks are called.
         self.assertEqual(len(hook_calls_1), 1)
         self.assertEqual(len(hook_calls_2), 1)
+
+
+class TestAllMethodsThatChangeTipWillRunHooks(ChangeBranchTipTestCase):
+    """Every method of Branch that changes a branch tip will invoke the
+    pre/post_change_branch_tip hooks.
+    """
+
+    def setUp(self):
+        ChangeBranchTipTestCase.setUp(self)
+        self.installPreAndPostHooks()
+        
+    def installPreAndPostHooks(self):
+        self.pre_hook_calls = self.install_logging_hook('pre')
+        self.post_hook_calls = self.install_logging_hook('post')
+
+    def resetHookCalls(self):
+        del self.pre_hook_calls[:], self.post_hook_calls[:]
+
+    def assertPreAndPostHooksWereInvoked(self):
+        # Check for len == 1, because the hooks should only be be invoked once
+        # by an operation.
+        self.assertEqual(1, len(self.pre_hook_calls))
+        self.assertEqual(1, len(self.post_hook_calls))
+
+    def test_set_revision_history(self):
+        branch = self.make_branch('')
+        branch.set_revision_history([])
+        self.assertPreAndPostHooksWereInvoked()
+
+    def test_set_last_revision_info(self):
+        branch = self.make_branch('')
+        branch.set_last_revision_info(0, NULL_REVISION)
+        self.assertPreAndPostHooksWereInvoked()
+
+    def test_generate_revision_history(self):
+        branch = self.make_branch('')
+        branch.generate_revision_history(NULL_REVISION)
+        self.assertPreAndPostHooksWereInvoked()
+
+    def test_pull(self):
+        source_branch = self.make_branch_with_revision_ids('rev-1', 'rev-2')
+        self.resetHookCalls()
+        destination_branch = self.make_branch('destination')
+        destination_branch.pull(source_branch)
+        self.assertPreAndPostHooksWereInvoked()
+
+    def test_push(self):
+        source_branch = self.make_branch_with_revision_ids('rev-1', 'rev-2')
+        self.resetHookCalls()
+        destination_branch = self.make_branch('destination')
+        source_branch.push(destination_branch)
+        self.assertPreAndPostHooksWereInvoked()
+
+        

=== modified file 'bzrlib/tests/branch_implementations/test_stacking.py'
--- bzrlib/tests/branch_implementations/test_stacking.py	2008-07-23 21:11:09 +0000
+++ bzrlib/tests/branch_implementations/test_stacking.py	2008-08-01 02:58:08 +0000
@@ -258,3 +258,81 @@
         unstacked.fetch(stacked.branch.repository, 'rev2')
         unstacked.get_revision('rev1')
         unstacked.get_revision('rev2')
+
+    def test_autopack_when_stacked(self):
+        # in bzr.dev as of 20080730, autopack was reported to fail in stacked
+        # repositories because of problems with text deltas spanning physical
+        # repository boundaries.  however, i didn't actually get this test to
+        # fail on that code. -- mbp
+        # see https://bugs.launchpad.net/bzr/+bug/252821
+        if not self.branch_format.supports_stacking():
+            raise TestNotApplicable("%r does not support stacking"
+                % self.branch_format)
+        stack_on = self.make_branch_and_tree('stack-on')
+        text_lines = ['line %d blah blah blah\n' % i for i in range(20)]
+        self.build_tree_contents([('stack-on/a', ''.join(text_lines))])
+        stack_on.add('a')
+        stack_on.commit('base commit')
+        stacked_dir = stack_on.bzrdir.sprout('stacked', stacked=True)
+        stacked_tree = stacked_dir.open_workingtree()
+        for i in range(20):
+            text_lines[0] = 'changed in %d\n' % i
+            self.build_tree_contents([('stacked/a', ''.join(text_lines))])
+            stacked_tree.commit('commit %d' % i)
+        stacked_tree.branch.repository.pack()
+        stacked_tree.branch.check()
+
+    def test_pull_delta_when_stacked(self):
+        if not self.branch_format.supports_stacking():
+            raise TestNotApplicable("%r does not support stacking"
+                % self.branch_format)
+        stack_on = self.make_branch_and_tree('stack-on')
+        text_lines = ['line %d blah blah blah\n' % i for i in range(20)]
+        self.build_tree_contents([('stack-on/a', ''.join(text_lines))])
+        stack_on.add('a')
+        stack_on.commit('base commit')
+        # make a stacked branch from the mainline
+        stacked_dir = stack_on.bzrdir.sprout('stacked', stacked=True)
+        stacked_tree = stacked_dir.open_workingtree()
+        # make a second non-stacked branch from the mainline
+        other_dir = stack_on.bzrdir.sprout('other')
+        other_tree = other_dir.open_workingtree()
+        text_lines[9] = 'changed in other\n'
+        self.build_tree_contents([('other/a', ''.join(text_lines))])
+        other_tree.commit('commit in other')
+        # this should have generated a delta; try to pull that across
+        # bug 252821 caused a RevisionNotPresent here...
+        stacked_tree.pull(other_tree.branch)
+        stacked_tree.branch.repository.pack()
+        stacked_tree.branch.check()
+
+    def test_fetch_revisions_with_file_changes(self):
+        # Fetching revisions including file changes into a stacked branch
+        # works without error.
+        # Make the source tree.
+        src_tree = self.make_branch_and_tree('src')
+        self.build_tree_contents([('src/a', 'content')])
+        src_tree.add('a')
+        src_tree.commit('first commit')
+
+        # Make the stacked-on branch.
+        src_tree.bzrdir.sprout('stacked-on')
+
+        # Make a branch stacked on it.
+        target = self.make_branch('target')
+        try:
+            target.set_stacked_on_url('../stacked-on')
+        except (errors.UnstackableRepositoryFormat,
+                errors.UnstackableBranchFormat):
+            raise TestNotApplicable('Format does not support stacking.')
+
+        # Change the source branch.
+        self.build_tree_contents([('src/a', 'new content')])
+        src_tree.commit('second commit', rev_id='rev2')
+
+        # Fetch changes to the target.
+        target.fetch(src_tree.branch)
+        rtree = target.repository.revision_tree('rev2')
+        rtree.lock_read()
+        self.addCleanup(rtree.unlock)
+        self.assertEqual('new content', rtree.get_file_by_path('a').read())

=== modified file 'bzrlib/tests/repository_implementations/test_repository.py'
--- bzrlib/tests/repository_implementations/test_repository.py	2008-07-15 05:06:13 +0000
+++ bzrlib/tests/repository_implementations/test_repository.py	2008-07-28 09:12:28 +0000
@@ -64,6 +64,24 @@
 
 class TestRepository(TestCaseWithRepository):
 
+    def test_attribute__fetch_order(self):
+        """Test the the _fetch_order attribute."""
+        tree = self.make_branch_and_tree('tree')
+        repo = tree.branch.repository
+        self.assertTrue(repo._fetch_order in ('topological', 'unsorted'))
+
+    def test_attribute__fetch_uses_deltas(self):
+        """Test the the _fetch_uses_deltas attribute."""
+        tree = self.make_branch_and_tree('tree')
+        repo = tree.branch.repository
+        self.assertTrue(repo._fetch_uses_deltas in (True, False))
+
+    def test_attribute__fetch_reconcile(self):
+        """Test the the _fetch_reconcile attribute."""
+        tree = self.make_branch_and_tree('tree')
+        repo = tree.branch.repository
+        self.assertTrue(repo._fetch_reconcile in (True, False))
+
     def test_attribute_inventories_store(self):
         """Test the existence of the inventories attribute."""
         tree = self.make_branch_and_tree('tree')

=== modified file 'bzrlib/tests/test_branch.py'
--- bzrlib/tests/test_branch.py	2008-07-16 07:30:18 +0000
+++ bzrlib/tests/test_branch.py	2008-07-22 19:48:40 +0000
@@ -243,19 +243,18 @@
         self.assertEqual('ftp://bazaar-vcs.org', branch.get_bound_location())
 
     def test_set_revision_history(self):
-        tree = self.make_branch_and_memory_tree('.',
-            format=self.get_format_name())
-        tree.lock_write()
-        try:
-            tree.add('.')
-            tree.commit('foo', rev_id='foo')
-            tree.commit('bar', rev_id='bar')
-            tree.branch.set_revision_history(['foo', 'bar'])
-            tree.branch.set_revision_history(['foo'])
-            self.assertRaises(errors.NotLefthandHistory,
-                              tree.branch.set_revision_history, ['bar'])
-        finally:
-            tree.unlock()
+        builder = self.make_branch_builder('.', format=self.get_format_name())
+        builder.build_snapshot('foo', None,
+            [('add', ('', None, 'directory', None))],
+            message='foo')
+        builder.build_snapshot('bar', None, [], message='bar')
+        branch = builder.get_branch()
+        branch.lock_write()
+        self.addCleanup(branch.unlock)
+        branch.set_revision_history(['foo', 'bar'])
+        branch.set_revision_history(['foo'])
+        self.assertRaises(errors.NotLefthandHistory,
+                          branch.set_revision_history, ['bar'])
 
     def do_checkout_test(self, lightweight=False):
         tree = self.make_branch_and_tree('source',

=== modified file 'bzrlib/tests/test_branchbuilder.py'
--- bzrlib/tests/test_branchbuilder.py	2007-04-27 06:16:29 +0000
+++ bzrlib/tests/test_branchbuilder.py	2008-07-29 16:16:36 +0000
@@ -18,6 +18,7 @@
 
 from bzrlib import (
     branch as _mod_branch,
+    errors,
     revision as _mod_revision,
     tests,
     )
@@ -71,3 +72,218 @@
         self.assertEqual(
             [rev_id1],
             branch.repository.get_revision(branch.last_revision()).parent_ids)
+
+
+class TestBranchBuilderBuildSnapshot(tests.TestCaseWithMemoryTransport):
+
+    def assertTreeShape(self, expected_shape, tree):
+        """Check that the tree shape matches expectations."""
+        tree.lock_read()
+        try:
+            entries = [(path, ie.file_id, ie.kind)
+                       for path, ie in tree.iter_entries_by_dir()]
+        finally:
+            tree.unlock()
+        self.assertEqual(expected_shape, entries)
+
+    def build_a_rev(self):
+        builder = BranchBuilder(self.get_transport().clone('foo'))
+        rev_id1 = builder.build_snapshot('A-id', None,
+            [('add', ('', 'a-root-id', 'directory', None)),
+             ('add', ('a', 'a-id', 'file', 'contents'))])
+        self.assertEqual('A-id', rev_id1)
+        return builder
+
+    def test_add_one_file(self):
+        builder = self.build_a_rev()
+        branch = builder.get_branch()
+        self.assertEqual((1, 'A-id'), branch.last_revision_info())
+        rev_tree = branch.repository.revision_tree('A-id')
+        rev_tree.lock_read()
+        self.addCleanup(rev_tree.unlock)
+        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
+                              (u'a', 'a-id', 'file')], rev_tree)
+        self.assertEqual('contents', rev_tree.get_file_text('a-id'))
+
+    def test_add_second_file(self):
+        builder = self.build_a_rev()
+        rev_id2 = builder.build_snapshot('B-id', None,
+            [('add', ('b', 'b-id', 'file', 'content_b'))])
+        self.assertEqual('B-id', rev_id2)
+        branch = builder.get_branch()
+        self.assertEqual((2, rev_id2), branch.last_revision_info())
+        rev_tree = branch.repository.revision_tree(rev_id2)
+        rev_tree.lock_read()
+        self.addCleanup(rev_tree.unlock)
+        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
+                              (u'a', 'a-id', 'file'),
+                              (u'b', 'b-id', 'file')], rev_tree)
+        self.assertEqual('content_b', rev_tree.get_file_text('b-id'))
+
+    def test_add_empty_dir(self):
+        builder = self.build_a_rev()
+        rev_id2 = builder.build_snapshot('B-id', None,
+            [('add', ('b', 'b-id', 'directory', None))])
+        rev_tree = builder.get_branch().repository.revision_tree('B-id')
+        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
+                              (u'a', 'a-id', 'file'),
+                              (u'b', 'b-id', 'directory'),
+                             ], rev_tree)
+
+    def test_commit_message_default(self):
+        builder = BranchBuilder(self.get_transport().clone('foo'))
+        rev_id = builder.build_snapshot(None, None,
+            [('add', (u'', None, 'directory', None))])
+        branch = builder.get_branch()
+        rev = branch.repository.get_revision(rev_id)
+        self.assertEqual(u'commit 1', rev.message)
+
+    def test_commit_message_supplied(self):
+        builder = BranchBuilder(self.get_transport().clone('foo'))
+        rev_id = builder.build_snapshot(None, None,
+            [('add', (u'', None, 'directory', None))],
+            message=u'Foo')
+        branch = builder.get_branch()
+        rev = branch.repository.get_revision(rev_id)
+        self.assertEqual(u'Foo', rev.message)
+
+    def test_modify_file(self):
+        builder = self.build_a_rev()
+        rev_id2 = builder.build_snapshot('B-id', None,
+            [('modify', ('a-id', 'new\ncontent\n'))])
+        self.assertEqual('B-id', rev_id2)
+        branch = builder.get_branch()
+        rev_tree = branch.repository.revision_tree(rev_id2)
+        rev_tree.lock_read()
+        self.addCleanup(rev_tree.unlock)
+        self.assertEqual('new\ncontent\n', rev_tree.get_file_text('a-id'))
+
+    def test_delete_file(self):
+        builder = self.build_a_rev()
+        rev_id2 = builder.build_snapshot('B-id', None,
+            [('unversion', 'a-id')])
+        self.assertEqual('B-id', rev_id2)
+        branch = builder.get_branch()
+        rev_tree = branch.repository.revision_tree(rev_id2)
+        rev_tree.lock_read()
+        self.addCleanup(rev_tree.unlock)
+        self.assertTreeShape([(u'', 'a-root-id', 'directory')], rev_tree)
+
+    def test_delete_directory(self):
+        builder = self.build_a_rev()
+        rev_id2 = builder.build_snapshot('B-id', None,
+            [('add', ('b', 'b-id', 'directory', None)),
+             ('add', ('b/c', 'c-id', 'file', 'foo\n')),
+             ('add', ('b/d', 'd-id', 'directory', None)),
+             ('add', ('b/d/e', 'e-id', 'file', 'eff\n')),
+            ])
+        rev_tree = builder.get_branch().repository.revision_tree('B-id')
+        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
+                              (u'a', 'a-id', 'file'),
+                              (u'b', 'b-id', 'directory'),
+                              (u'b/c', 'c-id', 'file'),
+                              (u'b/d', 'd-id', 'directory'),
+                              (u'b/d/e', 'e-id', 'file')], rev_tree)
+        # Removing a directory removes all child dirs
+        builder.build_snapshot('C-id', None, [('unversion', 'b-id')])
+        rev_tree = builder.get_branch().repository.revision_tree('C-id')
+        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
+                              (u'a', 'a-id', 'file'),
+                             ], rev_tree)
+
+    def test_unknown_action(self):
+        builder = self.build_a_rev()
+        e = self.assertRaises(ValueError,
+            builder.build_snapshot, 'B-id', None, [('weirdo', ('foo',))])
+        self.assertEqual('Unknown build action: "weirdo"', str(e))
+
+    # TODO: rename a file/directory, but rename isn't supported by the
+    #       MemoryTree api yet, so for now we wait until it is used
+
+    def test_set_parent(self):
+        builder = self.build_a_rev()
+        builder.start_series()
+        self.addCleanup(builder.finish_series)
+        builder.build_snapshot('B-id', ['A-id'],
+            [('modify', ('a-id', 'new\ncontent\n'))])
+        builder.build_snapshot('C-id', ['A-id'], 
+            [('add', ('c', 'c-id', 'file', 'alt\ncontent\n'))])
+        # We should now have a graph:
+        #   A
+        #   |\
+        #   C B
+        # And not A => B => C
+        repo = builder.get_branch().repository
+        self.assertEqual({'B-id': ('A-id',), 'C-id': ('A-id',)},
+                         repo.get_parent_map(['B-id', 'C-id']))
+        b_tree = repo.revision_tree('B-id')
+        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
+                              (u'a', 'a-id', 'file'),
+                             ], b_tree)
+        self.assertEqual('new\ncontent\n', b_tree.get_file_text('a-id'))
+
+        # We should still be using the content from A in C, not from B
+        c_tree = repo.revision_tree('C-id')
+        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
+                              (u'a', 'a-id', 'file'),
+                              (u'c', 'c-id', 'file'),
+                             ], c_tree)
+        self.assertEqual('contents', c_tree.get_file_text('a-id'))
+        self.assertEqual('alt\ncontent\n', c_tree.get_file_text('c-id'))
+
+    def test_set_merge_parent(self):
+        builder = self.build_a_rev()
+        builder.start_series()
+        self.addCleanup(builder.finish_series)
+        builder.build_snapshot('B-id', ['A-id'],
+            [('add', ('b', 'b-id', 'file', 'b\ncontent\n'))])
+        builder.build_snapshot('C-id', ['A-id'],
+            [('add', ('c', 'c-id', 'file', 'alt\ncontent\n'))])
+        builder.build_snapshot('D-id', ['B-id', 'C-id'], [])
+        repo = builder.get_branch().repository
+        self.assertEqual({'B-id': ('A-id',), 'C-id': ('A-id',),
+                          'D-id': ('B-id', 'C-id')},
+                         repo.get_parent_map(['B-id', 'C-id', 'D-id']))
+        d_tree = repo.revision_tree('D-id')
+        # Note: by default a merge node does *not* pull in the changes from the
+        #       merged tree, you have to supply it yourself.
+        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
+                              (u'a', 'a-id', 'file'),
+                              (u'b', 'b-id', 'file'),
+                             ], d_tree)
+
+    def test_set_merge_parent_and_contents(self):
+        builder = self.build_a_rev()
+        builder.start_series()
+        self.addCleanup(builder.finish_series)
+        builder.build_snapshot('B-id', ['A-id'],
+            [('add', ('b', 'b-id', 'file', 'b\ncontent\n'))])
+        builder.build_snapshot('C-id', ['A-id'],
+            [('add', ('c', 'c-id', 'file', 'alt\ncontent\n'))])
+        builder.build_snapshot('D-id', ['B-id', 'C-id'],
+            [('add', ('c', 'c-id', 'file', 'alt\ncontent\n'))])
+        repo = builder.get_branch().repository
+        self.assertEqual({'B-id': ('A-id',), 'C-id': ('A-id',),
+                          'D-id': ('B-id', 'C-id')},
+                         repo.get_parent_map(['B-id', 'C-id', 'D-id']))
+        d_tree = repo.revision_tree('D-id')
+        self.assertTreeShape([(u'', 'a-root-id', 'directory'),
+                              (u'a', 'a-id', 'file'),
+                              (u'b', 'b-id', 'file'),
+                              (u'c', 'c-id', 'file'),
+                             ], d_tree)
+        # Because we copied the exact text into *this* tree, the 'c' file
+        # should look like it was not modified in the merge
+        self.assertEqual('C-id', d_tree.inventory['c-id'].revision)
+
+    def test_start_finish_series(self):
+        builder = BranchBuilder(self.get_transport().clone('foo'))
+        builder.start_series()
+        try:
+            self.assertIsNot(None, builder._tree)
+            self.assertEqual('w', builder._tree._lock_mode)
+            self.assertTrue(builder._branch.is_locked())
+        finally:
+            builder.finish_series()
+        self.assertIs(None, builder._tree)
+        self.assertFalse(builder._branch.is_locked())

=== modified file 'bzrlib/tests/test_bzrdir.py'
--- bzrlib/tests/test_bzrdir.py	2008-07-16 07:30:18 +0000
+++ bzrlib/tests/test_bzrdir.py	2008-08-01 07:30:20 +0000
@@ -42,6 +42,7 @@
                            )
 from bzrlib.tests import (
     TestCase,
+    TestCaseWithMemoryTransport,
     TestCaseWithTransport,
     TestSkipped,
     test_sftp_transport
@@ -1113,3 +1114,72 @@
         b = bzrdir.BzrDir.create(urlutils.local_path_to_url('.'))
         self.build_tree(['a'])
         self.assertEquals(['a'], self.get_ls())
+
+
+class _TestBzrDirFormat(bzrdir.BzrDirMetaFormat1):
+    """Test BzrDirFormat implementation for TestBzrDirSprout."""
+
+    def _open(self, transport):
+        return _TestBzrDir(transport, self)
+
+
+class _TestBzrDir(bzrdir.BzrDirMeta1):
+    """Test BzrDir implementation for TestBzrDirSprout.
+    
+    When created a _TestBzrDir already has repository and a branch.  The branch
+    is a test double as well.
+    """
+
+    def __init__(self, *args, **kwargs):
+        super(_TestBzrDir, self).__init__(*args, **kwargs)
+        self.test_branch = _TestBranch()
+        self.test_branch.repository = self.create_repository()
+
+    def open_branch(self, unsupported=False):
+        return self.test_branch
+
+    def cloning_metadir(self):
+        return _TestBzrDirFormat()
+
+
+class _TestBranch(bzrlib.branch.Branch):
+    """Test Branch implementation for TestBzrDirSprout."""
+
+    def __init__(self, *args, **kwargs):
+        super(_TestBranch, self).__init__(*args, **kwargs)
+        self.calls = []
+    
+    def sprout(self, *args, **kwargs):
+        self.calls.append('sprout')
+
+
+class TestBzrDirSprout(TestCaseWithMemoryTransport):
+
+    def test_sprout_uses_branch_sprout(self):
+        """BzrDir.sprout calls Branch.sprout.
+
+        Usually, BzrDir.sprout should delegate to the branch's sprout method
+        for part of the work.  This allows the source branch to control the
+        choice of format for the new branch.
+        
+        There are exceptions, but this tests avoids them:
+          - if there's no branch in the source bzrdir,
+          - or if the stacking has been requested and the format needs to be
+            overridden to satisfy that.
+        """
+        # Make an instrumented bzrdir.
+        t = self.get_transport('source')
+        t.ensure_base()
+        source_bzrdir = _TestBzrDirFormat().initialize_on_transport(t)
+        # The instrumented bzrdir has a test_branch attribute that logs calls
+        # made to the branch contained in that bzrdir.  Initially the test
+        # branch exists but no calls have been made to it.
+        self.assertEqual([], source_bzrdir.test_branch.calls)
+
+        # Sprout the bzrdir
+        target_url = self.get_url('target')
+        result = source_bzrdir.sprout(target_url, recurse='no')
+
+        # The bzrdir called the branch's sprout method.
+        self.assertEqual(['sprout'], source_bzrdir.test_branch.calls)
+        

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2008-07-14 07:47:45 +0000
+++ bzrlib/tests/test_errors.py	2008-07-30 04:34:59 +0000
@@ -18,6 +18,7 @@
 
 """Tests for the formatting and construction of errors."""
 
+import sys
 from bzrlib import (
     bzrdir,
     errors,
@@ -383,6 +384,15 @@
             host='ahost', port=444, msg='Unable to connect to ssh host',
             orig_error='my_error')
 
+    def test_target_not_branch(self):
+        """Test the formatting of TargetNotBranch."""
+        error = errors.TargetNotBranch('foo')
+        self.assertEqual(
+            "Your branch does not have all of the revisions required in "
+            "order to merge this merge directive and the target "
+            "location specified in the merge directive is not a branch: "
+            "foo.", str(error))
+
     def test_malformed_bug_identifier(self):
         """Test the formatting of MalformedBugIdentifier."""
         error = errors.MalformedBugIdentifier('bogus', 'reason for bogosity')
@@ -510,6 +520,27 @@
         err = errors.UnknownRules(['foo', 'bar'])
         self.assertEquals("Unknown rules detected: foo, bar.", str(err))
 
+    def test_hook_failed(self):
+        # Create an exc_info tuple by raising and catching an exception.
+        try:
+            1/0
+        except ZeroDivisionError:
+            exc_info = sys.exc_info()
+        err = errors.HookFailed('hook stage', 'hook name', exc_info)
+        self.assertStartsWith(
+            str(err), 'Hook \'hook name\' during hook stage failed:\n')
+        self.assertEndsWith(
+            str(err), 'integer division or modulo by zero')
+
+    def test_tip_change_rejected(self):
+        err = errors.TipChangeRejected(u'Unicode message\N{INTERROBANG}')
+        self.assertEquals(
+            u'Tip change rejected: Unicode message\N{INTERROBANG}',
+            unicode(err))
+        self.assertEquals(
+            'Tip change rejected: Unicode message\xe2\x80\xbd',
+            str(err))
+
 
 class PassThroughError(errors.BzrError):
     

=== modified file 'bzrlib/tests/test_fetch.py'
--- bzrlib/tests/test_fetch.py	2008-06-11 04:20:16 +0000
+++ bzrlib/tests/test_fetch.py	2008-07-28 08:43:03 +0000
@@ -170,8 +170,11 @@
         knit3_tree = self.make_branch_and_tree('knit3',
             format='dirstate-with-subtree')
         knit3_tree.commit('blah')
-        self.assertRaises(errors.IncompatibleRepositories,
-                          knit_tree.branch.fetch, knit3_tree.branch)
+        e = self.assertRaises(errors.IncompatibleRepositories,
+                              knit_tree.branch.fetch, knit3_tree.branch)
+        self.assertContainsRe(str(e),
+            r"(?m).*/knit.*\nis not compatible with\n.*/knit3/.*\n"
+            r"different rich-root support")
 
 
 class TestMergeFetch(TestCaseWithTransport):

=== modified file 'bzrlib/tests/test_memorytree.py'
--- bzrlib/tests/test_memorytree.py	2007-11-21 23:42:50 +0000
+++ bzrlib/tests/test_memorytree.py	2008-07-22 18:12:25 +0000
@@ -125,6 +125,22 @@
         self.assertEqual('barshoom', tree.get_file('foo-id').read())
         tree.unlock()
 
+    def test_add_in_subdir(self):
+        branch = self.make_branch('branch')
+        tree = MemoryTree.create_on_branch(branch)
+        tree.lock_write()
+        self.addCleanup(tree.unlock)
+        tree.add([''], ['root-id'], ['directory'])
+        # Unfortunately, the only way to 'mkdir' is to call 'tree.mkdir', but
+        # that *always* adds the directory as well. So if you want to create a
+        # file in a subdirectory, you have to split out the 'mkdir()' calls
+        # from the add and put_file_bytes_non_atomic calls. :(
+        tree.mkdir('adir', 'dir-id')
+        tree.add(['adir/afile'], ['file-id'], ['file'])
+        self.assertEqual('adir/afile', tree.id2path('file-id'))
+        self.assertEqual('adir', tree.id2path('dir-id'))
+        tree.put_file_bytes_non_atomic('file-id', 'barshoom')
+
     def test_commit_trivial(self):
         """Smoke test for commit on a MemoryTree.
 

=== modified file 'bzrlib/tests/test_merge_directive.py'
--- bzrlib/tests/test_merge_directive.py	2008-05-23 10:39:44 +0000
+++ bzrlib/tests/test_merge_directive.py	2008-07-28 12:40:59 +0000
@@ -576,6 +576,17 @@
             branch_c.base, base_revision_id='rev2a')
         revision = md.install_revisions(tree_b.branch.repository)
 
+    def test_handle_target_not_a_branch(self):
+        tree_a, tree_b, branch_c = self.make_trees()
+        branch_c.pull(tree_a.branch)
+        self.build_tree_contents([('tree_a/file', 'content_q\ncontent_r\n')])
+        tree_a.commit('rev3a', rev_id='rev3a')
+        md = self.from_objects(tree_a.branch.repository, 'rev3a', 500, 36,
+            branch_c.base, base_revision_id='rev2a')
+        md.target_branch = self.get_url('not-a-branch')
+        self.assertRaises(errors.TargetNotBranch, md.install_revisions,
+                tree_b.branch.repository)
+
 
 class TestMergeDirective1Branch(tests.TestCaseWithTransport,
     TestMergeDirectiveBranch):

=== modified file 'bzrlib/tests/test_options.py'
--- bzrlib/tests/test_options.py	2007-09-03 01:50:29 +0000
+++ bzrlib/tests/test_options.py	2008-08-05 00:43:28 +0000
@@ -17,15 +17,12 @@
 import re
 
 from bzrlib import (
-    builtins,
     bzrdir,
     commands,
     errors,
     option,
-    repository,
-    symbol_versioning,
     )
-from bzrlib.builtins import cmd_commit, cmd_log, cmd_status
+from bzrlib.builtins import cmd_commit
 from bzrlib.commands import Command, parse_args
 from bzrlib.tests import TestCase
 from bzrlib.repofmt import knitrepo
@@ -41,16 +38,18 @@
 
     def test_parse_args(self):
         """Option parser"""
-        eq = self.assertEquals
-        eq(parse_args(cmd_commit(), ['--help']),
-           ([], {'fixes': [], 'help': True}))
-        eq(parse_args(cmd_commit(), ['--message=biter']),
-           ([], {'fixes': [], 'message': 'biter'}))
+        # XXX: Using cmd_commit makes these tests overly sensitive to changes
+        # to cmd_commit, when they are meant to be about option parsing in
+        # general.
+        self.assertEqual(parse_args(cmd_commit(), ['--help']),
+           ([], {'exclude': [], 'fixes': [], 'help': True}))
+        self.assertEqual(parse_args(cmd_commit(), ['--message=biter']),
+           ([], {'exclude': [], 'fixes': [], 'message': 'biter'}))
 
     def test_no_more_opts(self):
         """Terminated options"""
-        self.assertEquals(parse_args(cmd_commit(), ['--', '-file-with-dashes']),
-                          (['-file-with-dashes'], {'fixes': []}))
+        self.assertEqual(parse_args(cmd_commit(), ['--', '-file-with-dashes']),
+                          (['-file-with-dashes'], {'exclude': [], 'fixes': []}))
 
     def test_option_help(self):
         """Options have help strings."""
@@ -67,7 +66,7 @@
     def test_option_arg_help(self):
         """Help message shows option arguments."""
         out, err = self.run_bzr('help commit')
-        self.assertEquals(err, '')
+        self.assertEqual(err, '')
         self.assertContainsRe(out, r'--file[ =]MSGFILE')
 
     def test_unknown_short_opt(self):
@@ -81,8 +80,7 @@
 
     def test_allow_dash(self):
         """Test that we can pass a plain '-' as an argument."""
-        self.assertEqual(
-            (['-'], {'fixes': []}), parse_args(cmd_commit(), ['-']))
+        self.assertEqual((['-']), parse_args(cmd_commit(), ['-'])[0])
 
     def parse(self, options, args):
         parser = option.get_optparser(dict((o.name, o) for o in options))

=== added file 'bzrlib/tests/test_pack_repository.py'
--- bzrlib/tests/test_pack_repository.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_pack_repository.py	2008-08-04 02:54:44 +0000
@@ -0,0 +1,619 @@
+# Copyright (C) 2008 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for pack repositories.
+
+These tests are repeated for all pack-based repository formats.
+"""
+
+from cStringIO import StringIO
+from stat import S_ISDIR
+
+from bzrlib.index import GraphIndex, InMemoryGraphIndex
+from bzrlib import (
+    bzrdir,
+    errors,
+    inventory,
+    progress,
+    repository,
+    revision as _mod_revision,
+    symbol_versioning,
+    tests,
+    ui,
+    upgrade,
+    workingtree,
+    )
+from bzrlib.tests import (
+    TestCase,
+    TestCaseWithTransport,
+    TestNotApplicable,
+    TestSkipped,
+    )
+from bzrlib.transport import (
+    fakenfs,
+    get_transport,
+    )
+
+
+class TestPackRepository(TestCaseWithTransport):
+    """Tests to be repeated across all pack-based formats.
+
+    The following are populated from the test scenario:
+
+    :ivar format_name: Registered name fo the format to test.
+    :ivar format_string: On-disk format marker.
+    :ivar format_supports_external_lookups: Boolean.
+    """
+
+    def get_format(self):
+        return bzrdir.format_registry.make_bzrdir(self.format_name)
+
+    def test_attribute__fetch_order(self):
+        """Packs do not need ordered data retrieval."""
+        format = self.get_format()
+        repo = self.make_repository('.', format=format)
+        self.assertEqual('unsorted', repo._fetch_order)
+
+    def test_attribute__fetch_uses_deltas(self):
+        """Packs reuse deltas."""
+        format = self.get_format()
+        repo = self.make_repository('.', format=format)
+        self.assertEqual(True, repo._fetch_uses_deltas)
+
+    def test_disk_layout(self):
+        format = self.get_format()
+        repo = self.make_repository('.', format=format)
+        # in case of side effects of locking.
+        repo.lock_write()
+        repo.unlock()
+        t = repo.bzrdir.get_repository_transport(None)
+        self.check_format(t)
+        # XXX: no locks left when unlocked at the moment
+        # self.assertEqualDiff('', t.get('lock').read())
+        self.check_databases(t)
+
+    def check_format(self, t):
+        self.assertEqualDiff(
+            self.format_string, # from scenario
+            t.get('format').read())
+
+    def assertHasNoKndx(self, t, knit_name):
+        """Assert that knit_name has no index on t."""
+        self.assertFalse(t.has(knit_name + '.kndx'))
+
+    def assertHasNoKnit(self, t, knit_name):
+        """Assert that knit_name exists on t."""
+        # no default content
+        self.assertFalse(t.has(knit_name + '.knit'))
+
+    def check_databases(self, t):
+        """check knit content for a repository."""
+        # check conversion worked
+        self.assertHasNoKndx(t, 'inventory')
+        self.assertHasNoKnit(t, 'inventory')
+        self.assertHasNoKndx(t, 'revisions')
+        self.assertHasNoKnit(t, 'revisions')
+        self.assertHasNoKndx(t, 'signatures')
+        self.assertHasNoKnit(t, 'signatures')
+        self.assertFalse(t.has('knits'))
+        # revision-indexes file-container directory
+        self.assertEqual([],
+            list(GraphIndex(t, 'pack-names', None).iter_all_entries()))
+        self.assertTrue(S_ISDIR(t.stat('packs').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('upload').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('indices').st_mode))
+        self.assertTrue(S_ISDIR(t.stat('obsolete_packs').st_mode))
+
+    def test_shared_disk_layout(self):
+        format = self.get_format()
+        repo = self.make_repository('.', shared=True, format=format)
+        # we want:
+        t = repo.bzrdir.get_repository_transport(None)
+        self.check_format(t)
+        # XXX: no locks left when unlocked at the moment
+        # self.assertEqualDiff('', t.get('lock').read())
+        # We should have a 'shared-storage' marker file.
+        self.assertEqualDiff('', t.get('shared-storage').read())
+        self.check_databases(t)
+
+    def test_shared_no_tree_disk_layout(self):
+        format = self.get_format()
+        repo = self.make_repository('.', shared=True, format=format)
+        repo.set_make_working_trees(False)
+        # we want:
+        t = repo.bzrdir.get_repository_transport(None)
+        self.check_format(t)
+        # XXX: no locks left when unlocked at the moment
+        # self.assertEqualDiff('', t.get('lock').read())
+        # We should have a 'shared-storage' marker file.
+        self.assertEqualDiff('', t.get('shared-storage').read())
+        # We should have a marker for the no-working-trees flag.
+        self.assertEqualDiff('', t.get('no-working-trees').read())
+        # The marker should go when we toggle the setting.
+        repo.set_make_working_trees(True)
+        self.assertFalse(t.has('no-working-trees'))
+        self.check_databases(t)
+
+    def test_adding_revision_creates_pack_indices(self):
+        format = self.get_format()
+        tree = self.make_branch_and_tree('.', format=format)
+        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
+        self.assertEqual([],
+            list(GraphIndex(trans, 'pack-names', None).iter_all_entries()))
+        tree.commit('foobarbaz')
+        index = GraphIndex(trans, 'pack-names', None)
+        index_nodes = list(index.iter_all_entries())
+        self.assertEqual(1, len(index_nodes))
+        node = index_nodes[0]
+        name = node[1][0]
+        # the pack sizes should be listed in the index
+        pack_value = node[2]
+        sizes = [int(digits) for digits in pack_value.split(' ')]
+        for size, suffix in zip(sizes, ['.rix', '.iix', '.tix', '.six']):
+            stat = trans.stat('indices/%s%s' % (name, suffix))
+            self.assertEqual(size, stat.st_size)
+
+    def test_pulling_nothing_leads_to_no_new_names(self):
+        format = self.get_format()
+        tree1 = self.make_branch_and_tree('1', format=format)
+        tree2 = self.make_branch_and_tree('2', format=format)
+        tree1.branch.repository.fetch(tree2.branch.repository)
+        trans = tree1.branch.repository.bzrdir.get_repository_transport(None)
+        self.assertEqual([],
+            list(GraphIndex(trans, 'pack-names', None).iter_all_entries()))
+
+    def test_commit_across_pack_shape_boundary_autopacks(self):
+        format = self.get_format()
+        tree = self.make_branch_and_tree('.', format=format)
+        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
+        # This test could be a little cheaper by replacing the packs
+        # attribute on the repository to allow a different pack distribution
+        # and max packs policy - so we are checking the policy is honoured
+        # in the test. But for now 11 commits is not a big deal in a single
+        # test.
+        for x in range(9):
+            tree.commit('commit %s' % x)
+        # there should be 9 packs:
+        index = GraphIndex(trans, 'pack-names', None)
+        self.assertEqual(9, len(list(index.iter_all_entries())))
+        # insert some files in obsolete_packs which should be removed by pack.
+        trans.put_bytes('obsolete_packs/foo', '123')
+        trans.put_bytes('obsolete_packs/bar', '321')
+        # committing one more should coalesce to 1 of 10.
+        tree.commit('commit triggering pack')
+        index = GraphIndex(trans, 'pack-names', None)
+        self.assertEqual(1, len(list(index.iter_all_entries())))
+        # packing should not damage data
+        tree = tree.bzrdir.open_workingtree()
+        check_result = tree.branch.repository.check(
+            [tree.branch.last_revision()])
+        # We should have 50 (10x5) files in the obsolete_packs directory.
+        obsolete_files = list(trans.list_dir('obsolete_packs'))
+        self.assertFalse('foo' in obsolete_files)
+        self.assertFalse('bar' in obsolete_files)
+        self.assertEqual(50, len(obsolete_files))
+        # XXX: Todo check packs obsoleted correctly - old packs and indices
+        # in the obsolete_packs directory.
+        large_pack_name = list(index.iter_all_entries())[0][1][0]
+        # finally, committing again should not touch the large pack.
+        tree.commit('commit not triggering pack')
+        index = GraphIndex(trans, 'pack-names', None)
+        self.assertEqual(2, len(list(index.iter_all_entries())))
+        pack_names = [node[1][0] for node in index.iter_all_entries()]
+        self.assertTrue(large_pack_name in pack_names)
+
+    def test_fail_obsolete_deletion(self):
+        # failing to delete obsolete packs is not fatal
+        format = self.get_format()
+        server = fakenfs.FakeNFSServer()
+        server.setUp()
+        self.addCleanup(server.tearDown)
+        transport = get_transport(server.get_url())
+        bzrdir = self.get_format().initialize_on_transport(transport)
+        repo = bzrdir.create_repository()
+        repo_transport = bzrdir.get_repository_transport(None)
+        self.assertTrue(repo_transport.has('obsolete_packs'))
+        # these files are in use by another client and typically can't be deleted
+        repo_transport.put_bytes('obsolete_packs/.nfsblahblah', 'contents')
+        repo._pack_collection._clear_obsolete_packs()
+        self.assertTrue(repo_transport.has('obsolete_packs/.nfsblahblah'))
+
+    def test_pack_after_two_commits_packs_everything(self):
+        format = self.get_format()
+        tree = self.make_branch_and_tree('.', format=format)
+        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
+        tree.commit('start')
+        tree.commit('more work')
+        tree.branch.repository.pack()
+        # there should be 1 pack:
+        index = GraphIndex(trans, 'pack-names', None)
+        self.assertEqual(1, len(list(index.iter_all_entries())))
+        self.assertEqual(2, len(tree.branch.repository.all_revision_ids()))
+
+    def test_pack_layout(self):
+        format = self.get_format()
+        tree = self.make_branch_and_tree('.', format=format)
+        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
+        tree.commit('start', rev_id='1')
+        tree.commit('more work', rev_id='2')
+        tree.branch.repository.pack()
+        tree.lock_read()
+        self.addCleanup(tree.unlock)
+        pack = tree.branch.repository._pack_collection.get_pack_by_name(
+            tree.branch.repository._pack_collection.names()[0])
+        # revision access tends to be tip->ancestor, so ordering that way on 
+        # disk is a good idea.
+        for _1, key, val, refs in pack.revision_index.iter_all_entries():
+            if key == ('1',):
+                pos_1 = int(val[1:].split()[0])
+            else:
+                pos_2 = int(val[1:].split()[0])
+        self.assertTrue(pos_2 < pos_1)
+
+    def test_pack_repositories_support_multiple_write_locks(self):
+        format = self.get_format()
+        self.make_repository('.', shared=True, format=format)
+        r1 = repository.Repository.open('.')
+        r2 = repository.Repository.open('.')
+        r1.lock_write()
+        self.addCleanup(r1.unlock)
+        r2.lock_write()
+        r2.unlock()
+
+    def _add_text(self, repo, fileid):
+        """Add a text to the repository within a write group."""
+        repo.texts.add_lines((fileid, 'samplerev+'+fileid), [], [])
+
+    def test_concurrent_writers_merge_new_packs(self):
+        format = self.get_format()
+        self.make_repository('.', shared=True, format=format)
+        r1 = repository.Repository.open('.')
+        r2 = repository.Repository.open('.')
+        r1.lock_write()
+        try:
+            # access enough data to load the names list
+            list(r1.all_revision_ids())
+            r2.lock_write()
+            try:
+                # access enough data to load the names list
+                list(r2.all_revision_ids())
+                r1.start_write_group()
+                try:
+                    r2.start_write_group()
+                    try:
+                        self._add_text(r1, 'fileidr1')
+                        self._add_text(r2, 'fileidr2')
+                    except:
+                        r2.abort_write_group()
+                        raise
+                except:
+                    r1.abort_write_group()
+                    raise
+                # both r1 and r2 have open write groups with data in them
+                # created while the other's write group was open.
+                # Commit both which requires a merge to the pack-names.
+                try:
+                    r1.commit_write_group()
+                except:
+                    r1.abort_write_group()
+                    r2.abort_write_group()
+                    raise
+                r2.commit_write_group()
+                # tell r1 to reload from disk
+                r1._pack_collection.reset()
+                # Now both repositories should know about both names
+                r1._pack_collection.ensure_loaded()
+                r2._pack_collection.ensure_loaded()
+                self.assertEqual(r1._pack_collection.names(), r2._pack_collection.names())
+                self.assertEqual(2, len(r1._pack_collection.names()))
+            finally:
+                r2.unlock()
+        finally:
+            r1.unlock()
+
+    def test_concurrent_writer_second_preserves_dropping_a_pack(self):
+        format = self.get_format()
+        self.make_repository('.', shared=True, format=format)
+        r1 = repository.Repository.open('.')
+        r2 = repository.Repository.open('.')
+        # add a pack to drop
+        r1.lock_write()
+        try:
+            r1.start_write_group()
+            try:
+                self._add_text(r1, 'fileidr1')
+            except:
+                r1.abort_write_group()
+                raise
+            else:
+                r1.commit_write_group()
+            r1._pack_collection.ensure_loaded()
+            name_to_drop = r1._pack_collection.all_packs()[0].name
+        finally:
+            r1.unlock()
+        r1.lock_write()
+        try:
+            # access enough data to load the names list
+            list(r1.all_revision_ids())
+            r2.lock_write()
+            try:
+                # access enough data to load the names list
+                list(r2.all_revision_ids())
+                r1._pack_collection.ensure_loaded()
+                try:
+                    r2.start_write_group()
+                    try:
+                        # in r1, drop the pack
+                        r1._pack_collection._remove_pack_from_memory(
+                            r1._pack_collection.get_pack_by_name(name_to_drop))
+                        # in r2, add a pack
+                        self._add_text(r2, 'fileidr2')
+                    except:
+                        r2.abort_write_group()
+                        raise
+                except:
+                    r1._pack_collection.reset()
+                    raise
+                # r1 has a changed names list, and r2 an open write groups with
+                # changes.
+                # save r1, and then commit the r2 write group, which requires a
+                # merge to the pack-names, which should not reinstate
+                # name_to_drop
+                try:
+                    r1._pack_collection._save_pack_names()
+                    r1._pack_collection.reset()
+                except:
+                    r2.abort_write_group()
+                    raise
+                try:
+                    r2.commit_write_group()
+                except:
+                    r2.abort_write_group()
+                    raise
+                # Now both repositories should now about just one name.
+                r1._pack_collection.ensure_loaded()
+                r2._pack_collection.ensure_loaded()
+                self.assertEqual(r1._pack_collection.names(), r2._pack_collection.names())
+                self.assertEqual(1, len(r1._pack_collection.names()))
+                self.assertFalse(name_to_drop in r1._pack_collection.names())
+            finally:
+                r2.unlock()
+        finally:
+            r1.unlock()
+
+    def test_lock_write_does_not_physically_lock(self):
+        repo = self.make_repository('.', format=self.get_format())
+        repo.lock_write()
+        self.addCleanup(repo.unlock)
+        self.assertFalse(repo.get_physical_lock_status())
+
+    def prepare_for_break_lock(self):
+        # Setup the global ui factory state so that a break-lock method call
+        # will find usable input in the input stream.
+        old_factory = ui.ui_factory
+        def restoreFactory():
+            ui.ui_factory = old_factory
+        self.addCleanup(restoreFactory)
+        ui.ui_factory = ui.SilentUIFactory()
+        ui.ui_factory.stdin = StringIO("y\n")
+
+    def test_break_lock_breaks_physical_lock(self):
+        repo = self.make_repository('.', format=self.get_format())
+        repo._pack_collection.lock_names()
+        repo2 = repository.Repository.open('.')
+        self.assertTrue(repo.get_physical_lock_status())
+        self.prepare_for_break_lock()
+        repo2.break_lock()
+        self.assertFalse(repo.get_physical_lock_status())
+
+    def test_broken_physical_locks_error_on__unlock_names_lock(self):
+        repo = self.make_repository('.', format=self.get_format())
+        repo._pack_collection.lock_names()
+        self.assertTrue(repo.get_physical_lock_status())
+        repo2 = repository.Repository.open('.')
+        self.prepare_for_break_lock()
+        repo2.break_lock()
+        self.assertRaises(errors.LockBroken, repo._pack_collection._unlock_names)
+
+    def test_fetch_without_find_ghosts_ignores_ghosts(self):
+        # we want two repositories at this point:
+        # one with a revision that is a ghost in the other
+        # repository.
+        # 'ghost' is present in has_ghost, 'ghost' is absent in 'missing_ghost'.
+        # 'references' is present in both repositories, and 'tip' is present
+        # just in has_ghost.
+        # has_ghost       missing_ghost
+        #------------------------------
+        # 'ghost'             -
+        # 'references'    'references'
+        # 'tip'               -
+        # In this test we fetch 'tip' which should not fetch 'ghost'
+        has_ghost = self.make_repository('has_ghost', format=self.get_format())
+        missing_ghost = self.make_repository('missing_ghost',
+            format=self.get_format())
+
+        def add_commit(repo, revision_id, parent_ids):
+            repo.lock_write()
+            repo.start_write_group()
+            inv = inventory.Inventory(revision_id=revision_id)
+            inv.root.revision = revision_id
+            root_id = inv.root.file_id
+            sha1 = repo.add_inventory(revision_id, inv, [])
+            repo.texts.add_lines((root_id, revision_id), [], [])
+            rev = _mod_revision.Revision(timestamp=0,
+                                         timezone=None,
+                                         committer="Foo Bar <foo@example.com>",
+                                         message="Message",
+                                         inventory_sha1=sha1,
+                                         revision_id=revision_id)
+            rev.parent_ids = parent_ids
+            repo.add_revision(revision_id, rev)
+            repo.commit_write_group()
+            repo.unlock()
+        add_commit(has_ghost, 'ghost', [])
+        add_commit(has_ghost, 'references', ['ghost'])
+        add_commit(missing_ghost, 'references', ['ghost'])
+        add_commit(has_ghost, 'tip', ['references'])
+        missing_ghost.fetch(has_ghost, 'tip')
+        # missing ghost now has tip and not ghost.
+        rev = missing_ghost.get_revision('tip')
+        inv = missing_ghost.get_inventory('tip')
+        self.assertRaises(errors.NoSuchRevision,
+            missing_ghost.get_revision, 'ghost')
+        self.assertRaises(errors.NoSuchRevision,
+            missing_ghost.get_inventory, 'ghost')
+
+    def test_supports_external_lookups(self):
+        repo = self.make_repository('.', format=self.get_format())
+        self.assertEqual(self.format_supports_external_lookups,
+            repo._format.supports_external_lookups)
+
+
+class TestPackRepositoryStacking(TestCaseWithTransport):
+
+    """Tests for stacking pack repositories"""
+
+    def setUp(self):
+        if not self.format_supports_external_lookups:
+            raise TestNotApplicable("%r doesn't support stacking" 
+                % (self.format_name,))
+        super(TestPackRepositoryStacking, self).setUp()
+
+    def get_format(self):
+        return bzrdir.format_registry.make_bzrdir(self.format_name)
+
+    def test_stack_checks_compatibility(self):
+        # early versions of the packing code relied on pack internals to
+        # stack, but the current version should be able to stack on any
+        # format.
+        #
+        # TODO: Possibly this should be run per-repository-format and raise
+        # TestNotApplicable on formats that don't support stacking. -- mbp
+        # 20080729
+        repo = self.make_repository('repo', format=self.get_format())
+        if repo.supports_rich_root():
+            # can only stack on repositories that have compatible internal
+            # metadata
+            matching_format_name = 'pack-0.92-subtree'
+            mismatching_format_name = 'pack-0.92'
+        else:
+            matching_format_name = 'pack-0.92'
+            mismatching_format_name = 'pack-0.92-subtree'
+        base = self.make_repository('base', format=matching_format_name)
+        repo.add_fallback_repository(base)
+        # you can't stack on something with incompatible data
+        bad_repo = self.make_repository('mismatch',
+            format=mismatching_format_name)
+        e = self.assertRaises(errors.IncompatibleRepositories,
+            repo.add_fallback_repository, bad_repo)
+        self.assertContainsRe(str(e),
+            r'(?m)KnitPackRepository.*/mismatch/.*\nis not compatible with\n'
+            r'KnitPackRepository.*/repo/.*\n'
+            r'different rich-root support')
+
+    def test_adding_pack_does_not_record_pack_names_from_other_repositories(self):
+        base = self.make_branch_and_tree('base', format=self.get_format())
+        base.commit('foo')
+        referencing = self.make_branch_and_tree('repo', format=self.get_format())
+        referencing.branch.repository.add_fallback_repository(base.branch.repository)
+        referencing.commit('bar')
+        new_instance = referencing.bzrdir.open_repository()
+        new_instance.lock_read()
+        self.addCleanup(new_instance.unlock)
+        new_instance._pack_collection.ensure_loaded()
+        self.assertEqual(1, len(new_instance._pack_collection.all_packs()))
+
+    def test_autopack_only_considers_main_repo_packs(self):
+        base = self.make_branch_and_tree('base', format=self.get_format())
+        base.commit('foo')
+        tree = self.make_branch_and_tree('repo', format=self.get_format())
+        tree.branch.repository.add_fallback_repository(base.branch.repository)
+        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
+        # This test could be a little cheaper by replacing the packs
+        # attribute on the repository to allow a different pack distribution
+        # and max packs policy - so we are checking the policy is honoured
+        # in the test. But for now 11 commits is not a big deal in a single
+        # test.
+        for x in range(9):
+            tree.commit('commit %s' % x)
+        # there should be 9 packs:
+        index = GraphIndex(trans, 'pack-names', None)
+        self.assertEqual(9, len(list(index.iter_all_entries())))
+        # committing one more should coalesce to 1 of 10.
+        tree.commit('commit triggering pack')
+        index = GraphIndex(trans, 'pack-names', None)
+        self.assertEqual(1, len(list(index.iter_all_entries())))
+        # packing should not damage data
+        tree = tree.bzrdir.open_workingtree()
+        check_result = tree.branch.repository.check(
+            [tree.branch.last_revision()])
+        # We should have 50 (10x5) files in the obsolete_packs directory.
+        obsolete_files = list(trans.list_dir('obsolete_packs'))
+        self.assertFalse('foo' in obsolete_files)
+        self.assertFalse('bar' in obsolete_files)
+        self.assertEqual(50, len(obsolete_files))
+        # XXX: Todo check packs obsoleted correctly - old packs and indices
+        # in the obsolete_packs directory.
+        large_pack_name = list(index.iter_all_entries())[0][1][0]
+        # finally, committing again should not touch the large pack.
+        tree.commit('commit not triggering pack')
+        index = GraphIndex(trans, 'pack-names', None)
+        self.assertEqual(2, len(list(index.iter_all_entries())))
+        pack_names = [node[1][0] for node in index.iter_all_entries()]
+        self.assertTrue(large_pack_name in pack_names)
+
+
+def load_tests(basic_tests, module, test_loader):
+    # these give the bzrdir canned format name, and the repository on-disk
+    # format string
+    scenarios_params = [
+         dict(format_name='pack-0.92',
+              format_string="Bazaar pack repository format 1 (needs bzr 0.92)\n",
+              format_supports_external_lookups=False),
+         dict(format_name='pack-0.92-subtree',
+              format_string="Bazaar pack repository format 1 "
+              "with subtree support (needs bzr 0.92)\n",
+              format_supports_external_lookups=False),
+         dict(format_name='1.6',
+              format_string="Bazaar RepositoryFormatKnitPack5 (bzr 1.6)\n",
+              format_supports_external_lookups=True),
+         dict(format_name='1.6-rich-root',
+              format_string="Bazaar RepositoryFormatKnitPack5RichRoot "
+                  "(bzr 1.6)\n",
+              format_supports_external_lookups=True),
+         dict(format_name='development0',
+              format_string="Bazaar development format 0 "
+                  "(needs bzr.dev from before 1.3)\n",
+              format_supports_external_lookups=False),
+         dict(format_name='development0-subtree',
+              format_string="Bazaar development format 0 "
+                  "with subtree support (needs bzr.dev from before 1.3)\n",
+              format_supports_external_lookups=False),
+         dict(format_name='development',
+              format_string="Bazaar development format 1 "
+                  "(needs bzr.dev from before 1.6)\n",
+              format_supports_external_lookups=True),
+         dict(format_name='development-subtree',
+              format_string="Bazaar development format 1 "
+                  "with subtree support (needs bzr.dev from before 1.6)\n",
+              format_supports_external_lookups=True),
+         ]
+    adapter = tests.TestScenarioApplier()
+    # name of the scenario is the format name
+    adapter.scenarios = [(s['format_name'], s) for s in scenarios_params]
+    suite = tests.TestSuite()
+    tests.adapt_tests(basic_tests, adapter, suite)
+    return suite

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2008-07-23 11:18:10 +0000
+++ bzrlib/tests/test_remote.py	2008-07-25 06:42:08 +0000
@@ -551,6 +551,40 @@
             errors.NoSuchRevision, branch.set_revision_history, ['rev-id'])
         branch.unlock()
 
+    def test_tip_change_rejected(self):
+        """TipChangeRejected responses cause a TipChangeRejected exception to
+        be raised.
+        """
+        transport = MemoryTransport()
+        transport.mkdir('branch')
+        transport = transport.clone('branch')
+        client = FakeClient(transport.base)
+        # lock_write
+        client.add_success_response('ok', 'branch token', 'repo token')
+        # set_last_revision
+        rejection_msg_unicode = u'rejection message\N{INTERROBANG}'
+        rejection_msg_utf8 = rejection_msg_unicode.encode('utf8')
+        client.add_error_response('TipChangeRejected', rejection_msg_utf8)
+        # unlock
+        client.add_success_response('ok')
+
+        bzrdir = RemoteBzrDir(transport, _client=False)
+        repo = RemoteRepository(bzrdir, None, _client=client)
+        branch = RemoteBranch(bzrdir, repo, _client=client)
+        branch._ensure_real = lambda: None
+        branch.lock_write()
+        self.addCleanup(branch.unlock)
+        client._calls = []
+
+        # The 'TipChangeRejected' error response triggered by calling
+        # set_revision_history causes a TipChangeRejected exception.
+        err = self.assertRaises(
+            errors.TipChangeRejected, branch.set_revision_history, ['rev-id'])
+        # The UTF-8 message from the response has been decoded into a unicode
+        # object.
+        self.assertIsInstance(err.msg, unicode)
+        self.assertEqual(rejection_msg_unicode, err.msg)
+
 
 class TestBranchSetLastRevisionInfo(tests.TestCase):
 
@@ -689,6 +723,39 @@
         self.assertEqual(('UnexpectedError',), err.error_tuple)
         branch.unlock()
 
+    def test_tip_change_rejected(self):
+        """TipChangeRejected responses cause a TipChangeRejected exception to
+        be raised.
+        """
+        transport = MemoryTransport()
+        transport.mkdir('branch')
+        transport = transport.clone('branch')
+        client = FakeClient(transport.base)
+        # lock_write
+        client.add_success_response('ok', 'branch token', 'repo token')
+        # set_last_revision
+        client.add_error_response('TipChangeRejected', 'rejection message')
+        # unlock
+        client.add_success_response('ok')
+
+        bzrdir = RemoteBzrDir(transport, _client=False)
+        repo = RemoteRepository(bzrdir, None, _client=client)
+        branch = RemoteBranch(bzrdir, repo, _client=client)
+        # This is a hack to work around the problem that RemoteBranch currently
+        # unnecessarily invokes _ensure_real upon a call to lock_write.
+        branch._ensure_real = lambda: None
+        # Lock the branch, reset the record of remote calls.
+        branch.lock_write()
+        self.addCleanup(branch.unlock)
+        client._calls = []
+
+        # The 'TipChangeRejected' error response triggered by calling
+        # set_last_revision_info causes a TipChangeRejected exception.
+        err = self.assertRaises(
+            errors.TipChangeRejected,
+            branch.set_last_revision_info, 123, 'revid')
+        self.assertEqual('rejection message', err.msg)
+
 
 class TestBranchControlGetBranchConf(tests.TestCaseWithMemoryTransport):
     """Getting the branch configuration should use an abstract method not vfs.

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2008-07-14 06:39:43 +0000
+++ bzrlib/tests/test_repository.py	2008-08-04 07:55:41 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
+# Copyright (C) 2006, 2007, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -162,6 +162,24 @@
 
 class TestFormat6(TestCaseWithTransport):
 
+    def test_attribute__fetch_order(self):
+        """Weaves need topological data insertion."""
+        control = bzrdir.BzrDirFormat6().initialize(self.get_url())
+        repo = weaverepo.RepositoryFormat6().initialize(control)
+        self.assertEqual('topological', repo._fetch_order)
+
+    def test_attribute__fetch_uses_deltas(self):
+        """Weaves do not reuse deltas."""
+        control = bzrdir.BzrDirFormat6().initialize(self.get_url())
+        repo = weaverepo.RepositoryFormat6().initialize(control)
+        self.assertEqual(False, repo._fetch_uses_deltas)
+
+    def test_attribute__fetch_reconcile(self):
+        """Weave repositories need a reconcile after fetch."""
+        control = bzrdir.BzrDirFormat6().initialize(self.get_url())
+        repo = weaverepo.RepositoryFormat6().initialize(control)
+        self.assertEqual(True, repo._fetch_reconcile)
+
     def test_no_ancestry_weave(self):
         control = bzrdir.BzrDirFormat6().initialize(self.get_url())
         repo = weaverepo.RepositoryFormat6().initialize(control)
@@ -178,7 +196,25 @@
 
 
 class TestFormat7(TestCaseWithTransport):
-    
+
+    def test_attribute__fetch_order(self):
+        """Weaves need topological data insertion."""
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = weaverepo.RepositoryFormat7().initialize(control)
+        self.assertEqual('topological', repo._fetch_order)
+
+    def test_attribute__fetch_uses_deltas(self):
+        """Weaves do not reuse deltas."""
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = weaverepo.RepositoryFormat7().initialize(control)
+        self.assertEqual(False, repo._fetch_uses_deltas)
+
+    def test_attribute__fetch_reconcile(self):
+        """Weave repositories need a reconcile after fetch."""
+        control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
+        repo = weaverepo.RepositoryFormat7().initialize(control)
+        self.assertEqual(True, repo._fetch_reconcile)
+
     def test_disk_layout(self):
         control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
         repo = weaverepo.RepositoryFormat7().initialize(control)
@@ -307,6 +343,18 @@
 
 class TestFormatKnit1(TestCaseWithTransport):
     
+    def test_attribute__fetch_order(self):
+        """Knits need topological data insertion."""
+        repo = self.make_repository('.',
+                format=bzrdir.format_registry.get('knit')())
+        self.assertEqual('topological', repo._fetch_order)
+
+    def test_attribute__fetch_uses_deltas(self):
+        """Knits reuse deltas."""
+        repo = self.make_repository('.',
+                format=bzrdir.format_registry.get('knit')())
+        self.assertEqual(True, repo._fetch_uses_deltas)
+
     def test_disk_layout(self):
         control = bzrdir.BzrDirMetaFormat1().initialize(self.get_url())
         repo = knitrepo.RepositoryFormatKnit1().initialize(control)
@@ -558,6 +606,20 @@
 
 class TestRepositoryFormatKnit3(TestCaseWithTransport):
 
+    def test_attribute__fetch_order(self):
+        """Knits need topological data insertion."""
+        format = bzrdir.BzrDirMetaFormat1()
+        format.repository_format = knitrepo.RepositoryFormatKnit3()
+        repo = self.make_repository('.', format=format)
+        self.assertEqual('topological', repo._fetch_order)
+
+    def test_attribute__fetch_uses_deltas(self):
+        """Knits reuse deltas."""
+        format = bzrdir.BzrDirMetaFormat1()
+        format.repository_format = knitrepo.RepositoryFormatKnit3()
+        repo = self.make_repository('.', format=format)
+        self.assertEqual(True, repo._fetch_uses_deltas)
+
     def test_convert(self):
         """Ensure the upgrade adds weaves for roots"""
         format = bzrdir.BzrDirMetaFormat1()
@@ -677,566 +739,6 @@
         self.assertRaises(errors.RevisionNotPresent, empty_repo.fetch, broken_repo)
 
 
-class TestKnitPackNoSubtrees(TestCaseWithTransport):
-
-    def get_format(self):
-        return bzrdir.format_registry.make_bzrdir('pack-0.92')
-
-    def test_disk_layout(self):
-        format = self.get_format()
-        repo = self.make_repository('.', format=format)
-        # in case of side effects of locking.
-        repo.lock_write()
-        repo.unlock()
-        t = repo.bzrdir.get_repository_transport(None)
-        self.check_format(t)
-        # XXX: no locks left when unlocked at the moment
-        # self.assertEqualDiff('', t.get('lock').read())
-        self.check_databases(t)
-
-    def check_format(self, t):
-        self.assertEqualDiff(
-            "Bazaar pack repository format 1 (needs bzr 0.92)\n",
-                             t.get('format').read())
-
-    def assertHasNoKndx(self, t, knit_name):
-        """Assert that knit_name has no index on t."""
-        self.assertFalse(t.has(knit_name + '.kndx'))
-
-    def assertHasNoKnit(self, t, knit_name):
-        """Assert that knit_name exists on t."""
-        # no default content
-        self.assertFalse(t.has(knit_name + '.knit'))
-
-    def check_databases(self, t):
-        """check knit content for a repository."""
-        # check conversion worked
-        self.assertHasNoKndx(t, 'inventory')
-        self.assertHasNoKnit(t, 'inventory')
-        self.assertHasNoKndx(t, 'revisions')
-        self.assertHasNoKnit(t, 'revisions')
-        self.assertHasNoKndx(t, 'signatures')
-        self.assertHasNoKnit(t, 'signatures')
-        self.assertFalse(t.has('knits'))
-        # revision-indexes file-container directory
-        self.assertEqual([],
-            list(GraphIndex(t, 'pack-names', None).iter_all_entries()))
-        self.assertTrue(S_ISDIR(t.stat('packs').st_mode))
-        self.assertTrue(S_ISDIR(t.stat('upload').st_mode))
-        self.assertTrue(S_ISDIR(t.stat('indices').st_mode))
-        self.assertTrue(S_ISDIR(t.stat('obsolete_packs').st_mode))
-
-    def test_shared_disk_layout(self):
-        format = self.get_format()
-        repo = self.make_repository('.', shared=True, format=format)
-        # we want:
-        t = repo.bzrdir.get_repository_transport(None)
-        self.check_format(t)
-        # XXX: no locks left when unlocked at the moment
-        # self.assertEqualDiff('', t.get('lock').read())
-        # We should have a 'shared-storage' marker file.
-        self.assertEqualDiff('', t.get('shared-storage').read())
-        self.check_databases(t)
-
-    def test_shared_no_tree_disk_layout(self):
-        format = self.get_format()
-        repo = self.make_repository('.', shared=True, format=format)
-        repo.set_make_working_trees(False)
-        # we want:
-        t = repo.bzrdir.get_repository_transport(None)
-        self.check_format(t)
-        # XXX: no locks left when unlocked at the moment
-        # self.assertEqualDiff('', t.get('lock').read())
-        # We should have a 'shared-storage' marker file.
-        self.assertEqualDiff('', t.get('shared-storage').read())
-        # We should have a marker for the no-working-trees flag.
-        self.assertEqualDiff('', t.get('no-working-trees').read())
-        # The marker should go when we toggle the setting.
-        repo.set_make_working_trees(True)
-        self.assertFalse(t.has('no-working-trees'))
-        self.check_databases(t)
-
-    def test_adding_revision_creates_pack_indices(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
-        self.assertEqual([],
-            list(GraphIndex(trans, 'pack-names', None).iter_all_entries()))
-        tree.commit('foobarbaz')
-        index = GraphIndex(trans, 'pack-names', None)
-        index_nodes = list(index.iter_all_entries())
-        self.assertEqual(1, len(index_nodes))
-        node = index_nodes[0]
-        name = node[1][0]
-        # the pack sizes should be listed in the index
-        pack_value = node[2]
-        sizes = [int(digits) for digits in pack_value.split(' ')]
-        for size, suffix in zip(sizes, ['.rix', '.iix', '.tix', '.six']):
-            stat = trans.stat('indices/%s%s' % (name, suffix))
-            self.assertEqual(size, stat.st_size)
-
-    def test_pulling_nothing_leads_to_no_new_names(self):
-        format = self.get_format()
-        tree1 = self.make_branch_and_tree('1', format=format)
-        tree2 = self.make_branch_and_tree('2', format=format)
-        tree1.branch.repository.fetch(tree2.branch.repository)
-        trans = tree1.branch.repository.bzrdir.get_repository_transport(None)
-        self.assertEqual([],
-            list(GraphIndex(trans, 'pack-names', None).iter_all_entries()))
-
-    def test_commit_across_pack_shape_boundary_autopacks(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
-        # This test could be a little cheaper by replacing the packs
-        # attribute on the repository to allow a different pack distribution
-        # and max packs policy - so we are checking the policy is honoured
-        # in the test. But for now 11 commits is not a big deal in a single
-        # test.
-        for x in range(9):
-            tree.commit('commit %s' % x)
-        # there should be 9 packs:
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(9, len(list(index.iter_all_entries())))
-        # insert some files in obsolete_packs which should be removed by pack.
-        trans.put_bytes('obsolete_packs/foo', '123')
-        trans.put_bytes('obsolete_packs/bar', '321')
-        # committing one more should coalesce to 1 of 10.
-        tree.commit('commit triggering pack')
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(1, len(list(index.iter_all_entries())))
-        # packing should not damage data
-        tree = tree.bzrdir.open_workingtree()
-        check_result = tree.branch.repository.check(
-            [tree.branch.last_revision()])
-        # We should have 50 (10x5) files in the obsolete_packs directory.
-        obsolete_files = list(trans.list_dir('obsolete_packs'))
-        self.assertFalse('foo' in obsolete_files)
-        self.assertFalse('bar' in obsolete_files)
-        self.assertEqual(50, len(obsolete_files))
-        # XXX: Todo check packs obsoleted correctly - old packs and indices
-        # in the obsolete_packs directory.
-        large_pack_name = list(index.iter_all_entries())[0][1][0]
-        # finally, committing again should not touch the large pack.
-        tree.commit('commit not triggering pack')
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(2, len(list(index.iter_all_entries())))
-        pack_names = [node[1][0] for node in index.iter_all_entries()]
-        self.assertTrue(large_pack_name in pack_names)
-
-    def test_fail_obsolete_deletion(self):
-        # failing to delete obsolete packs is not fatal
-        format = self.get_format()
-        server = fakenfs.FakeNFSServer()
-        server.setUp()
-        self.addCleanup(server.tearDown)
-        transport = get_transport(server.get_url())
-        bzrdir = self.get_format().initialize_on_transport(transport)
-        repo = bzrdir.create_repository()
-        repo_transport = bzrdir.get_repository_transport(None)
-        self.assertTrue(repo_transport.has('obsolete_packs'))
-        # these files are in use by another client and typically can't be deleted
-        repo_transport.put_bytes('obsolete_packs/.nfsblahblah', 'contents')
-        repo._pack_collection._clear_obsolete_packs()
-        self.assertTrue(repo_transport.has('obsolete_packs/.nfsblahblah'))
-
-    def test_pack_after_two_commits_packs_everything(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
-        tree.commit('start')
-        tree.commit('more work')
-        tree.branch.repository.pack()
-        # there should be 1 pack:
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(1, len(list(index.iter_all_entries())))
-        self.assertEqual(2, len(tree.branch.repository.all_revision_ids()))
-
-    def test_pack_layout(self):
-        format = self.get_format()
-        tree = self.make_branch_and_tree('.', format=format)
-        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
-        tree.commit('start', rev_id='1')
-        tree.commit('more work', rev_id='2')
-        tree.branch.repository.pack()
-        tree.lock_read()
-        self.addCleanup(tree.unlock)
-        pack = tree.branch.repository._pack_collection.get_pack_by_name(
-            tree.branch.repository._pack_collection.names()[0])
-        # revision access tends to be tip->ancestor, so ordering that way on 
-        # disk is a good idea.
-        for _1, key, val, refs in pack.revision_index.iter_all_entries():
-            if key == ('1',):
-                pos_1 = int(val[1:].split()[0])
-            else:
-                pos_2 = int(val[1:].split()[0])
-        self.assertTrue(pos_2 < pos_1)
-
-    def test_pack_repositories_support_multiple_write_locks(self):
-        format = self.get_format()
-        self.make_repository('.', shared=True, format=format)
-        r1 = repository.Repository.open('.')
-        r2 = repository.Repository.open('.')
-        r1.lock_write()
-        self.addCleanup(r1.unlock)
-        r2.lock_write()
-        r2.unlock()
-
-    def _add_text(self, repo, fileid):
-        """Add a text to the repository within a write group."""
-        repo.texts.add_lines((fileid, 'samplerev+'+fileid), [], [])
-
-    def test_concurrent_writers_merge_new_packs(self):
-        format = self.get_format()
-        self.make_repository('.', shared=True, format=format)
-        r1 = repository.Repository.open('.')
-        r2 = repository.Repository.open('.')
-        r1.lock_write()
-        try:
-            # access enough data to load the names list
-            list(r1.all_revision_ids())
-            r2.lock_write()
-            try:
-                # access enough data to load the names list
-                list(r2.all_revision_ids())
-                r1.start_write_group()
-                try:
-                    r2.start_write_group()
-                    try:
-                        self._add_text(r1, 'fileidr1')
-                        self._add_text(r2, 'fileidr2')
-                    except:
-                        r2.abort_write_group()
-                        raise
-                except:
-                    r1.abort_write_group()
-                    raise
-                # both r1 and r2 have open write groups with data in them
-                # created while the other's write group was open.
-                # Commit both which requires a merge to the pack-names.
-                try:
-                    r1.commit_write_group()
-                except:
-                    r1.abort_write_group()
-                    r2.abort_write_group()
-                    raise
-                r2.commit_write_group()
-                # tell r1 to reload from disk
-                r1._pack_collection.reset()
-                # Now both repositories should know about both names
-                r1._pack_collection.ensure_loaded()
-                r2._pack_collection.ensure_loaded()
-                self.assertEqual(r1._pack_collection.names(), r2._pack_collection.names())
-                self.assertEqual(2, len(r1._pack_collection.names()))
-            finally:
-                r2.unlock()
-        finally:
-            r1.unlock()
-
-    def test_concurrent_writer_second_preserves_dropping_a_pack(self):
-        format = self.get_format()
-        self.make_repository('.', shared=True, format=format)
-        r1 = repository.Repository.open('.')
-        r2 = repository.Repository.open('.')
-        # add a pack to drop
-        r1.lock_write()
-        try:
-            r1.start_write_group()
-            try:
-                self._add_text(r1, 'fileidr1')
-            except:
-                r1.abort_write_group()
-                raise
-            else:
-                r1.commit_write_group()
-            r1._pack_collection.ensure_loaded()
-            name_to_drop = r1._pack_collection.all_packs()[0].name
-        finally:
-            r1.unlock()
-        r1.lock_write()
-        try:
-            # access enough data to load the names list
-            list(r1.all_revision_ids())
-            r2.lock_write()
-            try:
-                # access enough data to load the names list
-                list(r2.all_revision_ids())
-                r1._pack_collection.ensure_loaded()
-                try:
-                    r2.start_write_group()
-                    try:
-                        # in r1, drop the pack
-                        r1._pack_collection._remove_pack_from_memory(
-                            r1._pack_collection.get_pack_by_name(name_to_drop))
-                        # in r2, add a pack
-                        self._add_text(r2, 'fileidr2')
-                    except:
-                        r2.abort_write_group()
-                        raise
-                except:
-                    r1._pack_collection.reset()
-                    raise
-                # r1 has a changed names list, and r2 an open write groups with
-                # changes.
-                # save r1, and then commit the r2 write group, which requires a
-                # merge to the pack-names, which should not reinstate
-                # name_to_drop
-                try:
-                    r1._pack_collection._save_pack_names()
-                    r1._pack_collection.reset()
-                except:
-                    r2.abort_write_group()
-                    raise
-                try:
-                    r2.commit_write_group()
-                except:
-                    r2.abort_write_group()
-                    raise
-                # Now both repositories should now about just one name.
-                r1._pack_collection.ensure_loaded()
-                r2._pack_collection.ensure_loaded()
-                self.assertEqual(r1._pack_collection.names(), r2._pack_collection.names())
-                self.assertEqual(1, len(r1._pack_collection.names()))
-                self.assertFalse(name_to_drop in r1._pack_collection.names())
-            finally:
-                r2.unlock()
-        finally:
-            r1.unlock()
-
-    def test_lock_write_does_not_physically_lock(self):
-        repo = self.make_repository('.', format=self.get_format())
-        repo.lock_write()
-        self.addCleanup(repo.unlock)
-        self.assertFalse(repo.get_physical_lock_status())
-
-    def prepare_for_break_lock(self):
-        # Setup the global ui factory state so that a break-lock method call
-        # will find usable input in the input stream.
-        old_factory = bzrlib.ui.ui_factory
-        def restoreFactory():
-            bzrlib.ui.ui_factory = old_factory
-        self.addCleanup(restoreFactory)
-        bzrlib.ui.ui_factory = bzrlib.ui.SilentUIFactory()
-        bzrlib.ui.ui_factory.stdin = StringIO("y\n")
-
-    def test_break_lock_breaks_physical_lock(self):
-        repo = self.make_repository('.', format=self.get_format())
-        repo._pack_collection.lock_names()
-        repo2 = repository.Repository.open('.')
-        self.assertTrue(repo.get_physical_lock_status())
-        self.prepare_for_break_lock()
-        repo2.break_lock()
-        self.assertFalse(repo.get_physical_lock_status())
-
-    def test_broken_physical_locks_error_on__unlock_names_lock(self):
-        repo = self.make_repository('.', format=self.get_format())
-        repo._pack_collection.lock_names()
-        self.assertTrue(repo.get_physical_lock_status())
-        repo2 = repository.Repository.open('.')
-        self.prepare_for_break_lock()
-        repo2.break_lock()
-        self.assertRaises(errors.LockBroken, repo._pack_collection._unlock_names)
-
-    def test_fetch_without_find_ghosts_ignores_ghosts(self):
-        # we want two repositories at this point:
-        # one with a revision that is a ghost in the other
-        # repository.
-        # 'ghost' is present in has_ghost, 'ghost' is absent in 'missing_ghost'.
-        # 'references' is present in both repositories, and 'tip' is present
-        # just in has_ghost.
-        # has_ghost       missing_ghost
-        #------------------------------
-        # 'ghost'             -
-        # 'references'    'references'
-        # 'tip'               -
-        # In this test we fetch 'tip' which should not fetch 'ghost'
-        has_ghost = self.make_repository('has_ghost', format=self.get_format())
-        missing_ghost = self.make_repository('missing_ghost',
-            format=self.get_format())
-
-        def add_commit(repo, revision_id, parent_ids):
-            repo.lock_write()
-            repo.start_write_group()
-            inv = inventory.Inventory(revision_id=revision_id)
-            inv.root.revision = revision_id
-            root_id = inv.root.file_id
-            sha1 = repo.add_inventory(revision_id, inv, [])
-            repo.texts.add_lines((root_id, revision_id), [], [])
-            rev = bzrlib.revision.Revision(timestamp=0,
-                                           timezone=None,
-                                           committer="Foo Bar <foo@example.com>",
-                                           message="Message",
-                                           inventory_sha1=sha1,
-                                           revision_id=revision_id)
-            rev.parent_ids = parent_ids
-            repo.add_revision(revision_id, rev)
-            repo.commit_write_group()
-            repo.unlock()
-        add_commit(has_ghost, 'ghost', [])
-        add_commit(has_ghost, 'references', ['ghost'])
-        add_commit(missing_ghost, 'references', ['ghost'])
-        add_commit(has_ghost, 'tip', ['references'])
-        missing_ghost.fetch(has_ghost, 'tip')
-        # missing ghost now has tip and not ghost.
-        rev = missing_ghost.get_revision('tip')
-        inv = missing_ghost.get_inventory('tip')
-        self.assertRaises(errors.NoSuchRevision,
-            missing_ghost.get_revision, 'ghost')
-        self.assertRaises(errors.NoSuchRevision,
-            missing_ghost.get_inventory, 'ghost')
-
-    def test_supports_external_lookups(self):
-        repo = self.make_repository('.', format=self.get_format())
-        self.assertFalse(repo._format.supports_external_lookups)
-
-
-class TestKnitPackSubtrees(TestKnitPackNoSubtrees):
-
-    def get_format(self):
-        return bzrdir.format_registry.make_bzrdir(
-            'pack-0.92-subtree')
-
-    def check_format(self, t):
-        self.assertEqualDiff(
-            "Bazaar pack repository format 1 with subtree support (needs bzr 0.92)\n",
-            t.get('format').read())
-
-
-class TestDevelopment0(TestKnitPackNoSubtrees):
-
-    def get_format(self):
-        return bzrdir.format_registry.make_bzrdir(
-            'development0')
-
-    def check_format(self, t):
-        self.assertEqualDiff(
-            "Bazaar development format 0 (needs bzr.dev from before 1.3)\n",
-            t.get('format').read())
-
-
-class TestDevelopment0Subtree(TestKnitPackNoSubtrees):
-
-    def get_format(self):
-        return bzrdir.format_registry.make_bzrdir(
-            'development0-subtree')
-
-    def check_format(self, t):
-        self.assertEqualDiff(
-            "Bazaar development format 0 with subtree support "
-            "(needs bzr.dev from before 1.3)\n",
-            t.get('format').read())
-
-
-class TestExternalDevelopment1(object):
-
-    # mixin class for testing stack-supporting development formats
-
-    def test_compatible_cross_formats(self):
-        # early versions of the packing code relied on pack internals to
-        # stack, but the current version should be able to stack on any
-        # format.
-        repo = self.make_repository('repo', format=self.get_format())
-        if repo.supports_rich_root():
-            # can only stack on repositories that have compatible internal
-            # metadata
-            matching_format_name = 'pack-0.92-subtree'
-            mismatching_format_name = 'pack-0.92'
-        else:
-            matching_format_name = 'pack-0.92'
-            mismatching_format_name = 'pack-0.92-subtree'
-        base = self.make_repository('base', format=matching_format_name)
-        repo.add_fallback_repository(base)
-        # you can't stack on something with incompatible data
-        bad_repo = self.make_repository('mismatch',
-            format=mismatching_format_name)
-        self.assertRaises(errors.IncompatibleRepositories,
-            repo.add_fallback_repository, bad_repo)
-
-    def test_adding_pack_does_not_record_pack_names_from_other_repositories(self):
-        base = self.make_branch_and_tree('base', format=self.get_format())
-        base.commit('foo')
-        referencing = self.make_branch_and_tree('repo', format=self.get_format())
-        referencing.branch.repository.add_fallback_repository(base.branch.repository)
-        referencing.commit('bar')
-        new_instance = referencing.bzrdir.open_repository()
-        new_instance.lock_read()
-        self.addCleanup(new_instance.unlock)
-        new_instance._pack_collection.ensure_loaded()
-        self.assertEqual(1, len(new_instance._pack_collection.all_packs()))
-
-    def test_autopack_only_considers_main_repo_packs(self):
-        base = self.make_branch_and_tree('base', format=self.get_format())
-        base.commit('foo')
-        tree = self.make_branch_and_tree('repo', format=self.get_format())
-        tree.branch.repository.add_fallback_repository(base.branch.repository)
-        trans = tree.branch.repository.bzrdir.get_repository_transport(None)
-        # This test could be a little cheaper by replacing the packs
-        # attribute on the repository to allow a different pack distribution
-        # and max packs policy - so we are checking the policy is honoured
-        # in the test. But for now 11 commits is not a big deal in a single
-        # test.
-        for x in range(9):
-            tree.commit('commit %s' % x)
-        # there should be 9 packs:
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(9, len(list(index.iter_all_entries())))
-        # committing one more should coalesce to 1 of 10.
-        tree.commit('commit triggering pack')
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(1, len(list(index.iter_all_entries())))
-        # packing should not damage data
-        tree = tree.bzrdir.open_workingtree()
-        check_result = tree.branch.repository.check(
-            [tree.branch.last_revision()])
-        # We should have 50 (10x5) files in the obsolete_packs directory.
-        obsolete_files = list(trans.list_dir('obsolete_packs'))
-        self.assertFalse('foo' in obsolete_files)
-        self.assertFalse('bar' in obsolete_files)
-        self.assertEqual(50, len(obsolete_files))
-        # XXX: Todo check packs obsoleted correctly - old packs and indices
-        # in the obsolete_packs directory.
-        large_pack_name = list(index.iter_all_entries())[0][1][0]
-        # finally, committing again should not touch the large pack.
-        tree.commit('commit not triggering pack')
-        index = GraphIndex(trans, 'pack-names', None)
-        self.assertEqual(2, len(list(index.iter_all_entries())))
-        pack_names = [node[1][0] for node in index.iter_all_entries()]
-        self.assertTrue(large_pack_name in pack_names)
-
-
-class TestDevelopment1(TestKnitPackNoSubtrees, TestExternalDevelopment1):
-
-    def get_format(self):
-        return bzrdir.format_registry.make_bzrdir(
-            'development')
-
-    def check_format(self, t):
-        self.assertEqualDiff(
-            "Bazaar development format 1 (needs bzr.dev from before 1.6)\n",
-            t.get('format').read())
-
-    def test_supports_external_lookups(self):
-        repo = self.make_repository('.', format=self.get_format())
-        self.assertTrue(repo._format.supports_external_lookups)
-
-
-class TestDevelopment1Subtree(TestKnitPackNoSubtrees, TestExternalDevelopment1):
-
-    def get_format(self):
-        return bzrdir.format_registry.make_bzrdir(
-            'development-subtree')
-
-    def check_format(self, t):
-        self.assertEqualDiff(
-            "Bazaar development format 1 with subtree support "
-            "(needs bzr.dev from before 1.6)\n",
-            t.get('format').read())
-
-    def test_supports_external_lookups(self):
-        repo = self.make_repository('.', format=self.get_format())
-        self.assertTrue(repo._format.supports_external_lookups)
-
-
 class TestRepositoryPackCollection(TestCaseWithTransport):
 
     def get_format(self):

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2008-07-17 03:06:11 +0000
+++ bzrlib/tests/test_selftest.py	2008-07-29 16:16:36 +0000
@@ -26,6 +26,7 @@
 
 import bzrlib
 from bzrlib import (
+    branchbuilder,
     bzrdir,
     errors,
     memorytree,
@@ -547,6 +548,43 @@
         self.assertEqual(format.repository_format.__class__,
             tree.branch.repository._format.__class__)
 
+    def test_make_branch_builder(self):
+        builder = self.make_branch_builder('dir')
+        self.assertIsInstance(builder, branchbuilder.BranchBuilder)
+        # Guard against regression into MemoryTransport leaking
+        # files to disk instead of keeping them in memory.
+        self.failIf(osutils.lexists('dir'))
+
+    def test_make_branch_builder_with_format(self):
+        # Use a repo layout that doesn't conform to a 'named' layout, to ensure
+        # that the format objects are used.
+        format = bzrdir.BzrDirMetaFormat1()
+        repo_format = weaverepo.RepositoryFormat7()
+        format.repository_format = repo_format
+        builder = self.make_branch_builder('dir', format=format)
+        the_branch = builder.get_branch()
+        # Guard against regression into MemoryTransport leaking
+        # files to disk instead of keeping them in memory.
+        self.failIf(osutils.lexists('dir'))
+        self.assertEqual(format.repository_format.__class__,
+                         the_branch.repository._format.__class__)
+        self.assertEqual(repo_format.get_format_string(),
+                         self.get_transport().get_bytes(
+                            'dir/.bzr/repository/format'))
+
+    def test_make_branch_builder_with_format_name(self):
+        builder = self.make_branch_builder('dir', format='knit')
+        the_branch = builder.get_branch()
+        # Guard against regression into MemoryTransport leaking
+        # files to disk instead of keeping them in memory.
+        self.failIf(osutils.lexists('dir'))
+        dir_format = bzrdir.format_registry.make_bzrdir('knit')
+        self.assertEqual(dir_format.repository_format.__class__,
+                         the_branch.repository._format.__class__)
+        self.assertEqual('Bazaar-NG Knit Repository Format 1',
+                         self.get_transport().get_bytes(
+                            'dir/.bzr/repository/format'))
+
     def test_safety_net(self):
         """No test should modify the safety .bzr directory.
 
@@ -605,6 +643,18 @@
         self.assertRaises(AssertionError, self.assertIsDirectory, 'a_file', t)
         self.assertRaises(AssertionError, self.assertIsDirectory, 'not_here', t)
 
+    def test_make_branch_builder(self):
+        builder = self.make_branch_builder('dir')
+        rev_id = builder.build_commit()
+        self.failUnlessExists('dir')
+        a_dir = bzrdir.BzrDir.open('dir')
+        self.assertRaises(errors.NoWorkingTree, a_dir.open_workingtree)
+        a_branch = a_dir.open_branch()
+        builder_branch = builder.get_branch()
+        self.assertEqual(a_branch.base, builder_branch.base)
+        self.assertEqual((1, rev_id), builder_branch.last_revision_info())
+        self.assertEqual((1, rev_id), a_branch.last_revision_info())
+
 
 class TestTestCaseTransports(TestCaseWithTransport):
 

=== modified file 'bzrlib/tests/test_smart.py'
--- bzrlib/tests/test_smart.py	2008-07-07 05:45:40 +0000
+++ bzrlib/tests/test_smart.py	2008-07-25 06:42:08 +0000
@@ -36,7 +36,7 @@
     tests,
     urlutils,
     )
-from bzrlib.branch import BranchReferenceFormat
+from bzrlib.branch import Branch, BranchReferenceFormat
 import bzrlib.smart.branch
 import bzrlib.smart.bzrdir
 import bzrlib.smart.repository
@@ -480,6 +480,20 @@
         self.assertEqual(
             (1, rev_id_utf8), self.tree.branch.last_revision_info())
 
+    def test_TipChangeRejected(self):
+        """If a pre_change_branch_tip hook raises TipChangeRejected, the verb
+        returns TipChangeRejected.
+        """
+        rejection_message = u'rejection message\N{INTERROBANG}'
+        def hook_that_rejects(params):
+            raise errors.TipChangeRejected(rejection_message)
+        Branch.hooks.install_named_hook(
+            'pre_change_branch_tip', hook_that_rejects, None)
+        self.assertEqual(
+            FailedSmartServerResponse(
+                ('TipChangeRejected', rejection_message.encode('utf-8'))),
+            self.set_last_revision('null:', 0))
+
 
 class TestSmartServerBranchRequestSetLastRevision(
         SetLastRevisionTestBase, TestSetLastRevisionVerbMixin):

=== modified file 'bzrlib/tests/test_transform.py'
--- bzrlib/tests/test_transform.py	2008-07-21 14:46:41 +0000
+++ bzrlib/tests/test_transform.py	2008-08-02 16:11:23 +0000
@@ -1219,6 +1219,7 @@
         wt = self.make_branch_and_tree('.')
         self.build_tree(['foo'])
         wt.add(['foo'])
+        wt.commit("one")
         tt = TreeTransform(wt)
         self.addCleanup(tt.finalize)
         foo_trans_id = tt.trans_id_tree_path("foo")
@@ -1229,6 +1230,74 @@
         tt.version_file("bar-1", bar_trans_id)
         tt.apply()
         self.failUnlessExists("foo/bar")
+        wt.lock_read()
+        try:
+            self.assertEqual(wt.inventory.get_file_kind(wt.path2id("foo")),
+                    "directory")
+        finally:
+            wt.unlock()
+        wt.commit("two")
+        changes = wt.changes_from(wt.basis_tree())
+        self.assertFalse(changes.has_changed(), changes)
+
+    def test_file_to_symlink(self):
+        self.requireFeature(SymlinkFeature)
+        wt = self.make_branch_and_tree('.')
+        self.build_tree(['foo'])
+        wt.add(['foo'])
+        wt.commit("one")
+        tt = TreeTransform(wt)
+        self.addCleanup(tt.finalize)
+        foo_trans_id = tt.trans_id_tree_path("foo")
+        tt.delete_contents(foo_trans_id)
+        tt.create_symlink("bar", foo_trans_id)
+        tt.apply()
+        self.failUnlessExists("foo")
+        wt.lock_read()
+        self.addCleanup(wt.unlock)
+        self.assertEqual(wt.inventory.get_file_kind(wt.path2id("foo")),
+                "symlink")
+
+    def test_dir_to_file(self):
+        wt = self.make_branch_and_tree('.')
+        self.build_tree(['foo/', 'foo/bar'])
+        wt.add(['foo', 'foo/bar'])
+        wt.commit("one")
+        tt = TreeTransform(wt)
+        self.addCleanup(tt.finalize)
+        foo_trans_id = tt.trans_id_tree_path("foo")
+        bar_trans_id = tt.trans_id_tree_path("foo/bar")
+        tt.delete_contents(foo_trans_id)
+        tt.delete_versioned(bar_trans_id)
+        tt.create_file(["aa\n"], foo_trans_id)
+        tt.apply()
+        self.failUnlessExists("foo")
+        wt.lock_read()
+        self.addCleanup(wt.unlock)
+        self.assertEqual(wt.inventory.get_file_kind(wt.path2id("foo")),
+                "file")
+
+    def test_dir_to_hardlink(self):
+        self.requireFeature(HardlinkFeature)
+        wt = self.make_branch_and_tree('.')
+        self.build_tree(['foo/', 'foo/bar'])
+        wt.add(['foo', 'foo/bar'])
+        wt.commit("one")
+        tt = TreeTransform(wt)
+        self.addCleanup(tt.finalize)
+        foo_trans_id = tt.trans_id_tree_path("foo")
+        bar_trans_id = tt.trans_id_tree_path("foo/bar")
+        tt.delete_contents(foo_trans_id)
+        tt.delete_versioned(bar_trans_id)
+        self.build_tree(['baz'])
+        tt.create_hardlink("baz", foo_trans_id)
+        tt.apply()
+        self.failUnlessExists("foo")
+        self.failUnlessExists("baz")
+        wt.lock_read()
+        self.addCleanup(wt.unlock)
+        self.assertEqual(wt.inventory.get_file_kind(wt.path2id("foo")),
+                "file")
 
 
 class TransformGroup(object):
@@ -2314,3 +2383,55 @@
         preview.set_executability(True, preview.trans_id_file_id('file-id'))
         preview_tree = preview.get_preview_tree()
         self.assertEqual(True, preview_tree.is_executable('file-id'))
+
+    def test_get_set_parent_ids(self):
+        revision_tree, preview_tree = self.get_tree_and_preview_tree()
+        self.assertEqual([], preview_tree.get_parent_ids())
+        preview_tree.set_parent_ids(['rev-1'])
+        self.assertEqual(['rev-1'], preview_tree.get_parent_ids())
+
+    def test_plan_file_merge(self):
+        work_a = self.make_branch_and_tree('wta')
+        self.build_tree_contents([('wta/file', 'a\nb\nc\nd\n')])
+        work_a.add('file', 'file-id')
+        base_id = work_a.commit('base version')
+        tree_b = work_a.bzrdir.sprout('wtb').open_workingtree()
+        preview = TransformPreview(work_a)
+        self.addCleanup(preview.finalize)
+        trans_id = preview.trans_id_file_id('file-id')
+        preview.delete_contents(trans_id)
+        preview.create_file('b\nc\nd\ne\n', trans_id)
+        self.build_tree_contents([('wtb/file', 'a\nc\nd\nf\n')])
+        tree_a = preview.get_preview_tree()
+        tree_a.set_parent_ids([base_id])
+        self.assertEqual([
+            ('killed-a', 'a\n'),
+            ('killed-b', 'b\n'),
+            ('unchanged', 'c\n'),
+            ('unchanged', 'd\n'),
+            ('new-a', 'e\n'),
+            ('new-b', 'f\n'),
+        ], list(tree_a.plan_file_merge('file-id', tree_b)))
+
+    def test_plan_file_merge_revision_tree(self):
+        work_a = self.make_branch_and_tree('wta')
+        self.build_tree_contents([('wta/file', 'a\nb\nc\nd\n')])
+        work_a.add('file', 'file-id')
+        base_id = work_a.commit('base version')
+        tree_b = work_a.bzrdir.sprout('wtb').open_workingtree()
+        preview = TransformPreview(work_a.basis_tree())
+        self.addCleanup(preview.finalize)
+        trans_id = preview.trans_id_file_id('file-id')
+        preview.delete_contents(trans_id)
+        preview.create_file('b\nc\nd\ne\n', trans_id)
+        self.build_tree_contents([('wtb/file', 'a\nc\nd\nf\n')])
+        tree_a = preview.get_preview_tree()
+        tree_a.set_parent_ids([base_id])
+        self.assertEqual([
+            ('killed-a', 'a\n'),
+            ('killed-b', 'b\n'),
+            ('unchanged', 'c\n'),
+            ('unchanged', 'd\n'),
+            ('new-a', 'e\n'),
+            ('new-b', 'f\n'),
+        ], list(tree_a.plan_file_merge('file-id', tree_b)))

=== modified file 'bzrlib/tests/test_tree.py'
--- bzrlib/tests/test_tree.py	2007-07-31 19:42:15 +0000
+++ bzrlib/tests/test_tree.py	2008-08-01 17:48:30 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -16,7 +16,12 @@
 
 """Tests for Tree and InterTree."""
 
-from bzrlib import errors
+from bzrlib import (
+    errors,
+    revision,
+    tests,
+    tree as _mod_tree,
+    )
 from bzrlib.tests import TestCaseWithTransport
 from bzrlib.tree import InterTree
 
@@ -138,3 +143,277 @@
             specific_files=['known_file', 'unknown_file'] ,
             require_versioned=False)
         self.assertEqual(len(delta.added), 1)
+
+
+class TestMultiWalker(TestCaseWithTransport):
+
+    def assertStepOne(self, has_more, path, file_id, iterator):
+        retval = _mod_tree.MultiWalker._step_one(iterator)
+        if not has_more:
+            self.assertIs(None, path)
+            self.assertIs(None, file_id)
+            self.assertEqual((False, None, None), retval)
+        else:
+            self.assertEqual((has_more, path, file_id),
+                             (retval[0], retval[1], retval[2].file_id))
+
+    def test__step_one_empty(self):
+        tree = self.make_branch_and_tree('empty')
+        repo = tree.branch.repository
+        empty_tree = repo.revision_tree(revision.NULL_REVISION)
+
+        iterator = empty_tree.iter_entries_by_dir()
+        self.assertStepOne(False, None, None, iterator)
+        self.assertStepOne(False, None, None, iterator)
+
+    def test__step_one(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b/', 'tree/b/c'])
+        tree.add(['a', 'b', 'b/c'], ['a-id', 'b-id', 'c-id'])
+
+        iterator = tree.iter_entries_by_dir()
+        tree.lock_read()
+        self.addCleanup(tree.unlock)
+
+        root_id = tree.path2id('')
+        self.assertStepOne(True, '', root_id, iterator)
+        self.assertStepOne(True, 'a', 'a-id', iterator)
+        self.assertStepOne(True, 'b', 'b-id', iterator)
+        self.assertStepOne(True, 'b/c', 'c-id', iterator)
+        self.assertStepOne(False, None, None, iterator)
+        self.assertStepOne(False, None, None, iterator)
+
+    def assertWalkerNext(self, exp_path, exp_file_id, master_has_node,
+                         exp_other_paths, iterator):
+        """Check what happens when we step the iterator.
+
+        :param path: The path for this entry
+        :param file_id: The file_id for this entry
+        :param master_has_node: Does the master tree have this entry?
+        :param exp_other_paths: A list of other_path values.
+        :param iterator: The iterator to step
+        """
+        path, file_id, master_ie, other_values = iterator.next()
+        self.assertEqual((exp_path, exp_file_id), (path, file_id),
+                         'Master entry did not match')
+        if master_has_node:
+            self.assertIsNot(None, master_ie, 'master should have an entry')
+        else:
+            self.assertIs(None, master_ie, 'master should not have an entry')
+        self.assertEqual(len(exp_other_paths), len(other_values),
+                            'Wrong number of other entries')
+        other_paths = []
+        other_file_ids = []
+        for path, ie in other_values:
+            other_paths.append(path)
+            if ie is None:
+                other_file_ids.append(None)
+            else:
+                other_file_ids.append(ie.file_id)
+        
+        exp_file_ids = []
+        for path in exp_other_paths:
+            if path is None:
+                exp_file_ids.append(None)
+            else:
+                exp_file_ids.append(file_id)
+        self.assertEqual(exp_other_paths, other_paths, "Other paths incorrect")
+        self.assertEqual(exp_file_ids, other_file_ids,
+                         "Other file_ids incorrect")
+
+    def lock_and_get_basis_and_root_id(self, tree):
+        tree.lock_read()
+        self.addCleanup(tree.unlock)
+        basis_tree = tree.basis_tree()
+        basis_tree.lock_read()
+        self.addCleanup(basis_tree.unlock)
+        root_id = tree.path2id('')
+        return basis_tree, root_id
+
+    def test_simple_stepping(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b/', 'tree/b/c'])
+        tree.add(['a', 'b', 'b/c'], ['a-id', 'b-id', 'c-id'])
+
+        tree.commit('first', rev_id='first-rev-id')
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+
+        walker = _mod_tree.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'b', 'b-id', True, [u'b'], iterator)
+        self.assertWalkerNext(u'b/c', 'c-id', True, [u'b/c'], iterator)
+        self.assertRaises(StopIteration, iterator.next)
+
+    def test_master_has_extra(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b/', 'tree/c', 'tree/d'])
+        tree.add(['a', 'b', 'd'], ['a-id', 'b-id', 'd-id'])
+
+        tree.commit('first', rev_id='first-rev-id')
+
+        tree.add(['c'], ['c-id'])
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+
+        walker = _mod_tree.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'b', 'b-id', True, [u'b'], iterator)
+        self.assertWalkerNext(u'c', 'c-id', True, [None], iterator)
+        self.assertWalkerNext(u'd', 'd-id', True, [u'd'], iterator)
+        self.assertRaises(StopIteration, iterator.next)
+
+    def test_master_renamed_to_earlier(self):
+        """The record is still present, it just shows up early."""
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/c', 'tree/d'])
+        tree.add(['a', 'c', 'd'], ['a-id', 'c-id', 'd-id'])
+        tree.commit('first', rev_id='first-rev-id')
+        tree.rename_one('d', 'b')
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+
+        walker = _mod_tree.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'b', 'd-id', True, [u'd'], iterator)
+        self.assertWalkerNext(u'c', 'c-id', True, [u'c'], iterator)
+        self.assertRaises(StopIteration, iterator.next)
+
+    def test_master_renamed_to_later(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
+        tree.add(['a', 'b', 'd'], ['a-id', 'b-id', 'd-id'])
+        tree.commit('first', rev_id='first-rev-id')
+        tree.rename_one('b', 'e')
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+
+        walker = _mod_tree.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'd', 'd-id', True, [u'd'], iterator)
+        self.assertWalkerNext(u'e', 'b-id', True, [u'b'], iterator)
+        self.assertRaises(StopIteration, iterator.next)
+
+    def test_other_extra_in_middle(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
+        tree.add(['a', 'b', 'd'], ['a-id', 'b-id', 'd-id'])
+        tree.commit('first', rev_id='first-rev-id')
+        tree.remove(['b'])
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+        walker = _mod_tree.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'd', 'd-id', True, [u'd'], iterator)
+        self.assertWalkerNext(u'b', 'b-id', False, [u'b'], iterator)
+        self.assertRaises(StopIteration, iterator.next)
+
+    def test_other_extra_at_end(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b', 'tree/d'])
+        tree.add(['a', 'b', 'd'], ['a-id', 'b-id', 'd-id'])
+        tree.commit('first', rev_id='first-rev-id')
+        tree.remove(['d'])
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+        walker = _mod_tree.MultiWalker(tree, [basis_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u''], iterator)
+        self.assertWalkerNext(u'a', 'a-id', True, [u'a'], iterator)
+        self.assertWalkerNext(u'b', 'b-id', True, [u'b'], iterator)
+        self.assertWalkerNext(u'd', 'd-id', False, [u'd'], iterator)
+        self.assertRaises(StopIteration, iterator.next)
+
+    def test_others_extra_at_end(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b', 'tree/c', 'tree/d', 'tree/e'])
+        tree.add(['a', 'b', 'c', 'd', 'e'],
+                 ['a-id', 'b-id', 'c-id', 'd-id', 'e-id'])
+        tree.commit('first', rev_id='first-rev-id')
+        tree.remove(['e'])
+        tree.commit('second', rev_id='second-rev-id')
+        tree.remove(['d'])
+        tree.commit('third', rev_id='third-rev-id')
+        tree.remove(['c'])
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+        first_tree = tree.branch.repository.revision_tree('first-rev-id')
+        second_tree = tree.branch.repository.revision_tree('second-rev-id')
+        walker = _mod_tree.MultiWalker(tree, [basis_tree, first_tree,
+                                              second_tree])
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u'', u'', u''], iterator)
+        self.assertWalkerNext(u'a', 'a-id', True, [u'a', u'a', u'a'], iterator)
+        self.assertWalkerNext(u'b', 'b-id', True, [u'b', u'b', u'b'], iterator)
+        self.assertWalkerNext(u'c', 'c-id', False, [u'c', u'c', u'c'], iterator)
+        self.assertWalkerNext(u'd', 'd-id', False, [None, u'd', u'd'], iterator)
+        self.assertWalkerNext(u'e', 'e-id', False, [None, u'e', None], iterator)
+        self.assertRaises(StopIteration, iterator.next)
+
+    def test_different_file_id_in_others(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a', 'tree/b', 'tree/c/'])
+        tree.add(['a', 'b', 'c'], ['a-id', 'b-id', 'c-id'])
+        tree.commit('first', rev_id='first-rev-id')
+
+        tree.rename_one('b', 'c/d')
+        self.build_tree(['tree/b'])
+        tree.add(['b'], ['b2-id'])
+        tree.commit('second', rev_id='second-rev-id')
+
+        tree.rename_one('a', 'c/e')
+        self.build_tree(['tree/a'])
+        tree.add(['a'], ['a2-id'])
+
+        basis_tree, root_id = self.lock_and_get_basis_and_root_id(tree)
+        first_tree = tree.branch.repository.revision_tree('first-rev-id')
+        walker = _mod_tree.MultiWalker(tree, [basis_tree, first_tree])
+
+        iterator = walker.iter_all()
+        self.assertWalkerNext(u'', root_id, True, [u'', u''], iterator)
+        self.assertWalkerNext(u'a', 'a2-id', True, [None, None], iterator)
+        self.assertWalkerNext(u'b', 'b2-id', True, [u'b', None], iterator)
+        self.assertWalkerNext(u'c', 'c-id', True, [u'c', u'c'], iterator)
+        self.assertWalkerNext(u'c/d', 'b-id', True, [u'c/d', u'b'], iterator)
+        self.assertWalkerNext(u'c/e', 'a-id', True, [u'a', u'a'], iterator)
+        self.assertRaises(StopIteration, iterator.next)
+
+    def assertCmpByDirblock(self, cmp_val, path1, path2):
+        self.assertEqual(cmp_val,
+            _mod_tree.MultiWalker._cmp_path_by_dirblock(path1, path2))
+
+    def test__cmp_path_by_dirblock(self):
+        # We only support Unicode strings at this point
+        self.assertRaises(TypeError,
+            _mod_tree.MultiWalker._cmp_path_by_dirblock, '', 'b')
+        self.assertCmpByDirblock(0, u'', u'')
+        self.assertCmpByDirblock(0, u'a', u'a')
+        self.assertCmpByDirblock(0, u'a/b', u'a/b')
+        self.assertCmpByDirblock(0, u'a/b/c', u'a/b/c')
+        self.assertCmpByDirblock(1, u'a-a', u'a')
+        self.assertCmpByDirblock(-1, u'a-a', u'a/a')
+        self.assertCmpByDirblock(-1, u'a=a', u'a/a')
+        self.assertCmpByDirblock(1, u'a-a/a', u'a/a')
+        self.assertCmpByDirblock(1, u'a=a/a', u'a/a')
+        self.assertCmpByDirblock(1, u'a-a/a', u'a/a/a')
+        self.assertCmpByDirblock(1, u'a=a/a', u'a/a/a')
+        self.assertCmpByDirblock(1, u'a-a/a/a', u'a/a/a')
+        self.assertCmpByDirblock(1, u'a=a/a/a', u'a/a/a')
+
+    def assertPathToKey(self, expected, path):
+        self.assertEqual(expected, _mod_tree.MultiWalker._path_to_key(path))
+
+    def test__path_to_key(self):
+        self.assertPathToKey(([u''], u''), u'')
+        self.assertPathToKey(([u''], u'a'), u'a')
+        self.assertPathToKey(([u'a'], u'b'), u'a/b')
+        self.assertPathToKey(([u'a', u'b'], u'c'), u'a/b/c')

=== added file 'bzrlib/tests/test_upgrade_stacked.py'
--- bzrlib/tests/test_upgrade_stacked.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_upgrade_stacked.py	2008-08-04 07:55:41 +0000
@@ -0,0 +1,90 @@
+# Copyright (C) 2008 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Tests for upgrades of various stacking situations."""
+
+from bzrlib import (
+    bzrdir,
+    errors,
+    tests,
+    )
+from bzrlib.upgrade import upgrade
+
+
+class TestStackUpgrade(tests.TestCaseWithTransport):
+    # TODO: This should possibly be repeated for all stacking repositories,
+    # pairwise by rich/non-rich format; should possibly also try other kinds
+    # of upgrades like knit->pack. -- mbp 20080804
+
+    def test_stack_upgrade(self):
+        """Correct checks when stacked-on repository is upgraded.
+        
+        We initially stack on a repo with the same rich root support, 
+        we then upgrade it and should fail, we then upgrade the overlaid 
+        repository.
+        """
+        base = self.make_branch_and_tree('base',
+            format=self.scenario_old_format)
+        self.build_tree(['base/foo'])
+        base.commit('base commit')
+        # make another one stacked
+        stacked = base.bzrdir.sprout('stacked', stacked=True)
+        # this must really be stacked (or get_stacked_on_url raises an error)
+        self.assertTrue(stacked.open_branch().get_stacked_on_url())
+        # now we'll upgrade the underlying branch, then upgrade the stacked
+        # branch, and this should still work.
+        new_format = bzrdir.format_registry.make_bzrdir(
+            self.scenario_new_format)
+        upgrade('base', new_format)
+        # in some cases you'll get an error if the underlying model has
+        # changed; if just the data format has changed this should still work
+        if self.scenario_model_change:
+            self.assertRaises(errors.IncompatibleRepositories,
+                stacked.open_branch)
+        else:
+            stacked.open_branch().check()
+        stacked = bzrdir.BzrDir.open('stacked')
+        # but we can upgrade the stacked repository
+        upgrade('stacked', new_format)
+        # and now it's ok
+        stacked = bzrdir.BzrDir.open('stacked')
+        stacked.open_branch().check()
+
+
+def load_tests(basic_tests, module, test_loader):
+    """Generate dynamic scenario tests.
+
+    Called by the bzrlib test framework.
+    """
+    scenario_pairs = [ # old format, new format, model_change
+#        ('knit', 'rich-root', True),
+        ('knit', '1.6', False),
+#        ('pack-0.92', '1.6', False),
+        ('1.6', '1.6-rich-root', True),
+        ]
+    scenarios = []
+    for (old_name, new_name, model_change) in scenario_pairs:
+        name = old_name + ', ' + new_name
+        scenarios.append((name,
+            dict(scenario_old_format=old_name,
+                scenario_new_format=new_name,
+                scenario_model_change=model_change)))
+    adapter = tests.TestScenarioApplier()
+    adapter.scenarios = scenarios
+    suite = tests.TestSuite()
+    tests.adapt_tests(basic_tests, adapter, suite)
+    return suite

=== modified file 'bzrlib/tests/tree_implementations/__init__.py'
--- bzrlib/tests/tree_implementations/__init__.py	2008-07-17 02:49:32 +0000
+++ bzrlib/tests/tree_implementations/__init__.py	2008-07-22 20:33:58 +0000
@@ -74,7 +74,9 @@
 def preview_tree_pre(testcase, tree):
     tt = TransformPreview(tree)
     testcase.addCleanup(tt.finalize)
-    return tt.get_preview_tree()
+    preview_tree = tt.get_preview_tree()
+    preview_tree.set_parent_ids(tree.get_parent_ids())
+    return preview_tree
 
 
 class TestTreeImplementationSupport(TestCaseWithTransport):

=== modified file 'bzrlib/tests/workingtree_implementations/test_commit.py'
--- bzrlib/tests/workingtree_implementations/test_commit.py	2008-04-20 08:21:39 +0000
+++ bzrlib/tests/workingtree_implementations/test_commit.py	2008-08-05 04:10:43 +0000
@@ -195,6 +195,52 @@
                           ('xyz/m', 'm-id'),
                          ], paths)
 
+    def test_commit_exclude_pending_merge_fails(self):
+        """Excludes are a form of partial commit."""
+        wt = self.make_branch_and_tree('.')
+        self.build_tree(['foo'])
+        wt.add('foo')
+        wt.commit('commit one')
+        wt2 = wt.bzrdir.sprout('to').open_workingtree()
+        wt2.commit('change_right')
+        wt.merge_from_branch(wt2.branch)
+        self.assertRaises(errors.CannotCommitSelectedFileMerge,
+            wt.commit, 'test', exclude=['foo'])
+
+    def test_commit_exclude_exclude_changed_is_pointless(self):
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['a'])
+        tree.smart_add(['.'])
+        tree.commit('setup test')
+        self.build_tree_contents([('a', 'new contents for "a"\n')])
+        self.assertRaises(errors.PointlessCommit, tree.commit, 'test',
+            exclude=['a'], allow_pointless=False)
+
+    def test_commit_exclude_excludes_modified_files(self):
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['a', 'b', 'c'])
+        tree.smart_add(['.'])
+        tree.commit('test', exclude=['b', 'c'])
+        # If b was excluded it will still be 'added' in status.
+        tree.lock_read()
+        self.addCleanup(tree.unlock)
+        changes = list(tree.iter_changes(tree.basis_tree()))
+        self.assertEqual(2, len(changes))
+        self.assertEqual((None, 'b'), changes[0][1])
+        self.assertEqual((None, 'c'), changes[1][1])
+
+    def test_commit_exclude_subtree_of_selected(self):
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['a/', 'a/b'])
+        tree.smart_add(['.'])
+        tree.commit('test', specific_files=['a'], exclude=['a/b'])
+        # If a/b was excluded it will still be 'added' in status.
+        tree.lock_read()
+        self.addCleanup(tree.unlock)
+        changes = list(tree.iter_changes(tree.basis_tree()))
+        self.assertEqual(1, len(changes))
+        self.assertEqual((None, 'a/b'), changes[0][1])
+
     def test_commit_sets_last_revision(self):
         tree = self.make_branch_and_tree('tree')
         committed_id = tree.commit('foo', rev_id='foo')

=== modified file 'bzrlib/tests/workingtree_implementations/test_remove.py'
--- bzrlib/tests/workingtree_implementations/test_remove.py	2007-11-29 18:06:55 +0000
+++ bzrlib/tests/workingtree_implementations/test_remove.py	2008-07-30 07:52:22 +0000
@@ -67,9 +67,9 @@
     def test_remove_unchanged_files(self):
         """Check that unchanged files are removed and deleted."""
         tree = self.get_committed_tree(TestRemove.files)
-
         tree.remove(TestRemove.files, keep_files=False)
         self.assertRemovedAndDeleted(TestRemove.files)
+        tree._validate()
 
     def test_remove_added_files(self):
         """Removal of newly added files must fail."""
@@ -82,6 +82,7 @@
             '(?s)added:.*a.*b/.*b/c.*d/')
         self.assertInWorkingTree(TestRemove.files)
         self.failUnlessExists(TestRemove.files)
+        tree._validate()
 
     def test_remove_changed_file(self):
         """Removal of a changed files must fail."""
@@ -93,6 +94,7 @@
         self.assertContainsRe(err.changes_as_text, '(?s)modified:.*a')
         self.assertInWorkingTree('a')
         self.failUnlessExists('a')
+        tree._validate()
 
     def test_remove_deleted_files(self):
         """Check that files are removed if they don't exist any more."""
@@ -101,9 +103,9 @@
             osutils.delete_any(f)
         self.assertInWorkingTree(TestRemove.files)
         self.failIfExists(TestRemove.files)
-
         tree.remove(TestRemove.files, keep_files=False)
         self.assertRemovedAndDeleted(TestRemove.files)
+        tree._validate()
 
     def test_remove_renamed_files(self):
         """Check that files are removed even if they are renamed."""
@@ -117,6 +119,7 @@
 
         tree.remove(rfilesx, keep_files=False)
         self.assertRemovedAndDeleted(rfilesx)
+        tree._validate()
 
     def test_remove_renamed_changed_files(self):
         """Check that files are not removed if they are renamed and changed."""
@@ -136,6 +139,7 @@
             '(?s)modified:.*ax.*bx/cx')
         self.assertInWorkingTree(rfilesx)
         self.failUnlessExists(rfilesx)
+        tree._validate()
 
     def test_force_remove_changed_files(self):
         """Check that changed files are removed and deleted when forced."""
@@ -145,6 +149,7 @@
 
         tree.remove(TestRemove.files, keep_files=False, force=True)
         self.assertRemovedAndDeleted(TestRemove.files)
+        tree._validate()
 
     def test_remove_unknown_files(self):
         """Try to delete unknown files."""
@@ -153,12 +158,14 @@
             TestRemove.files, keep_files=False)
         self.assertContainsRe(err.changes_as_text,
             '(?s)unknown:.*d/.*b/c.*b/.*a.*')
+        tree._validate()
 
     def test_remove_nonexisting_files(self):
         """Try to delete non-existing files."""
         tree = self.get_tree(TestRemove.files)
         tree.remove([''], keep_files=False)
         tree.remove(['xyz', 'abc/def'], keep_files=False)
+        tree._validate()
 
     def test_remove_unchanged_directory(self):
         """Unchanged directories should be deleted."""
@@ -166,6 +173,16 @@
         tree = self.get_committed_tree(files)
         tree.remove('b', keep_files=False)
         self.assertRemovedAndDeleted('b')
+        tree._validate()
+
+    def test_remove_absent_directory(self):
+        """Removing a absent directory succeeds without corruption (#150438)."""
+        paths = ['a/', 'a/b']
+        tree = self.get_committed_tree(paths)
+        self.get_transport('.').delete_tree('a')
+        tree.remove(['a'])
+        self.assertRemovedAndDeleted('b')
+        tree._validate()
 
     def test_remove_unknown_ignored_files(self):
         """Unknown ignored files should be deleted."""
@@ -182,6 +199,7 @@
         self.assertNotEquals(None, tree.is_ignored('b/unknown_ignored_dir'))
         tree.remove('b', keep_files=False)
         self.assertRemovedAndDeleted('b')
+        tree._validate()
 
     def test_remove_changed_ignored_files(self):
         """Changed ignored files should not be deleted."""
@@ -196,6 +214,7 @@
         self.assertContainsRe(err.changes_as_text,
             '(?s)added:.*' + files[0])
         self.assertInWorkingTree(files)
+        tree._validate()
 
     def test_dont_remove_directory_with_unknowns(self):
         """Directories with unknowns should not be deleted."""
@@ -222,6 +241,7 @@
 
         self.assertInWorkingTree(directories)
         self.failUnlessExists(directories)
+        tree._validate()
 
     def test_force_remove_directory_with_unknowns(self):
         """Unchanged non-empty directories should be deleted when forced."""
@@ -239,6 +259,7 @@
 
         self.assertRemovedAndDeleted(files)
         self.assertRemovedAndDeleted(other_files)
+        tree._validate()
 
     def test_remove_directory_with_changed_file(self):
         """Refuse to delete directories with changed files."""
@@ -255,6 +276,7 @@
         # see if we can force it now..
         tree.remove('b', keep_files=False, force=True)
         self.assertRemovedAndDeleted(files)
+        tree._validate()
 
     def test_remove_directory_with_renames(self):
         """Delete directory with renames in or out."""
@@ -278,6 +300,7 @@
         # check if it works with renames in
         tree.remove('b', keep_files=False)
         self.assertRemovedAndDeleted(['b/'])
+        tree._validate()
 
     def test_non_cwd(self):
         tree = self.make_branch_and_tree('tree')
@@ -287,6 +310,7 @@
         tree.remove('dir/', keep_files=False)
         self.failIfExists('tree/dir/file')
         self.assertNotInWorkingTree('tree/dir/file', 'tree')
+        tree._validate()
 
     def test_remove_uncommitted_removed_file(self):
         # As per bug #152811
@@ -294,6 +318,7 @@
         tree.remove('a', keep_files=False)
         tree.remove('a', keep_files=False)
         self.failIfExists('a')
+        tree._validate()
 
     def test_remove_file_and_containing_dir(self):
         tree = self.get_committed_tree(['config/', 'config/file'])
@@ -301,3 +326,4 @@
         tree.remove('config', keep_files=False)
         self.failIfExists('config/file')
         self.failIfExists('config')
+        tree._validate()

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2008-07-17 15:56:09 +0000
+++ bzrlib/transform.py	2008-08-01 16:10:59 +0000
@@ -1217,10 +1217,10 @@
                 mover = _mover
             try:
                 child_pb.update('Apply phase', 0, 2)
-                self._apply_removals(new_inventory_delta, mover)
+                kind_changes = self._apply_removals(new_inventory_delta, mover)
                 child_pb.update('Apply phase', 1, 2)
                 modified_paths = self._apply_insertions(new_inventory_delta,
-                                                        mover)
+                                                        mover, kind_changes)
             except:
                 mover.rollback()
                 raise
@@ -1244,6 +1244,7 @@
         """
         tree_paths = list(self._tree_path_ids.iteritems())
         tree_paths.sort(reverse=True)
+        kind_changes = set()
         child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
         try:
             for num, data in enumerate(tree_paths):
@@ -1251,6 +1252,12 @@
                 child_pb.update('removing file', num, len(tree_paths))
                 full_path = self._tree.abspath(path)
                 if trans_id in self._removed_contents:
+                    try:
+                        if (self.tree_kind(trans_id)
+                                != self.final_kind(trans_id)):
+                            kind_changes.add(trans_id)
+                    except NoSuchFile:
+                        pass
                     mover.pre_delete(full_path, os.path.join(self._deletiondir,
                                      trans_id))
                 elif trans_id in self._new_name or trans_id in \
@@ -1274,8 +1281,9 @@
                     inventory_delta.append((path, None, file_id, None))
         finally:
             child_pb.finished()
+        return kind_changes
 
-    def _apply_insertions(self, inventory_delta, mover):
+    def _apply_insertions(self, inventory_delta, mover, kind_changes):
         """Perform tree operations that insert directory/inventory names.
 
         That is, create any files that need to be created, and restore from
@@ -1284,6 +1292,9 @@
 
         If inventory_delta is None, no inventory delta is calculated, and
         no list of modified paths is returned.
+
+        kind_changes is a set of trans ids where the entry has changed
+        kind, and so an inventory delta entry should be created for them.
         """
         new_paths = self.new_paths(filesystem_only=(inventory_delta is None))
         modified_paths = []
@@ -1320,7 +1331,8 @@
                     if file_id is not None and (trans_id in self._new_id or
                         trans_id in self._new_name or
                         trans_id in self._new_parent
-                        or trans_id in self._new_executability):
+                        or trans_id in self._new_executability
+                        or trans_id in kind_changes):
                         try:
                             kind = self.final_kind(trans_id)
                         except NoSuchFile:
@@ -1410,6 +1422,7 @@
         self._transform = transform
         self._final_paths = FinalPaths(transform)
         self.__by_parent = None
+        self._parent_ids = []
 
     def _changes(self, file_id):
         for changes in self._transform.iter_changes():
@@ -1423,9 +1436,29 @@
         # InterTree.iter_changes.
         return (changes is not None and changes[2])
 
+    def _get_repository(self):
+        repo = getattr(self._transform._tree, '_repository', None)
+        if repo is None:
+            repo = self._transform._tree.branch.repository
+        return repo
+
+    def _iter_parent_trees(self):
+        for revision_id in self.get_parent_ids():
+            try:
+                yield self.revision_tree(revision_id)
+            except errors.NoSuchRevisionInTree:
+                yield self._get_repository().revision_tree(revision_id)
+
     def _get_file_revision(self, file_id, vf, tree_revision):
-        return self._transform._tree._get_file_revision(file_id, vf,
-                                                        tree_revision)
+        parent_keys = [(file_id, self._file_revision(t, file_id)) for t in
+                       self._iter_parent_trees()]
+        vf.add_lines((file_id, tree_revision), parent_keys,
+                     self.get_file(file_id).readlines())
+        repo = self._get_repository()
+        base_vf = repo.texts
+        if base_vf not in vf.fallback_versionedfiles:
+            vf.fallback_versionedfiles.append(base_vf)
+        return tree_revision
 
     def _stat_limbo_file(self, file_id):
         trans_id = self._transform.trans_id_file_id(file_id)
@@ -1682,7 +1715,10 @@
         return self._transform._tree.walkdirs(prefix)
 
     def get_parent_ids(self):
-        return self._transform._tree.get_parent_ids()
+        return self._parent_ids
+
+    def set_parent_ids(self, parent_ids):
+        self._parent_ids = parent_ids
 
     def get_revision_tree(self, revision_id):
         return self._transform._tree.get_revision_tree(revision_id)

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2008-07-09 09:36:41 +0000
+++ bzrlib/transport/sftp.py	2008-07-18 19:51:08 +0000
@@ -584,7 +584,8 @@
             if (e.args == ('No such file or directory',) or
                 e.args == ('No such file',)):
                 raise NoSuchFile(path, str(e) + more_info)
-            if (e.args == ('mkdir failed',)):
+            if (e.args == ('mkdir failed',) or
+                e.args[0].startswith('syserr: File exists')):
                 raise FileExists(path, str(e) + more_info)
             # strange but true, for the paramiko server.
             if (e.args == ('Failure',)):

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2008-07-02 19:51:05 +0000
+++ bzrlib/tree.py	2008-08-01 18:19:44 +0000
@@ -374,32 +374,36 @@
         return vf.plan_lca_merge(last_revision_a, last_revision_b,
                                  last_revision_base)
 
+    def _iter_parent_trees(self):
+        """Iterate through parent trees, defaulting to Tree.revision_tree."""
+        for revision_id in self.get_parent_ids():
+            try:
+                yield self.revision_tree(revision_id)
+            except errors.NoSuchRevisionInTree:
+                yield self.repository.revision_tree(revision_id)
+
+    @staticmethod
+    def _file_revision(revision_tree, file_id):
+        """Determine the revision associated with a file in a given tree."""
+        revision_tree.lock_read()
+        try:
+            return revision_tree.inventory[file_id].revision
+        finally:
+            revision_tree.unlock()
+
     def _get_file_revision(self, file_id, vf, tree_revision):
         """Ensure that file_id, tree_revision is in vf to plan the merge."""
-        def file_revision(revision_tree):
-            revision_tree.lock_read()
-            try:
-                return revision_tree.inventory[file_id].revision
-            finally:
-                revision_tree.unlock()
-
-        def iter_parent_trees():
-            for revision_id in self.get_parent_ids():
-                try:
-                    yield self.revision_tree(revision_id)
-                except:
-                    yield self.repository.revision_tree(revision_id)
 
         if getattr(self, '_repository', None) is None:
             last_revision = tree_revision
-            parent_keys = [(file_id, file_revision(t)) for t in
-                iter_parent_trees()]
+            parent_keys = [(file_id, self._file_revision(t, file_id)) for t in
+                self._iter_parent_trees()]
             vf.add_lines((file_id, last_revision), parent_keys,
                          self.get_file(file_id).readlines())
             repo = self.branch.repository
             base_vf = repo.texts
         else:
-            last_revision = file_revision(self)
+            last_revision = self._file_revision(self, file_id)
             base_vf = self._repository.texts
         if base_vf not in vf.fallback_versionedfiles:
             vf.fallback_versionedfiles.append(base_vf)
@@ -953,3 +957,236 @@
             # the parent's path is necessarily known at this point.
             yield(file_id, (path, to_path), changed_content, versioned, parent,
                   name, kind, executable)
+
+
+class MultiWalker(object):
+    """Walk multiple trees simultaneously, getting combined results."""
+
+    # Note: This could be written to not assume you can do out-of-order
+    #       lookups. Instead any nodes that don't match in all trees could be
+    #       marked as 'deferred', and then returned in the final cleanup loop.
+    #       For now, I think it is "nicer" to return things as close to the
+    #       "master_tree" order as we can.
+
+    def __init__(self, master_tree, other_trees):
+        """Create a new MultiWalker.
+
+        All trees being walked must implement "iter_entries_by_dir()", such
+        that they yield (path, object) tuples, where that object will have a
+        '.file_id' member, that can be used to check equality.
+
+        :param master_tree: All trees will be 'slaved' to the master_tree such
+            that nodes in master_tree will be used as 'first-pass' sync points.
+            Any nodes that aren't in master_tree will be merged in a second
+            pass.
+        :param other_trees: A list of other trees to walk simultaneously.
+        """
+        self._master_tree = master_tree
+        self._other_trees = other_trees
+
+        # Keep track of any nodes that were properly processed just out of
+        # order, that way we don't return them at the end, we don't have to
+        # track *all* processed file_ids, just the out-of-order ones
+        self._out_of_order_processed = set()
+
+    @staticmethod
+    def _step_one(iterator):
+        """Step an iter_entries_by_dir iterator.
+
+        :return: (has_more, path, ie)
+            If has_more is False, path and ie will be None.
+        """
+        try:
+            path, ie = iterator.next()
+        except StopIteration:
+            return False, None, None
+        else:
+            return True, path, ie
+
+    @staticmethod
+    def _cmp_path_by_dirblock(path1, path2):
+        """Compare two paths based on what directory they are in.
+
+        This generates a sort order, such that all children of a directory are
+        sorted together, and grandchildren are in the same order as the
+        children appear. But all grandchildren come after all children.
+
+        :param path1: first path
+        :param path2: the second path
+        :return: negative number if ``path1`` comes first,
+            0 if paths are equal
+            and a positive number if ``path2`` sorts first
+        """
+        # Shortcut this special case
+        if path1 == path2:
+            return 0
+        # This is stolen from _dirstate_helpers_py.py, only switching it to
+        # Unicode objects. Consider using encode_utf8() and then using the
+        # optimized versions, or maybe writing optimized unicode versions.
+        if not isinstance(path1, unicode):
+            raise TypeError("'path1' must be a unicode string, not %s: %r"
+                            % (type(path1), path1))
+        if not isinstance(path2, unicode):
+            raise TypeError("'path2' must be a unicode string, not %s: %r"
+                            % (type(path2), path2))
+        return cmp(MultiWalker._path_to_key(path1),
+                   MultiWalker._path_to_key(path2))
+
+    @staticmethod
+    def _path_to_key(path):
+        dirname, basename = osutils.split(path)
+        return (dirname.split(u'/'), basename)
+
+    def _lookup_by_file_id(self, extra_entries, other_tree, file_id):
+        """Lookup an inventory entry by file_id.
+
+        This is called when an entry is missing in the normal order.
+        Generally this is because a file was either renamed, or it was
+        deleted/added. If the entry was found in the inventory and not in
+        extra_entries, it will be added to self._out_of_order_processed
+
+        :param extra_entries: A dictionary of {file_id: (path, ie)}.  This
+            should be filled with entries that were found before they were
+            used. If file_id is present, it will be removed from the
+            dictionary.
+        :param other_tree: The Tree to search, in case we didn't find the entry
+            yet.
+        :param file_id: The file_id to look for
+        :return: (path, ie) if found or (None, None) if not present.
+        """
+        if file_id in extra_entries:
+            return extra_entries.pop(file_id)
+        # TODO: Is id2path better as the first call, or is
+        #       inventory[file_id] better as a first check?
+        try:
+            cur_path = other_tree.id2path(file_id)
+        except errors.NoSuchId:
+            cur_path = None
+        if cur_path is None:
+            return (None, None)
+        else:
+            self._out_of_order_processed.add(file_id)
+            cur_ie = other_tree.inventory[file_id]
+            return (cur_path, cur_ie)
+
+    def iter_all(self):
+        """Match up the values in the different trees."""
+        for result in self._walk_master_tree():
+            yield result
+        self._finish_others()
+        for result in self._walk_others():
+            yield result
+
+    def _walk_master_tree(self):
+        """First pass, walk all trees in lock-step.
+        
+        When we are done, all nodes in the master_tree will have been
+        processed. _other_walkers, _other_entries, and _others_extra will be
+        set on 'self' for future processing.
+        """
+        # This iterator has the most "inlining" done, because it tends to touch
+        # every file in the tree, while the others only hit nodes that don't
+        # match.
+        master_iterator = self._master_tree.iter_entries_by_dir()
+
+        other_walkers = [other.iter_entries_by_dir()
+                         for other in self._other_trees]
+        other_entries = [self._step_one(walker) for walker in other_walkers]
+        # Track extra nodes in the other trees
+        others_extra = [{} for i in xrange(len(self._other_trees))]
+
+        master_has_more = True
+        step_one = self._step_one
+        lookup_by_file_id = self._lookup_by_file_id
+        out_of_order_processed = self._out_of_order_processed
+
+        while master_has_more:
+            (master_has_more, path, master_ie) = step_one(master_iterator)
+            if not master_has_more:
+                break
+
+            file_id = master_ie.file_id
+            other_values = []
+            other_values_append = other_values.append
+            next_other_entries = []
+            next_other_entries_append = next_other_entries.append
+            for idx, (other_has_more, other_path, other_ie) in enumerate(other_entries):
+                if not other_has_more:
+                    other_values_append(lookup_by_file_id(
+                        others_extra[idx], self._other_trees[idx], file_id))
+                    next_other_entries_append((False, None, None))
+                elif file_id == other_ie.file_id:
+                    # This is the critical code path, as most of the entries
+                    # should match between most trees.
+                    other_values_append((other_path, other_ie))
+                    next_other_entries_append(step_one(other_walkers[idx]))
+                else:
+                    # This walker did not match, step it until it either
+                    # matches, or we know we are past the current walker.
+                    other_walker = other_walkers[idx]
+                    other_extra = others_extra[idx]
+                    while (other_has_more and
+                           self._cmp_path_by_dirblock(other_path, path) < 0):
+                        other_file_id = other_ie.file_id
+                        if other_file_id not in out_of_order_processed:
+                            other_extra[other_file_id] = (other_path, other_ie)
+                        other_has_more, other_path, other_ie = \
+                            step_one(other_walker)
+                    if other_has_more and other_ie.file_id == file_id:
+                        # We ended up walking to this point, match and step
+                        # again
+                        other_values_append((other_path, other_ie))
+                        other_has_more, other_path, other_ie = \
+                            step_one(other_walker)
+                    else:
+                        # This record isn't in the normal order, see if it
+                        # exists at all.
+                        other_values_append(lookup_by_file_id(
+                            other_extra, self._other_trees[idx], file_id))
+                    next_other_entries_append((other_has_more, other_path,
+                                               other_ie))
+            other_entries = next_other_entries
+
+            # We've matched all the walkers, yield this datapoint
+            yield path, file_id, master_ie, other_values
+        self._other_walkers = other_walkers
+        self._other_entries = other_entries
+        self._others_extra = others_extra
+
+    def _finish_others(self):
+        """Finish walking the other iterators, so we get all entries."""
+        for idx, info in enumerate(self._other_entries):
+            other_extra = self._others_extra[idx]
+            (other_has_more, other_path, other_ie) = info
+            while other_has_more:
+                other_file_id = other_ie.file_id
+                if other_file_id not in self._out_of_order_processed:
+                    other_extra[other_file_id] = (other_path, other_ie)
+                other_has_more, other_path, other_ie = \
+                    self._step_one(self._other_walkers[idx])
+        del self._other_entries
+
+    def _walk_others(self):
+        """Finish up by walking all the 'deferred' nodes."""
+        # TODO: One alternative would be to grab all possible unprocessed
+        #       file_ids, and then sort by path, and then yield them. That
+        #       might ensure better ordering, in case a caller strictly
+        #       requires parents before children.
+        for idx, other_extra in enumerate(self._others_extra):
+            others = sorted(other_extra.itervalues(),
+                            key=lambda x: self._path_to_key(x[0]))
+            for other_path, other_ie in others:
+                file_id = other_ie.file_id
+                # We don't need to check out_of_order_processed here, because
+                # the lookup_by_file_id will be removing anything processed
+                # from the extras cache
+                other_extra.pop(file_id)
+                other_values = [(None, None) for i in xrange(idx)]
+                other_values.append((other_path, other_ie))
+                for alt_idx, alt_extra in enumerate(self._others_extra[idx+1:]):
+                    alt_idx = alt_idx + idx + 1
+                    alt_extra = self._others_extra[alt_idx]
+                    alt_tree = self._other_trees[alt_idx]
+                    other_values.append(self._lookup_by_file_id(
+                                            alt_extra, alt_tree, file_id))
+                yield other_path, file_id, None, other_values

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2008-07-25 03:12:11 +0000
+++ bzrlib/upgrade.py	2008-08-07 00:25:38 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -51,12 +51,15 @@
                 self.pb.note("This is a checkout. The branch (%s) needs to be "
                              "upgraded separately.",
                              branch.bzrdir.root_transport.base)
-        except errors.NotBranchError:
+            del branch
+        except (errors.NotBranchError, errors.IncompatibleRepositories):
+            # might not be a format we can open without upgrading; see e.g. 
+            # https://bugs.launchpad.net/bzr/+bug/253891
             pass
         if not self.bzrdir.needs_format_conversion(self.format):
             raise errors.UpToDateFormat(self.bzrdir._format)
         if not self.bzrdir.can_convert_format():
-            raise errors.BzrError("cannot upgrade from branch format %s" %
+            raise errors.BzrError("cannot upgrade from bzrdir format %s" %
                            self.bzrdir._format)
         if self.format is None:
             target_format = BzrDirFormat.get_default_format()

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2008-07-08 14:55:19 +0000
+++ bzrlib/workingtree.py	2008-07-30 09:50:22 +0000
@@ -1859,9 +1859,8 @@
             # Recurse directory and add all files
             # so we can check if they have changed.
             for parent_info, file_infos in\
-                osutils.walkdirs(self.abspath(directory),
-                    directory):
-                for relpath, basename, kind, lstat, abspath in file_infos:
+                self.walkdirs(directory):
+                for relpath, basename, kind, lstat, fileid, kind in file_infos:
                     # Is it versioned or ignored?
                     if self.path2id(relpath) or self.is_ignored(relpath):
                         # Add nested content for deletion.
@@ -1877,8 +1876,7 @@
             filename = self.relpath(abspath)
             if len(filename) > 0:
                 new_files.add(filename)
-                if osutils.isdir(abspath):
-                    recurse_directory_to_add_files(filename)
+                recurse_directory_to_add_files(filename)
 
         files = list(new_files)
 
@@ -2418,10 +2416,11 @@
                 relroot = ""
             # FIXME: stash the node in pending
             entry = inv[top_id]
-            for name, child in entry.sorted_children():
-                dirblock.append((relroot + name, name, child.kind, None,
-                    child.file_id, child.kind
-                    ))
+            if entry.kind == 'directory':
+                for name, child in entry.sorted_children():
+                    dirblock.append((relroot + name, name, child.kind, None,
+                        child.file_id, child.kind
+                        ))
             yield (currentdir[0], entry.file_id), dirblock
             # push the user specified dirs from dirblock
             for dir in reversed(dirblock):

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2008-07-08 14:55:19 +0000
+++ bzrlib/workingtree_4.py	2008-07-29 13:03:44 +0000
@@ -1296,6 +1296,8 @@
 
     upgrade_recommended = False
 
+    _tree_class = WorkingTree4
+
     def get_format_string(self):
         """See WorkingTreeFormat.get_format_string()."""
         return "Bazaar Working Tree Format 4 (bzr 0.15)\n"
@@ -1339,7 +1341,7 @@
         state = dirstate.DirState.initialize(local_path)
         state.unlock()
         del state
-        wt = WorkingTree4(a_bzrdir.root_transport.local_abspath('.'),
+        wt = self._tree_class(a_bzrdir.root_transport.local_abspath('.'),
                          branch,
                          _format=self,
                          _bzrdir=a_bzrdir,
@@ -1347,6 +1349,7 @@
         wt._new_tree()
         wt.lock_tree_write()
         try:
+            self._init_custom_control_files(wt)
             if revision_id in (None, NULL_REVISION):
                 if branch.repository.supports_rich_root():
                     wt._set_root_id(generate_ids.gen_root_id())
@@ -1390,13 +1393,22 @@
             wt.unlock()
         return wt
 
+    def _init_custom_control_files(self, wt):
+        """Subclasses with custom control files should override this method.
+        
+        The working tree and control files are locked for writing when this
+        method is called.
+        
+        :param wt: the WorkingTree object
+        """
+
     def _open(self, a_bzrdir, control_files):
         """Open the tree itself.
 
         :param a_bzrdir: the dir for the tree.
         :param control_files: the control files for the tree.
         """
-        return WorkingTree4(a_bzrdir.root_transport.local_abspath('.'),
+        return self._tree_class(a_bzrdir.root_transport.local_abspath('.'),
                            branch=a_bzrdir.open_branch(),
                            _format=self,
                            _bzrdir=a_bzrdir,

=== modified file 'doc/developers/HACKING.txt'
--- doc/developers/HACKING.txt	2008-07-15 05:06:13 +0000
+++ doc/developers/HACKING.txt	2008-07-29 17:03:43 +0000
@@ -406,6 +406,17 @@
     subprocess you can use ``run_bzr_subprocess``. By default the spawned
     process will not load plugins unless ``--allow-plugins`` is supplied.
 
+When writing library functionality, it is often necessary to set up a
+branch with a certain history. Most current tests do this by inheriting
+from ``TestCaseWithTransport`` and using the ``make_branch_and_tree``
+helper to give them a ``WorkingTree`` that they can commit to. However,
+there is a newer api available from ``TestCaseWithMemoryTransport`` using
+the ``make_branch_builder`` helper. This helper is preferred, because it
+can build the changes in memory, rather than on disk. Tests that are
+explictly testing how we work with disk objects should, of course, use a
+real ``WorkingTree``. See ``bzrlib/branch_builder.py`` for how to use the
+class.
+
 
 Doctests
 --------
@@ -895,6 +906,29 @@
 associated information such as a help string or description.
 
 
+InterObject and multiple dispatch
+=================================
+
+The ``InterObject`` provides for two-way `multiple dispatch`__: matching
+up for example a source and destination repository to find the right way
+to transfer data between them. 
+
+.. __: http://en.wikipedia.org/wiki/Multiple_dispatch
+
+There is a subclass ``InterObject`` classes for each type of object that is
+dispatched this way, e.g. ``InterRepository``.  Calling ``.get()`` on this
+class will return an ``InterObject`` instance providing the best match for 
+those parameters, and this instance then has methods for operations
+between the objects.
+
+  inter = InterRepository.get(source_repo, target_repo)
+  inter.fetch(revision_id)
+
+``InterRepository`` also acts as a registry-like object for its
+subclasses, and they can be added through ``.register_optimizer``.  The
+right one to run is selected by asking each class, in reverse order of
+registration, whether it ``.is_compatible`` with the relevant objects.
+
 Lazy Imports
 ============
 

=== modified file 'tools/doc_generate/autodoc_rstx.py'
--- tools/doc_generate/autodoc_rstx.py	2007-12-17 04:45:41 +0000
+++ tools/doc_generate/autodoc_rstx.py	2008-07-19 15:00:27 +0000
@@ -127,7 +127,7 @@
 
 def _get_commands_section(registry, title="Commands", hdg_level1="#",
                           hdg_level2="="):
-    """Build the comands reference section of the manual."""
+    """Build the commands reference section of the manual."""
     lines = [title, hdg_level1 * len(title), ""]
     cmds = sorted(bzrlib.commands.builtin_command_names())
     for cmd_name in cmds:

